//*****************************************************************************
//*
//*
//*		CDiskDoc  Klasse
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#include  "StdAfx.h"
#include  "DiskViewer.h"
#include  "DiskView.h"
#include  "DiskDoc.h"
#include  "DiskIO.h"
#include  "DriveDlg.h"
#include  "AfxDialog.h"
#include  "SectionDlg.h"
#include  "ProgressDlg.h"
#include  "StartOptionDlg.h"
#include  "HexFind.h"


#ifdef		_DEBUG
#define new  DEBUG_NEW
#undef       THIS_FILE
static char  THIS_FILE[] = __FILE__;
#endif

#define 	FIND_SIZE	0x100000
#define 	FIND_SEC	(FIND_SIZE/512)

//*****************************************************************************
//*
//*		Nachrichten Verarbeitung
//*
//*****************************************************************************

IMPLEMENT_DYNCREATE(CDiskDoc, CDocument)
BEGIN_MESSAGE_MAP  (CDiskDoc, CDocument)
	//{{AFX_MSG_MAP(CDiskDoc)
	ON_COMMAND(ID_LOADIMAGE					,OnLoadImage)
	ON_COMMAND(ID_DRIVE_SELCET				,OnDriveSelect)
	ON_COMMAND(ID_SECTOR_GOTO				,OnSectorGoto)
	ON_COMMAND(ID_SECTOR_PLUS				,OnSectorNext)
	ON_COMMAND(ID_SECTOR_MINUS				,OnSectorBefore)
	ON_COMMAND(ID_GOTOCLUSTER				,OnGotoCluster)
	ON_COMMAND(ID_SAVESEC					,OnSaveSec)
	ON_COMMAND(ID_LOADSEC					,OnLoadSec)
	ON_COMMAND(ID_GOTO						,OnGoto)
	ON_COMMAND(ID_FINDINSEC					,OnFind)
	ON_COMMAND(ID_FINDINSECNEXT				,OnFindNext)
	ON_COMMAND(ID_STARTOPTIONS				,OnStartOptions)
	ON_COMMAND(ID_WRITEPROTECT				,OnWriteProtection)
	ON_COMMAND(ID_LOADPARTS					,OnPartitionLoad)
	ON_UPDATE_COMMAND_UI(ID_GOTO			,OnGotoOk)
	ON_UPDATE_COMMAND_UI(ID_FINDINSECNEXT   ,OnFindNextOk)
	ON_UPDATE_COMMAND_UI(ID_SECTOR_GOTO		,OnSectorGotoOk)
	ON_UPDATE_COMMAND_UI(ID_SECTOR_PLUS		,OnSectorNextOk)
	ON_UPDATE_COMMAND_UI(ID_SECTOR_MINUS	,OnSectorBeforeOk)
	ON_UPDATE_COMMAND_UI(ID_WRITEPROTECT	,OnWriteProtectionOk)
	ON_UPDATE_COMMAND_UI(ID_LOADPARTS		,OnPartitionLoadOk)
	ON_UPDATE_COMMAND_UI(ID_GOTOCLUSTER		,OnGotoClusterOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

LOAD_LAST(CDiskDoc,CDiskViewerApp);



//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CDiskDoc::CDiskDoc()
{
CRegKeys	sKey;



	memset(bSectorData  ,0xFF,sizeof(bSectorData  ));
	memset(dwClusterSize,0xFF,sizeof(dwClusterSize));
	memset(aSecName,0,sizeof(aSecName));		// Sektor Namen
	dwDrive			  = 0xFFFFFFFF;				// Laufwerks Nummer (0=A 1=B ...)
	dwDriveOld		  = 0xFFFFFFFF;				// Alte Laufwerks Nummer
	dwSectorSize	  = 0;						// Gre des Sektors
	dwSectorState	  = 1;						// Zustand 0=geladen 1=leer 2=Fehler
	qwSectorNumber	  = 0;						// Nummer des geladenen Sektors
	qwSectorCount	  = 0;						// Anzahl der Sektoren am Laufwerk
	dwDriveSectorSize = 0;						// Gre der Sektoren am Laufwerk
	dwDriveMul		  = 1;						// Gre der Sektoren in 512 Byte Blcken
	dwSecUnits		  = 0;						// Benutzte Sektoreinheiten
	bIsDriveOk		  = FALSE;					// Ist ein Laufwerk vorhanden
	bIsWriteable	  = FALSE;					// Kann der Sektor verndert werden.
	bIsDisk			  = TRUE;					// Ist es eine Festplatte
	dwClusterParts	  = 0;						// Anzahl der Partitionen
	dwPartitions	  = 0;						// Anzahl der Partitionen

   	iOpenMode		  = 0;						// 0=C: ffnen 1=D: ffnen 2=nichts ffnen 3=letzes ffnen
	iFindFlags		  = 0;						// Suchendaten
   	pFindSuchen		  = 0;
   	pFindGruppe		  = 0;
   	pFindErgebnis	  = 0;
   	qwFindStart		  = 0;						// Startsektor fr die Suche
   	qwFindCount		  = 0;						// Sektorenanzahl fr die Suche
   	qwFindSecPos	  = 0;						// Jetziger Sektor in dem gesucht wird
   	qwFindPos		  = 0;						// Jetzige Position im Sektor
	pFindData		  = 0;						// Daten mit geladen Sektoren
	qwFindDataSec	  = 0;						// Startsektor der Daten
	qwFindDataSize	  = 0;						// Anzahl der geladen Sektoren

	hEmulation		  = INVALID_HANDLE_VALUE;

	sKey.Open();
	sKey.Get(iOpenMode ,"OpenMode");


	switch(iOpenMode)
		{
	case 0:	dwDrive = 'C'-0x41;					// Laufwerk C:
			break;

	case 1:	dwDrive = 'D'-0x41;					// Laufwerk D:
			break;

	case 2:	dwDrive	= 0xFFFFFFFF;				// Nichts ffnen
			break;

	case 3:	sKey.Get(dwDrive,"LastDrive");		// Letztes Lauferk ffnen

			if(dwDrive==0xC000)
				{
				sKey.Get(sEmulation,"LastImageFile");

				if(ExistFile(sEmulation)!=1)
					{
					dwDrive	= 0xFFFFFFFF;
					}
				}

			break;
		}


   	sKey.Up("Find");
	sKey.Get(iFindFlags,"Flags");
   	sKey.GetMulti(&pFindSuchen,"FindText");
   	sKey.GetMulti(&pFindGruppe,"FindGroups");


	InitDocument();

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CDiskDoc::~CDiskDoc()
{
CRegKeys	sKey;


	sKey.Open();
	sKey.Set(iOpenMode ,"OpenMode");
	sKey.Set(dwDrive   ,"LastDrive");

	if(dwDrive==0xC000)
		{
		sKey.Set(sEmulation,"LastImageFile");
		}
	else{
		sKey.Set("","LastImageFile");
		}


   	sKey.Up("Find");
	sKey.Set(iFindFlags,"Flags");


	if(pFindSuchen)
		{
		sKey.SetMulti(pFindSuchen,"FindText");
		delete pFindSuchen;
		}

	if(pFindGruppe)
		{
		sKey.SetMulti(pFindGruppe,"FindGroups");
		delete pFindGruppe;
		}

	if(hEmulation!=INVALID_HANDLE_VALUE)
		{
		CloseHandle(hEmulation);
		hEmulation=INVALID_HANDLE_VALUE;
		}

	if(pFindErgebnis)delete pFindErgebnis;

	if(pFindData)delete pFindData;

}

//*****************************************************************************
//*
//*		OnNewDocument
//*
//*****************************************************************************
BOOL CDiskDoc::OnNewDocument()
{
char	cText[MAX_PATH];

	if(!CDocument::OnNewDocument())return FALSE;

	InitDocument();

	if(dwDrive<26)
		{
		sprintf(cText,"%c:\\ ",'A'+dwDrive);
		}
	else if(dwDrive==0xC000)
		{
		sprintf(cText,"%s ",GetFileName(sEmulation));
		}
	else if(dwDrive>=0x8000 && dwDrive<=0x80FF)
		{
		sprintf(cText,"Pysical_%u:\\ ",dwDrive&0xFF);
		}
	else{
		sprintf(cText,"Unbenannt");
		}


	SetTitle(cText);


return TRUE;
}

//*****************************************************************************
//*
//*		InitDocument
//*
//*****************************************************************************
void CDiskDoc::InitDocument()
{

	SetCursor(IDC_WAIT);

	qwFindDataSec	  = 0;						// Startsektor der Daten
	qwFindDataSize	  = 0;						// Anzahl der geladen Sektoren
   	qwFindStart		  = 0;						// Startsektor fr die Suche
   	qwFindCount		  = 0;						// Sektorenanzahl fr die Suche
   	qwFindSecPos	  = 0;						// Jetziger Sektor in dem gesucht wird
   	qwFindPos		  = 0;						// Jetzige Position im Sektor

	if(dwDrive!=0xFFFFFFFF && (dwDrive!=dwDriveOld || dwDrive==0xC000))
		{
		bIsDisk=TRUE;
		dwSecUnits=0;
		dwDriveOld=dwDrive;
		qwSectorCount=GetSectorCount(dwDrive,&dwDriveSectorSize);
		memset(aSecName,0,sizeof(aSecName));	// Sektor Namen

		dwDriveMul=dwDriveSectorSize/512;
		if(dwDriveMul<=0)dwDriveMul=1;
		if(dwDriveMul>sizeof(bSectorData)/512)dwDriveMul=sizeof(bSectorData)/512;

		if(dwDrive&0x8000)						// Physical Drive ?
			{
			if((qwSectorCount/2048)*dwDriveMul<1024)bIsDisk=FALSE;
			}
		else{
			char cPath[]="A:\\";
			cPath[0]+=(char)dwDrive;
			if(GetDriveType(cPath)==DRIVE_REMOVABLE)bIsDisk=FALSE;
			}
		}

	if(dwDrive==0xFFFFFFFF)
		{
		dwSectorState = 1;
		dwSectorSize  = 0;
		dwSecUnits    = 0;
		bIsDriveOk	  = FALSE;
		bIsDisk       = FALSE;
		}

	if(dwDrive==0xC000)							// Imagedatei
		{
		bIsDisk=FALSE;
		}

	ScanDrive();


	SortEntries();
	UpdateSector();

	SetCursor(IDC_ARROW);

}

//*****************************************************************************
//*
//*		SortEntries
//*
//*****************************************************************************
void CDiskDoc::SortEntries()
{
QWORD		qwOld;
DWORD		dwOld;
LPCTSTR		pOld;
unsigned	uPos;


	for(uPos=1;uPos<dwSecUnits;uPos++)			// Sortiere alle Eintrge
		{
		if(qwSecPos[uPos]>=qwSecPos[uPos-1])continue;

		qwOld = qwSecPos[uPos];	qwSecPos[uPos] = qwSecPos[uPos-1];	qwSecPos[uPos-1] = qwOld;
		qwOld = qwSecEnd[uPos];	qwSecEnd[uPos] = qwSecEnd[uPos-1];	qwSecEnd[uPos-1] = qwOld;
		dwOld = dwSecTyp[uPos];	dwSecTyp[uPos] = dwSecTyp[uPos-1];	dwSecTyp[uPos-1] = dwOld;
		pOld  = aSecName[uPos];	aSecName[uPos] = aSecName[uPos-1];	aSecName[uPos-1] = pOld;

		uPos = 0;
		}

}

//*****************************************************************************
//*
//*		MessageBox
//*
//*****************************************************************************
int	CDiskDoc::MessageBox( LPCTSTR lpszText, LPCTSTR lpszCaption, UINT nType)
{

	return AfxGetMainWnd()->MessageBox(lpszText,lpszCaption,nType);

}

//*****************************************************************************
//*
//*		UpdateSector
//*
//*****************************************************************************
//	Lies den Sektor auf den qwSectorNumber zeigt
//	dwPos/dwLen	: Ist dwLen ungleich Null, so wird ein Bereich mariert
//	Ergibt TRUE wenn der Sektor geladen wurde
BOOL CDiskDoc::UpdateSector(QWORD qwPos,DWORD dwLen)
{
int				i;
BOOL			bOk;
static	QWORD	qwCurrentSector=0xFFFFFFFFFFFFFFFF;



	if(bIsDriveOk || dwDrive==0xFFFFFFFF)
		{
		dwSectorState = 1;
		dwSectorSize  = 0;
		bIsDriveOk	  = FALSE;
		bIsWriteable  = FALSE;
		return FALSE;
		}

	if(dwLen && qwCurrentSector==qwSectorNumber)		// Nur markieren
		{
		UpdateAllViews(NULL,(DWORD)((dwLen&0xFF)|(qwPos<<8)|0x80000000));
		return TRUE;
		}

	if(bIsWriteable && memcmp(bSectorOld,bSectorData,dwSectorSize))
		{
		i=MessageBox("Der Sektor wurde verndert ?\nSoll ergeschrieben werden ?","Schreibschutz",MB_YESNO|MB_ICONWARNING|MB_DEFBUTTON2);
		if(i==IDYES && bIsDisk)
			{
			CTextDlg sDlg;

			sDlg.SetTitle("Sicherheits Abfrage");
			sDlg.SetTextTitle("Bitte OK eingeben bei Festplatten :");
			if(sDlg.DoModal()!=IDOK || stricmp(sDlg.GetText(),"OK"))
				{
				i=IDNO;
				}
			}
		if(i==IDYES)
			{
			SetCursor(IDC_WAIT);
			bOk=WriteSector(dwDrive,qwCurrentSector*(QWORD)dwDriveMul,dwDriveMul,bSectorData);
			SetCursor(IDC_ARROW);

			if(!bOk)
				{
				MessageBox("Der Sektor konnte nicht geschrieben werden!","Fehler",MB_OK|MB_ICONERROR);
				}
			}
		}

	SetCursor(IDC_WAIT);
	bOk=ReadSector(dwDrive,qwSectorNumber*(QWORD)dwDriveMul,dwDriveMul,bSectorData);

	if(bOk)
		{
		dwSectorState   = 0;
		dwSectorSize    = dwDriveSectorSize;
		qwCurrentSector	= qwSectorNumber;
		}
	else{
		dwSectorState = 2;
		dwSectorSize  = 0;
		}

	bIsWriteable  = FALSE;
	UpdateAllViews(NULL,(DWORD)((dwLen&0xFF)|(qwPos<<8)));
	SetCursor(IDC_ARROW);


return TRUE;
}


//*****************************************************************************
//*
//*		OnOpenDocument
//*
//*****************************************************************************
BOOL CDiskDoc::OnOpenDocument(LPCTSTR pPathName)
{
LPCTSTR		pName;
UINT		uDisk;
BOOL		bOk;



	pName = GetFileName(pPathName);
	uDisk = 0;
												// Ist es ein physikalische Laufwerk
	if(!strnicmp(pName,"Physical",8) && pName[8]!=0 && (pName[9]==0 || pName[10]==0))
		{
		if(strwchar(pName[8],0x01) || (strwchar(pName[9],0x01) && pName[10]==0))
			{
			uDisk	  = atoi(pPathName+8)|0x8000;
			pPathName = pName;
			}
		else if(strwchar(pName[8],0x06) && pName[9]==0)
			{
			uDisk     = GetDriveOfVolume((pName[8]&~0x20)-'A');
			if(uDisk)pPathName=pName;
			}
		}


	if(hEmulation!=INVALID_HANDLE_VALUE)		// Vorherige Image Datei schlieen
		{
		CloseHandle(hEmulation);
		hEmulation=INVALID_HANDLE_VALUE;
		}

												// Eine Image-Datei laden
	if(ExistFile(pPathName) && CmpFileType(pPathName,"bin;img;iso;fat"))
		{
		dwDrive		= 0xC000;
		sEmulation	= pPathName;
		bOk			= TRUE;
		}										// Logisches Laufwerk (z.B.: "D:\")
	else if(pPathName[1]==':' && (pPathName[2]==0 || pPathName[3]==0) && (pPathName[2]==0 || pPathName[2]=='\\' || pPathName[2]=='/'))
		{
		   dwDrive=pPathName[0];
		if(dwDrive>='a')dwDrive-='a';
		if(dwDrive>='A')dwDrive-='A';
		if(dwDrive>  26)dwDrive = 26;

		bOk = TRUE;
		}
	else if(uDisk)								// Physikalisches Laufwerk
		{
		dwDrive = uDisk;
		bOk     = TRUE;
		}
	else{
		bOk     = FALSE;
		}


	qwSectorNumber=0;
	InitDocument();


	if(bOk)
		{
		AfxGetApp()->AddToRecentFileList(pPathName);
		}



return bOk;
}

//*****************************************************************************
//*
//*		Serialize
//*
//*****************************************************************************
void CDiskDoc::Serialize(CArchive& ar)
{
CDiskView	    *pView;



	GET_VIEW(pView,CDiskView);					// Zeiger auf pView
	if(!pView)return;

	if (ar.IsStoring())
		{
		}
	else{										// Zeilenweise laden
		}

}


//*****************************************************************************
//*
//*		IsModified
//*
//*****************************************************************************
BOOL	CDiskDoc::IsModified( )
{
CDiskView   *pView;



	GET_VIEW(pView,CDiskView);					// Zeiger auf pView
	if(!pView)return FALSE;

return FALSE;
}

//*****************************************************************************
//*
//*		Debug Funktionen
//*
//*****************************************************************************
#ifdef _DEBUG
void  CDiskDoc ::AssertValid()         const
	{ CDocument::AssertValid();	}
void  CDiskDoc ::Dump(CDumpContext& dc) const
	{ CDocument::Dump(dc);}
#endif

//*****************************************************************************
//*
//*		OnSectorGoto
//*
//*****************************************************************************
//	Auf den nchsten Sektor springen
void CDiskDoc::OnSectorGotoOk(CCmdUI *pCmdUI){pCmdUI->Enable(qwSectorCount>0);}
void CDiskDoc::OnSectorGoto()
{
CDiskView  *pView;
CTextDlg	sDlg;
CString		sText,sValue;
QWORD		qwValue;
QWORD		qwNr;
__int64		iValue;


	qwNr = qwSectorNumber;

	GET_VIEW(pView,CDiskView);

	if(pView && pView->GetMark(&qwValue))
		{
		qwNr=qwValue;
		}


	sValue.Format("%I64u",qwNr);
	sText .Format("Maximaler Sektor %I64i (Sektorgre: %i)",(QWORD)(qwSectorCount-1),dwSectorSize);


	   sDlg.SetText(sValue);
	   sDlg.SetTextTitle(sText);
	   sDlg.SetTitle("Springe zu Sektor");
	if(sDlg.DoModal()!=IDOK)return;

	strcalc(sDlg.GetText(),&iValue);

	if((QWORD)iValue>=qwSectorCount)
		{
		MessageBox("Falsche Sektornummer !");
		return;
		}

	qwSectorNumber=iValue;
	UpdateSector();

}

//*****************************************************************************
//*
//*		OnGotoCluster
//*
//*****************************************************************************
//	Auf den nchsten Sektor springen
void CDiskDoc::OnGotoClusterOk(CCmdUI *pCmdUI){pCmdUI->Enable(dwClusterParts>0);}
void CDiskDoc::OnGotoCluster()
{
CDiskView  *pView;
CTextDlg	sDlg;
LPCTSTR		pText;
CString		sText;
CString		sValue;
QWORD		qwValue;
QWORD		qwNr;
DWORD		dwPart;
__int64		iValue;


	if(dwClusterParts==0)return;

	for(dwPart=dwClusterParts-1;dwPart>0;dwPart--)
		{
		if(qwSectorNumber>=qwClusterFrom[dwPart])
			{
			break;
			}
		}


	qwNr = (qwSectorNumber-qwClusterStart[dwPart])/dwClusterSize[dwPart]+qwClusterMin[dwPart];

	GET_VIEW(pView,CDiskView);

	if(pView && pView->GetMark(&qwValue))
		{
		qwNr = qwValue;
		}

	if(dwClusterSize[dwPart]==0xFFFFFFFF)
		{
		return;
		}

	if(qwSectorNumber<qwClusterStart[dwPart] || qwSectorNumber>qwClusterStart[dwPart]+dwClusterSize[dwPart]*qwClusters[dwPart])
		{
		qwNr = qwClusterMin[dwPart];
		}

	if(dwClusterParts>1)
		{
		sValue.Format("%u:%u",dwPart,qwNr);
		}
	else{
		sValue.Format("%u",qwNr);
		}

	sText .Format("Cluster %I64i bis %I64i (Cluster-Gre: %i)  (<Partition>:...)",qwClusterMin[dwPart],qwClusters[dwPart]+1,dwSectorSize*dwClusterSize[dwPart]);

	   sDlg.SetTextTitle(sText);
	   sDlg.SetText(sValue);
	   sDlg.SetTitle("Springe zu Cluster");
	if(sDlg.DoModal()!=IDOK)return;

	pText = sDlg.GetText();

	if(pText[0] && pText[1]==':')						// Ist die Parition im Text angegeben
		{
		dwPart = pText[0]-'0';
		pText += 2;

		if(dwPart>=dwClusterParts)
			{
			dwPart = 0;
			}
		}

	strcalc(pText,&iValue);

	if((QWORD)iValue+qwClusterMin[dwPart]>=qwClusters[dwPart] || iValue<(__int64)qwClusterMin[dwPart])
		{
		MessageBox("Falsche Cluster-Nummer !");
		return;
		}

	qwSectorNumber = qwClusterStart[dwPart]+(iValue-qwClusterMin[dwPart])*dwClusterSize[dwPart];

	UpdateSector();

}


//*****************************************************************************
//*
//*		OnSectorNext
//*
//*****************************************************************************
//	Auf den nchsten Sektor springen
void CDiskDoc::OnSectorNextOk(CCmdUI *pCmdUI){pCmdUI->Enable(qwSectorNumber+1<qwSectorCount);}
void CDiskDoc::OnSectorNext()
{

	if(qwSectorNumber+1>=qwSectorCount)return;
	qwSectorNumber++;
	UpdateSector();

}

//*****************************************************************************
//*
//*		OnSectorBefore
//*
//*****************************************************************************
//	Auf den vorherigen Sektor springen
void CDiskDoc::OnSectorBeforeOk(CCmdUI *pCmdUI){pCmdUI->Enable(qwSectorNumber!=0);}
void CDiskDoc::OnSectorBefore()
{

	if(qwSectorNumber==0)return;
	qwSectorNumber--;
	UpdateSector();

}


//*****************************************************************************
//*
//*		OnDriveSelect
//*
//*****************************************************************************
//	Ein anderses Laufwerk auswhlen
void CDiskDoc::OnDriveSelect()
{
CDriveDlg	sDlg;
CString		sPath;
CString		sText;
BOOL		bOk;



	sDlg.bAddImage = TRUE;

	   sDlg.dwDrive=dwDrive;
	if(sDlg.DoModal()!=IDOK)return;

	dwDrive=sDlg.dwDrive;
	qwSectorNumber=0;

	if(hEmulation!=INVALID_HANDLE_VALUE)
		{
		CloseHandle(hEmulation);
		hEmulation=INVALID_HANDLE_VALUE;
		}

	if(dwDrive==0xC000)							// Image Datei
		{
		CFileDialog sDlg(TRUE,".bin",sEmulation,OFN_EXPLORER|OFN_ENABLESIZING|OFN_HIDEREADONLY|OFN_PATHMUSTEXIST,"Alle Image-Formate |*.bin;*.iso;*.fat;*.img|CD-Image   (*.iso)|*.iso|Binrdatei   (*.bin)|*.bin|FAT-Image   (*.fat)|*.fat|Image-Datei   (*.img)|*.img|Alle Dateien|*.*|");

		if(sDlg.DoModal()==IDOK)
			{
			sEmulation=sDlg.GetPathName();
			dwDriveOld=0xFFFF;
			}

		SetTitle(GetFileName(sEmulation));
		sPath	= sEmulation;
		bOk		= TRUE;
		}
	else{
		if(dwDrive&0x8000)
			{
			sText.Format("Physical_%i :\\",dwDrive&~0x8000);
			sPath.Format("Physical%i"     ,dwDrive&~0x8000);
			}
		else{
			sText.Format("%c :\\",dwDrive+'A');
			sPath.Format("%c:\\" ,dwDrive+'A');
			}

		SetTitle(sText);
		bOk = TRUE;
		}


	InitDocument();


	if(bOk)
		{
		AfxGetApp()->AddToRecentFileList(sPath);
		}

}

//*****************************************************************************
//*
//*		OnLoadImage
//*
//*****************************************************************************
//	Ld eine Image-Datei
void CDiskDoc::OnLoadImage()
{


	if(hEmulation!=INVALID_HANDLE_VALUE)
		{
		CloseHandle(hEmulation);
		hEmulation=INVALID_HANDLE_VALUE;
		}

	CFileDialog sDlg(TRUE,".bin",sEmulation,OFN_EXPLORER|OFN_ENABLESIZING|OFN_HIDEREADONLY|OFN_PATHMUSTEXIST,"Alle Image-Formate |*.bin;*.iso;*.fat;*.img|CD-Image   (*.iso)|*.iso|Binrdatei   (*.bin)|*.bin|FAT-Image   (*.fat)|*.fat|Image-Datei   (*.img)|*.img|Alle Dateien|*.*|");

	if(sDlg.DoModal()!=IDOK)
		{
		return;
		}

	sEmulation		= sDlg.GetPathName();
	dwDriveOld		= 0xFFFF;
	dwDrive			= 0xC000;
	qwSectorNumber	= 0;

	InitDocument();
	SetTitle(GetFileName(sEmulation));
	AfxGetApp()->AddToRecentFileList(sEmulation);

}

//*****************************************************************************
//*
//*		GetSectorType
//*
//*****************************************************************************
//	Ergibt den Standard Type des Sektors
DWORD CDiskDoc::GetSectorType()
{
DWORD	i;

	for(i=0;i<dwSecUnits;i++)
		{
		if(qwSectorNumber<qwSecPos[i])continue;
		if(qwSectorNumber<qwSecEnd[i])return dwSecTyp[i];
		}


return 0;
}


//*****************************************************************************
//*
//*		GetMftData
//*
//*****************************************************************************
//	Einen MFT Block laden
//	Ergibt die Anzahl der kopierten Bytes
DWORD CDiskDoc::GetMftData(void *pData,void **pBase)
{
LPBYTE	pByte=(LPBYTE)pData;
BOOL	bFound=0;
QWORD	qwPos;
DWORD	i;


	*pBase = pData;

	if(dwSectorState)return 0;

	if(dwSectorSize>=1024)
		{
		memcpy(pData,bSectorData,1024);
		return 1024;
		}


	qwPos = qwSectorNumber&~1;

	if(qwSectorNumber&1)
		{
		pByte += dwSectorSize;
		}

	for(i=0;i<dwSecUnits;i++)						// Offset auf Type Beginn einrasten
		{
		if(qwSectorNumber<qwSecPos[i])continue;
		if(qwSectorNumber>qwSecEnd[i])continue;

		if(qwSecPos[i]&1)
			{
			if(qwSectorNumber&1)
				{qwPos++;pByte-=dwSectorSize;}
			else{qwPos--;pByte+=dwSectorSize;}
			}

		break;
		}

	*pBase = pByte;

	if(!ReadSector(dwDrive,qwPos,2,pData))return 0;



return 1024;
}


//*****************************************************************************
//*
//*		EcmaTagCrc
//*
//*****************************************************************************
BYTE CDiskDoc::EcmaTagCrc(void *pTagPtr)
{
LPBYTE		pTag=(LPBYTE)pTagPtr;
BYTE		bCrc;
int			iPos;


	bCrc = pTag[0];

	for(iPos=1;iPos< 4;iPos++)bCrc+=pTag[iPos];
	for(iPos=5;iPos<16;iPos++)bCrc+=pTag[iPos];


return bCrc;
}

//*****************************************************************************
//*
//*		EcmaName
//*
//*****************************************************************************
LPCSTR CDiskDoc::EcmaName(void *pTagPtr)
{
EcmaTag		   *pTag=(EcmaTag*)pTagPtr;


	switch(pTag->wTagIdentifier)
		{
	case 0x0001:	return "Emca-Primary Volume";
	case 0x0002:	return "Emca-Volume Desc.";
	case 0x0003:	return "Emca-Descriptor";
	case 0x0004:	return "Emca-Implementation Use.";
	case 0x0005:	return "Emca-Partition Desc.";
	case 0x0006:	return "Emca-Logical Volume";
	case 0x0007:	return "Emca-Unallocated Scace";
	case 0x0008:	return "Emca-Terminating Desc.";
	case 0x0009:	return "Emca-Logical Volume Int.";
	case 0x0100:	return "Emca-File Set";
	case 0x0101:	return "Emca-File Identifier";
	case 0x0102:	return "Emca-Allocation Extent";
	case 0x0103:	return "Emca-Indirect Entry";
	case 0x0104:	return "Emca-Terminal Entry";
	case 0x0105:	return "Emca-File Entry";
	case 0x0106:	return "Emca-Extended Attribute";
	case 0x0107:	return "Emca-Unallocated Space";
	case 0x0108:	return "Emca-Space Bitmap";
	case 0x0109:	return "Emca-Partition Integrity";
	case 0x010A:	return "Emca-Extended File";
		}


return "Emca-Tag";
}


//*****************************************************************************
//*
//*		ScanDrive
//*
//*****************************************************************************
//	Den Type eines Laufwerkes feststellen
BOOL CDiskDoc::ScanDrive()
{
char	cText[]="A:\\";


	dwSecUnits		  = 0;					// Benutzte Sektoreinheiten
	dwSerialNumber	  = 0;					// Volume Seriennummer
	dwFilenameLength  = 0;					// Lnge der Dateinamen
	dwFileSystemFlags = 0;					// Dateisystem Flags
	qwFATStart		  = 0;					// Startsektor der ersten FAT
	dwFATSize		  = 1;					// Gre einer FAT-Tabelle
	cVolume[0]		  = 0;					// Volume Name
	cSystem[0]		  = 0;					// Dateisystem
	dwClusterParts	  = 0;					// Anzahl der Cluster-Partitionen
	dwPartitions	  = 0;					// Anzahl der Partitionen


	if(dwDrive&0x8000)						// Physical Drive ?
		{
		return ScanMBR();
		}

	if(dwDrive>26)return FALSE;

	cText[0]+=(char)dwDrive;

	if(!GetVolumeInformation(cText,cVolume,sizeof(cVolume),&dwSerialNumber,&dwFilenameLength,&dwFileSystemFlags,cSystem,sizeof(cSystem)))
		{
		return FALSE;
		}

	if(!stricmp(cSystem,"FAT"  ))return ScanFAT();
	if(!stricmp(cSystem,"FAT32"))return ScanFAT();
	if(!stricmp(cSystem,"NTFS" ))return ScanNTFS();
	if(!stricmp(cSystem,"CDFS" ))return ScanCDFS();
	if(!stricmp(cSystem,"EXFAT"))return ScanExFAT();

	if(ScanEXT())return TRUE;



return FALSE;
}


//*****************************************************************************
//*
//*		ScanCDFS
//*
//*****************************************************************************
BOOL CDiskDoc::ScanCDFS(QWORD qwStart)
{
BOOL				bOk,bFirst,bUdf;
DWORD				dwNr,dwSize;
QWORD				qwPos;
VolumeDescriptor	sVd;



	bUdf	= FALSE;
	qwPos	= qwStart;

	if((dwDrive&0xC000) && dwDriveSectorSize!=2048)
		{
		qwSectorCount    /= 4;
		dwDriveMul        = 4;
		dwDriveSectorSize = 2048;
		}

	for(dwNr=0;dwNr<16;dwNr++)				// Durchlaufe Volume Deskriptoren
		{
			bOk=ReadSector(dwDrive,(qwPos+dwNr+16)*4,4,&sVd);
		if(!bOk || memcmp(sVd.cVSStdId,"CD001",5))break;

		if(sVd.bVDType==0xFF)
			{
			dwNr++;
			break;
			}

		if(sVd.bVDType>=1 && sVd.bVDType<=2)
			{
			if(dwSecUnits<UNITS_MAX && sVd.dwLsbPathTable1>0)
				{
				dwSize=(sVd.dwLsbPathTableSize+2047)/2048;
				qwSecPos[dwSecUnits]=sVd.dwLsbPathTable1;
				qwSecEnd[dwSecUnits]=qwSecPos[dwSecUnits]+dwSize*2;
				dwSecTyp[dwSecUnits]=TYPE_PTABLE;
				dwSecUnits++;
				}

			if(dwSecUnits<UNITS_MAX && sVd.dwLsbPathTable2>0)
				{
				dwSize=(sVd.dwLsbPathTableSize+2047)/2048;
				qwSecPos[dwSecUnits]=sVd.dwLsbPathTable2;
				qwSecEnd[dwSecUnits]=qwSecPos[dwSecUnits]+dwSize*2;
				dwSecTyp[dwSecUnits]=TYPE_PTABLE;
				dwSecUnits++;
				}

			if(dwSecUnits<UNITS_MAX)
				{
				dwSize=(sVd.sRootDirectory.dwLsbFileLength+2047)/2048;
				qwSecPos[dwSecUnits]=sVd.sRootDirectory.dwLsbSector;
				qwSecEnd[dwSecUnits]=qwSecPos[dwSecUnits]+dwSize;
				dwSecTyp[dwSecUnits]=TYPE_CDDIR;
				dwSecUnits++;
				}
			}
		}

	for(bFirst=1;dwNr<16;dwNr++)				// Durchlaufe Volume Deskriptoren fr UDF
		{
			bOk=ReadSector(dwDrive,(qwPos+dwNr+16)*4,4,&sVd);
		if(!bOk || sVd.bVDType!=0 || sVd.bVSStdVersion!=1)break;
		if(sVd.cVSStdId[0]<'A' || sVd.cVSStdId[0]>'Z')break;
		if(strnlen(sVd.cVSStdId,5)!=5)break;

		if(bFirst)
			{
			if(memcmp(sVd.cVSStdId,"BEA01",5))break;
			bFirst=0;
			}


		if(!memcmp(sVd.cVSStdId,"TEA01",5))break;
		if(!memcmp(sVd.cVSStdId,"NSR"  ,3))bUdf=1;
		}

	if(dwSecUnits<UNITS_MAX)
		{
		qwSecPos[dwSecUnits]=qwPos+16;
		qwSecEnd[dwSecUnits]=qwPos+16+dwNr;
		dwSecTyp[dwSecUnits]=TYPE_VDESC;
		dwSecUnits++;
		}

	if(bUdf)ScanUDF(qwStart);




return (dwNr)? TRUE:FALSE;
}

//*****************************************************************************
//*
//*		ScanUDF
//*
//*****************************************************************************
BOOL CDiskDoc::ScanUDF(QWORD qwStart)
{
#define 				MAX_LIST 128
BYTE					bBuffer[2048];
DWORD					aList[MAX_LIST];
DWORD					aScan[MAX_LIST];
unsigned				uCount;
unsigned				uRead;
unsigned				uPos;
unsigned				uAdd;
unsigned				uLen;
unsigned				uOff;
BOOL					bOk;
EcmaTag				   *pTag;
EcmaFileSetDesc		   *pSet;
EcmaPartitionDesc	   *pPar;
EcmaPrimVolumeDesc	   *pPri;
EcmaAnchorVolumeDesc   *pAnc;



	if((dwDrive==0xC000) && dwDriveSectorSize!=2048)
		{
		qwSectorCount    /= 4;
		dwDriveMul        = 4;
		dwDriveSectorSize = 2048;
		}


	aList[0] = 256;
	aScan[0] = 0;
	uCount	 = 1;
	uAdd	 = 0;


	for(uRead=0;uRead<uCount;)
		{
		for(uPos=0;uPos<dwSecUnits;uPos++)
			{
			if(aList[uRead]+qwStart/4==qwSecPos[uPos])
				{
				uRead++;
				uAdd=0;
				break;
				}
			}

		if(uPos<dwSecUnits)continue;


			bOk=ReadSector(dwDrive,aList[uRead]*4+qwStart,4,bBuffer);
		if(!bOk)break;

		pTag = (EcmaTag*)bBuffer;

		if(pTag->wTagIdentifier==0)
			{
			uRead++;
			uAdd=0;
			continue;
			}

		if(EcmaTagCrc(pTag)!=pTag->bChecksum)
			{
			uRead++;
			continue;
			}

		if(dwSecUnits<UNITS_MAX)
			{
			qwSecPos[dwSecUnits]=aList[uRead]+qwStart/4;
			qwSecEnd[dwSecUnits]=aList[uRead]+qwStart/4+1;
			dwSecTyp[dwSecUnits]=TYPE_ECMA;
			aSecName[dwSecUnits]=EcmaName(pTag);
			dwSecUnits++;
			}

		if(pTag->wTagIdentifier==0x0001)
			{
			pPri	= (EcmaPrimVolumeDesc*)bBuffer;

			if(pPri->dwVolumeAbstractLoc && uCount<=MAX_LIST)
				{
				aList[uCount]=pAnc->dwMainVolumeDescLoc;
				aScan[uCount]=0;
				uCount++;
				}

			if(pPri->dwVolumeCopyrightLoc && uCount<=MAX_LIST)
				{
				aList[uCount]=pPri->dwVolumeCopyrightLoc;
				aScan[uCount]=0;
				uCount++;
				}
			}

		if(pTag->wTagIdentifier==0x0002)
			{
			pAnc	= (EcmaAnchorVolumeDesc*)bBuffer;

			if(uCount<=MAX_LIST)
				{
				aList[uCount]=pAnc->dwMainVolumeDescLoc;
				aScan[uCount]=32;
				uCount++;
				}

			if(uCount<=MAX_LIST)
				{
				aList[uCount]=pAnc->dwReserveVolumeDescLoc;
				aScan[uCount]=32;
				uCount++;
				}
			}

		if(pTag->wTagIdentifier==0x0005)
			{
			pPar	= (EcmaPartitionDesc*)bBuffer;

			if(pPar->dwPartitionLoc && uCount<=MAX_LIST)
				{
				aList[uCount]=pPar->dwPartitionLoc;
				aScan[uCount]=32;
				uCount++;

				if(dwClusterParts<PARTS_MAX)
					{
					qwClusters    [dwClusterParts]	= pPar->dwPartitionLen;
					qwClusterStart[dwClusterParts]	= pPar->dwPartitionLoc;
					qwClusterFrom [dwClusterParts]	= pPar->dwPartitionLoc;
					dwClusterSize [dwClusterParts]	= 1;
					qwClusterMin  [dwClusterParts]	= 0;

					dwClusterParts++;
					}
				}
			}

		if(pTag->wTagIdentifier==0x0100)
			{
			pSet	= (EcmaFileSetDesc*)bBuffer;
			uLen    = *(DWORD*)(pSet->aRootDirectoryIcb+0);
			uOff    = *(DWORD*)(pSet->aRootDirectoryIcb+4);

			if(uOff && uLen)
				{
				qwSecPos[dwSecUnits]=aList[uRead]-uAdd+uOff+qwStart/4;
				qwSecEnd[dwSecUnits]=aList[uRead]-uAdd+uOff+qwStart/4+(uLen+2047)/2048;
				dwSecTyp[dwSecUnits]=TYPE_ECMA;
				aSecName[dwSecUnits]="Root-Verzeichnis";
				dwSecUnits++;
				}
			}


		if(pTag->wTagIdentifier==0x0008)					// Ende Markierung
			{
			aScan[uRead]=0;
			}

		if(aScan[uRead]==0)
			{
			uRead++;
			uAdd=0;
			continue;
			}

		aScan[uRead]--;
		aList[uRead]++;
		uAdd++;
		}




return (uRead>0)? TRUE:FALSE;
}

//*****************************************************************************
//*
//*		ScanNTFS
//*
//*****************************************************************************
BOOL CDiskDoc::ScanNTFS(QWORD qwStart)
{
BOOL				 bOk;
BYTE				 bData[1024];
DWORD				 dwOffset,dwSize;
QWORD				 qwBegin;
QWORD				 qwPos;
BootRecordNtfs		*pBootNtfs;
int					 i;


	qwPos = qwStart;

		bOk=ReadSector(dwDrive,qwPos,1,bData);
	if(!bOk)return FALSE;

	pBootNtfs=(BootRecordNtfs*)bData;

 	do	{											// Suche Boot-Sektor
		if(pBootNtfs->wSignature==0xAA55)
			{
			if(!memcmp(pBootNtfs->cOEMName,"EXFAT   ",8))
				{
				return ScanExFAT(qwStart);
				}

			qwBegin = qwPos;
			dwSize  = pBootNtfs->bSectorsPerCluster;

			if(dwSecUnits<UNITS_MAX)
				{
				qwSecPos[dwSecUnits]=qwPos;
				qwSecEnd[dwSecUnits]=qwPos+1;
				dwSecTyp[dwSecUnits]=TYPE_BOOTNTFS;
				dwSecUnits++;
				}

			if(dwClusterParts<PARTS_MAX)			// Knnen die Cluster eingefgt werden
				{
				qwClusterFrom [dwClusterParts] = qwStart;
				qwClusterStart[dwClusterParts] = qwBegin;
				dwClusterSize [dwClusterParts] = dwSize;

				if(dwClusterSize[dwClusterParts]==0)
					{
					dwClusterSize[dwClusterParts] = 1;
					}

				qwClusters  [dwClusterParts]   = pBootNtfs->qwTotalSectors;
				qwClusters  [dwClusterParts]  /= dwClusterSize[dwClusterParts];
				qwClusterMin[dwClusterParts]   = 0;

				dwClusterParts++;
				}

			break;
			}

		qwPos++;
		if(qwPos>1024)return FALSE;

		bOk=ReadSector(dwDrive,qwPos,1,bData);

		}while(bOk);


//******************** Scannen MFT ********************************************
NtfsMftEntry	   *pMftEntry;
NtfsAttribut	   *pAttribut;
NtfsAttributFile   *pFile;
NtfsAttributData   *pData;
BYTE			   *pByte;
DWORD				dwLen;
DWORD				dwNum,dwCluster[8],dwCount[8];
char				cName[256];



	qwPos = (DWORD)pBootNtfs->qwMtfCluster*dwSize+qwBegin;


	for(i=0;i<16;i++,qwPos+=2)
		{
			bOk=ReadSector(dwDrive,qwPos,2,bData);
		if(!bOk)break;

		pMftEntry=(NtfsMftEntry*)bData;
		if(memcmp(pMftEntry->cId,"FILE",4))continue;
		dwOffset = pMftEntry->wAttributOffset;
		cName[0] = 0;
		dwNum	 = 0;

		if(dwOffset>1024-sizeof(NtfsAttribut))continue;
		pAttribut=(NtfsAttribut*)(bData+dwOffset);

		for(;;dwOffset+=pAttribut->dwLength)
			{
			if(dwOffset>1024-sizeof(NtfsAttribut))break;
			if(pAttribut->dwLength<sizeof(NtfsAttribut)-2)break;
			   pAttribut=(NtfsAttribut*)(bData+dwOffset);
			if(pAttribut->dwType==0xFFFFFFFF     )break;
			if(pAttribut->dwLength+dwOffset>=1024)break;

			if(pAttribut->dwType==0x30)
				{
				pFile=(NtfsAttributFile*)(bData+dwOffset+pAttribut->wDataOffest);
				WideCharToMultiByte(CP_ACP,0,pFile->wName,pFile->bNameLength,cName,sizeof(cName),NULL,NULL);
				cName[pFile->bNameLength]=0;
				}

			if(pAttribut->dwType==0x80)
				{
				pData=(NtfsAttributData*)(pAttribut);
				pByte=(bData+dwOffset+pData->wOffset);
				dwLen=(DWORD)(pData->qwEndCluster-pData->qwStartCluster+1);
				dwNum=DecodeClusterData(dwLen,pByte,dwCluster,dwCount,8);
				}
			}

		if(dwSecUnits<UNITS_MAX && dwNum>0 && !stricmp(cName,"$MFT"))
			{
			qwSecPos[dwSecUnits]=qwBegin             +dwSize*dwCluster[0];
			qwSecEnd[dwSecUnits]=qwSecPos[dwSecUnits]+dwSize*dwCount  [0];
			dwSecTyp[dwSecUnits]=TYPE_MFT;
			dwSecUnits++;
			}

		if(dwSecUnits<UNITS_MAX && dwNum>0 && !stricmp(cName,"$MFTMirr"))
			{
			qwSecPos[dwSecUnits]=qwStart             +dwSize*dwCluster[0];
			qwSecEnd[dwSecUnits]=qwSecPos[dwSecUnits]+dwSize*dwCount  [0];
			dwSecTyp[dwSecUnits]=TYPE_MFTMIR;
			dwSecUnits++;
			}
		}


return TRUE;
}

//*****************************************************************************
//*
//*		ScanFAT
//*
//*****************************************************************************
BOOL CDiskDoc::ScanFAT(QWORD qwStart)
{
BOOL				 bOk;
BYTE				 bData[512];
QWORD				 qwPos;
QWORD				 qwFrom;
DWORD				 dwSize;
DWORD				 dwCount;
DWORD				 dwFatSec;
DWORD				 dwDirs;
BootRecord16		*pBoot16;
BootRecord32		*pBoot32;



	qwPos  = qwStart;
	qwFrom = qwStart;

		bOk=ReadSector(dwDrive,qwPos,1,bData);
	if(!bOk)return FALSE;

	pBoot16=(BootRecord16*)bData;
	pBoot32=(BootRecord32*)bData;

	if(!memcmp(pBoot32->cOEMName,"EXFAT   ",8))
		{
		return ScanExFAT(qwStart);
		}

 	do	{											// Suche Boot-Sektor
		if(pBoot32->wSignature    ==0xAA55)
		if(pBoot32->wDirEntries   ==0x0000)
		if(pBoot32->wSectorsPerFAT==0x0000)
			{
			if(dwSecUnits<UNITS_MAX)
				{
				qwSecPos[dwSecUnits]=qwPos;
				qwSecEnd[dwSecUnits]=qwPos+1;
				dwSecTyp[dwSecUnits]=TYPE_BOOT32;
				dwSecUnits++;
				}

			if(dwSecUnits<UNITS_MAX)				// Backup Bootsektor
			if(pBoot32->wBackupBootSector!=0x0000)
			if(pBoot32->wBackupBootSector!=0xFFFF)
				{
				qwSecPos[dwSecUnits]=qwPos+pBoot32->wBackupBootSector;
				qwSecEnd[dwSecUnits]=qwPos+pBoot32->wBackupBootSector+1;
				dwSecTyp[dwSecUnits]=TYPE_BOOT32;
				dwSecUnits++;
				}

			if(dwSecUnits<UNITS_MAX)				// Info Sektor
			if(pBoot32->wFSInfoSector!=0x0000)
			if(pBoot32->wFSInfoSector!=0xFFFF)
				{
				qwSecPos[dwSecUnits]=qwPos+pBoot32->wFSInfoSector;
				qwSecEnd[dwSecUnits]=qwPos+pBoot32->wFSInfoSector+1;
				dwSecTyp[dwSecUnits]=TYPE_INFO;
				dwSecUnits++;
				}

			if(!pBoot32->bSectorsPerCluster)pBoot32->bSectorsPerCluster=1;

													// Berechne FAT
			qwPos     += pBoot32->wReservedSectors;
			dwFatSec   = pBoot32->bNumberOfFATs *pBoot32->dwSectorsPerFAT;
			dwCount    =(pBoot16->wSectorsOnDisk)? pBoot16->wSectorsOnDisk:pBoot32->dwTotalSectors;
			dwCount   -= pBoot16->wReservedSectors+dwFatSec;
			dwCount   /= pBoot32->bSectorsPerCluster;

			if(dwFatSec<=0 || (dwFatSec&0xFFF00000))return FALSE;
			if(dwCount <=0 || (dwCount &0xF0000000))return FALSE;

			qwFATStart = qwPos;
			dwFATSize  = pBoot32->dwSectorsPerFAT;

			if(dwSecUnits<UNITS_MAX)				// FAT Sektoren
				{
				qwSecPos[dwSecUnits]=qwPos;
				qwSecEnd[dwSecUnits]=qwPos+dwFatSec;

				     if(dwCount<0x0FF5)dwSecTyp[dwSecUnits]=TYPE_FAT12;
				else if(dwCount<0xFFF5)dwSecTyp[dwSecUnits]=TYPE_FAT16;
				else 		   		   dwSecTyp[dwSecUnits]=TYPE_FAT32;

				dwSecUnits++;
				}

			qwPos   += dwFatSec;
			qwStart  = qwPos;
			dwSize   = pBoot32->bSectorsPerCluster;

			if(dwSecUnits<UNITS_MAX)				// Root Verzeichnis
			if(pBoot32->dwRootDirCluster>=2)
				{
				qwSecPos[dwSecUnits]=qwStart+(pBoot32->dwRootDirCluster-2)*dwSize;
				qwSecEnd[dwSecUnits]=qwSecPos[dwSecUnits]+dwSize;
				dwSecTyp[dwSecUnits]=TYPE_DIR;
				dwSecUnits++;
				}

			if(dwClusterParts<PARTS_MAX)			// Knnen die Cluster eingefgt werden
				{
				qwClusterFrom [dwClusterParts] = qwFrom;
				qwClusterStart[dwClusterParts] = qwStart;
				dwClusterSize [dwClusterParts] = dwSize;
				qwClusters    [dwClusterParts] = dwCount;
				qwClusterMin  [dwClusterParts] = 2;

				dwClusterParts++;
				}

			return TRUE;
			}

		if(pBoot16->wSignature==0xAA55)				// Boot Sektor
			{
			if(dwSecUnits<UNITS_MAX)
				{
				qwSecPos[dwSecUnits]=qwPos;
				qwSecEnd[dwSecUnits]=qwPos+1;
				dwSecTyp[dwSecUnits]=TYPE_BOOT;
				dwSecUnits++;
				}

			if(!pBoot16->bSectorsPerCluster)pBoot16->bSectorsPerCluster=1;

													// Berechne FAT
			qwPos     += pBoot16->wReservedSectors;
			dwFatSec   = pBoot16->bNumberOfFATs *pBoot16->wSectorsPerFAT;
			dwCount    =(pBoot16->wSectorsOnDisk)? pBoot16->wSectorsOnDisk:pBoot32->dwTotalSectors;
			dwCount   -= pBoot16->wReservedSectors+dwFatSec;
			dwCount   -=(pBoot16->wDirEntries*32+pBoot16->wBytesPerSector-1)/pBoot16->wBytesPerSector;
			dwCount   /= pBoot16->bSectorsPerCluster;

			if(dwFatSec<=0 || (dwFatSec&0xFFFF0000))return FALSE;
			if(dwCount <=0 || (dwCount &0xFFFF0000))return FALSE;

			qwFATStart = qwPos;
			dwFATSize  = pBoot16->wSectorsPerFAT;

			if(dwSecUnits<UNITS_MAX)				// FAT Sektoren
				{
				qwSecPos[dwSecUnits]=qwPos;
				qwSecEnd[dwSecUnits]=qwPos+dwFatSec;

				     if(dwCount<0x0FF5)dwSecTyp[dwSecUnits]=TYPE_FAT12;
				else if(dwCount<0xFFF5)dwSecTyp[dwSecUnits]=TYPE_FAT16;
				else 	               dwSecTyp[dwSecUnits]=TYPE_FAT32;

				dwSecUnits++;
				}

			qwPos+=dwFatSec;
			dwDirs=(pBoot16->wDirEntries*32+pBoot16->wBytesPerSector-1)/pBoot16->wBytesPerSector;

			if(dwSecUnits<UNITS_MAX)				// Verzeichnis Sektoren
				{
				qwSecPos[dwSecUnits]=qwPos;
				qwSecEnd[dwSecUnits]=qwPos+dwDirs;
				dwSecTyp[dwSecUnits]=TYPE_DIR;
				dwSecUnits++;
				}

			qwPos+=dwDirs;

			if(dwClusterParts<PARTS_MAX)			// Knnen die Cluster eingefgt werden
				{
				qwClusterFrom [dwClusterParts] = qwFrom;
				qwClusterStart[dwClusterParts] = qwPos;
				dwClusterSize [dwClusterParts] = pBoot16->bSectorsPerCluster;
				qwClusters    [dwClusterParts] = dwCount;
				qwClusterMin  [dwClusterParts] = 2;

				dwClusterParts++;
				}

			return TRUE;
			}


		qwPos++;
		if(qwPos>1024)return FALSE;

		bOk=ReadSector(dwDrive,qwPos,1,bData);

		}while(bOk);



return FALSE;
}

//*****************************************************************************
//*
//*		ScanExFAT
//*
//*****************************************************************************
BOOL CDiskDoc::ScanExFAT(QWORD qwStart)
{
BootRecordExFat		*pBoot;
BYTE				 bData[512];
DWORD				 dwBytePerSec;
DWORD				 dwSecPerCl;
QWORD				 qwFrom;
QWORD				 qwBase;
QWORD				 qwPos;
BOOL				 bOk;



	qwPos  = qwStart;
	qwFrom = qwStart;

		bOk=ReadSector(dwDrive,qwPos,1,bData);
	if(!bOk)return FALSE;

	pBoot = (BootRecordExFat*)bData;

	if(pBoot->wSignature!=0xAA55)return FALSE;
	if(memcmp(pBoot->cOEMName,"EXFAT   ",8))return FALSE;


	if(dwSecUnits<UNITS_MAX)						// Bootsektor
		{
		qwSecPos[dwSecUnits]=qwPos;
		qwSecEnd[dwSecUnits]=qwPos+1;
		dwSecTyp[dwSecUnits]=TYPE_BOOTEXFAT;
		dwSecUnits++;
		}

	if(dwSecUnits<UNITS_MAX)						// Backup Bootsektor
	if(pBoot->wBackupBootSector!=0x0000)
	if(pBoot->wBackupBootSector!=0xFFFF)
		{
		qwSecPos[dwSecUnits]=qwPos+pBoot->wBackupBootSector;
		qwSecEnd[dwSecUnits]=qwPos+pBoot->wBackupBootSector+1;
		dwSecTyp[dwSecUnits]=TYPE_BOOTEXFAT;
		dwSecUnits++;
		}

	if(dwSecUnits<UNITS_MAX)						// Info Sektor
	if(pBoot->wFSInfoSector!=0x0000)
	if(pBoot->wFSInfoSector!=0xFFFF)
		{
		qwSecPos[dwSecUnits]=qwPos+pBoot->wFSInfoSector;
		qwSecEnd[dwSecUnits]=qwPos+pBoot->wFSInfoSector+1;
		dwSecTyp[dwSecUnits]=TYPE_INFO;
		dwSecUnits++;
		}

	if(dwSecUnits<UNITS_MAX)						// FAT Sektoren
	if(pBoot->dwFatSectorStart!=0x00000000)
	if(pBoot->dwFatSectorCount!=0x00000000)
	if(pBoot->dwFatSectorCount!=0xFFFFFFFF)
		{
		qwSecPos[dwSecUnits]=qwPos+pBoot->dwFatSectorStart;
		qwSecEnd[dwSecUnits]=qwPos+pBoot->dwFatSectorStart+pBoot->dwFatSectorCount;
		dwSecTyp[dwSecUnits]=TYPE_FATEX;
		dwSecUnits++;
		}

	dwBytePerSec	= 1<<pBoot->bSectorBits;
	dwSecPerCl		= dwBytePerSec<<pBoot->bSpcBits;
	dwSecPerCl	   /= 512;

	if(dwClusterParts<PARTS_MAX)					// Knnen die Cluster eingefgt werden
		{
		qwClusterFrom [dwClusterParts] = qwFrom;
		qwClusterStart[dwClusterParts] = qwPos+pBoot->dwClusterSectorStart;
		dwClusterSize [dwClusterParts] = dwSecPerCl;
		qwClusters    [dwClusterParts] = pBoot->dwClusterCount;
		qwClusterMin  [dwClusterParts] = 2;

		dwClusterParts++;
		}

	if(dwSecUnits<UNITS_MAX)						// Root-Verzeichnis
	if(pBoot->dwRootDirCluster>=0x00000002)
	if(pBoot->dwRootDirCluster!=0xFFFFFFFF)
		{
		qwBase	= (pBoot->dwRootDirCluster-2)*dwSecPerCl;
		qwBase +=  pBoot->dwClusterSectorStart;

		qwSecPos[dwSecUnits]=qwPos+qwBase;
		qwSecEnd[dwSecUnits]=qwPos+qwBase+dwSecPerCl;
		dwSecTyp[dwSecUnits]=TYPE_EXFATDIR;
		dwSecUnits++;
		}



return TRUE;
}

//*****************************************************************************
//*
//*		ScanExt
//*
//*****************************************************************************
BOOL CDiskDoc::ScanEXT(QWORD qwStart)
{
BYTE			aData[1024];
ExtSuperBlock  *pSuper;
QWORD			qwBlocks;
DWORD			dwSize;
QWORD			qwPos;
BOOL			bOk;



	qwPos  = qwStart;

		bOk=ReadSector(dwDrive,qwPos+2,2,aData);
	if(!bOk)return FALSE;							// Wurde Super-Block geladen

	   pSuper = (ExtSuperBlock*)aData;
	if(pSuper->wMagic!=0xEF53)return FALSE;


	if(dwSecUnits<UNITS_MAX)						// Root-Verzeichnis
		{
		qwSecPos[dwSecUnits]=qwPos+2;
		qwSecEnd[dwSecUnits]=qwPos+4;
		dwSecTyp[dwSecUnits]=TYPE_SUPERBLK;
		dwSecUnits++;
		}

	if(dwClusterParts<PARTS_MAX)					// Knnen die Cluster eingefgt werden
		{
		dwSize		= 2<<pSuper->dwLogBlockSize;
		qwBlocks	= pSuper->dwBlocksCountHi;
		qwBlocks  <<= 32;
		qwBlocks   |= pSuper->dwBlocksCountLo;
		qwBlocks   /= dwSize;

		qwClusterFrom [dwClusterParts] = qwPos;
		qwClusterStart[dwClusterParts] = qwPos+dwSize;
		dwClusterSize [dwClusterParts] = dwSize;
		qwClusters    [dwClusterParts] = qwBlocks*dwSize-1;
		qwClusterMin  [dwClusterParts] = 1;

		dwClusterParts++;
		}


return TRUE;
}

//*****************************************************************************
//*
//*		ScanMBR
//*
//*****************************************************************************
BOOL CDiskDoc::ScanMBR(QWORD qwStart)
{
BYTE				aData[2048];
BootRecord16	   *pBoot;
BootRecord32	   *pBt32;
BootRecordNtfs	   *pNtfs;
MasterBootRecord	sMbr;
GuidPartitionTable	sGuid;
GuidPartitionEntry	aList[4];
QWORD				qwPos;
DWORD				dwCount;
DWORD				dwNumber;
DWORD				dwOffset;
DWORD				dwNext[32];
DWORD				dwTemp[32];
int					i,j,iNum=1;


	qwPos = qwStart;

	if(!(dwDrive&0x8000))return FALSE;

	dwNext[0] = 0;
	dwTemp[0] = 0;

	if(!qwStart)							// Prfe ob Boot-Sektor statt MBR
		{
		if(!ReadSector(dwDrive,0,1,&sMbr))
			{
			return FALSE;
			}

		pBoot = (BootRecord16  *)&sMbr;
		pBt32 = (BootRecord32  *)&sMbr;
		pNtfs = (BootRecordNtfs*)&sMbr;

		if(pBoot->wSignature==0xAA55)
			{
			if(!memcmp(pBoot->cSystemID,"FAT"     ,3))return ScanFAT();
			if(!memcmp(pBt32->cSystemID,"FAT"     ,3))return ScanFAT();
			if(!memcmp(pNtfs->cOEMName ,"NTFS    ",8))return ScanNTFS();
			}

		if(ReadSector(dwDrive,64,1,aData))
			{
			if(!memcmp(aData,"\001CD001",6) || !memcmp(aData,"\000BEA01",6))
				{
				return ScanCDFS();
				}
			}

		if(ReadSector(dwDrive,2,2,aData))	// Superblock von Ext2..4 laden
			{
			if(*(LPWORD)(aData+0x38)==0xEF53)
				{
				return ScanEXT();
				}
			}
		}


//******************** Untersuche MBR *****************************************


	for(j=0;j<iNum && j<32;j++)
		{
		qwPos=dwNext[j]+qwStart;

		if(!ReadSector(dwDrive,qwPos,1,&sMbr))
			{
			return FALSE;
			}

		if(sMbr.wSignature!=0xAA55)
			{
			if(dwTemp[j]==0        )continue;
			if(dwTemp[j]==dwNext[j])continue;
			dwNext[j] = dwTemp[j];
			dwTemp[j] = 0;
			j--;
			continue;
			}


		if(dwSecUnits<UNITS_MAX)				// FAT Sektoren
			{
			qwSecPos[dwSecUnits]=qwPos;
			qwSecEnd[dwSecUnits]=qwPos+1;
			dwSecTyp[dwSecUnits]=TYPE_MBR;
			dwSecUnits++;
			}

		if(dwSecUnits>=UNITS_MAX)break;

		for(i=0;i<4;i++)						// Scanne Tabelleneintrge
			{
			if(!sMbr.sTable[i].dwRelativeSector)continue;
			if(!sMbr.sTable[i].dwSectors       )continue;


			if(dwPartitions<PARTS_MAX)			// Start der Partition eintragen
				{
				qwPartitionBase[dwPartitions] = sMbr.sTable[i].dwRelativeSector+qwPos;
				dwPartitions++;
				}


			if(sMbr.sTable[i].bOSType==0x07 || // NTFS Partitionen
			   sMbr.sTable[i].bOSType==0x17)
				{
				ScanNTFS(sMbr.sTable[i].dwRelativeSector+qwPos);
				continue;
				}

			if(sMbr.sTable[i].bOSType==0x01 ||	// FAT Partitionen
			   sMbr.sTable[i].bOSType==0x04 ||
			   sMbr.sTable[i].bOSType==0x06 ||
			   sMbr.sTable[i].bOSType==0x0B ||
			   sMbr.sTable[i].bOSType==0x0C ||
			   sMbr.sTable[i].bOSType==0x0E ||
			   sMbr.sTable[i].bOSType==0x11 ||
			   sMbr.sTable[i].bOSType==0x14 ||
			   sMbr.sTable[i].bOSType==0x16 ||
			   sMbr.sTable[i].bOSType==0x1B ||
			   sMbr.sTable[i].bOSType==0x1C ||
			   sMbr.sTable[i].bOSType==0x1E)
				{
				ScanFAT(sMbr.sTable[i].dwRelativeSector+qwPos);
				continue;
				}

			if(sMbr.sTable[i].bOSType==0x83)	// EXT Partitionen
				{
				ScanEXT(sMbr.sTable[i].dwRelativeSector+qwPos);
				continue;
				}

			if(iNum<32)							// Erweiterte Partitionen
			if(sMbr.sTable[i].bOSType==0x05 || sMbr.sTable[i].bOSType==0x0F)
				{
				dwNext[iNum]=(DWORD)qwPos+sMbr.sTable[i].dwRelativeSector;
				dwTemp[iNum]=0;

				if(i>0)							// Alternative Position (BUG in Win ???)
					{
					dwTemp[iNum]  = (DWORD)qwPos;
					dwTemp[iNum] += sMbr.sTable[i-1].dwSectors;
					dwTemp[iNum] += sMbr.sTable[i-1].dwRelativeSector;
					}

				iNum++;
				}
			}
		}


//******************** Suche GPT **********************************************


	if(dwSecUnits<UNITS_MAX && ReadSector(dwDrive,qwStart+1,1,&sGuid))
	if(memcmp(sGuid.aSignatur,"\x45\x46\x49\x20\x50\x41\x52\x54",8)==0)
		{
		qwSecPos[dwSecUnits]=qwStart+1;
		qwSecEnd[dwSecUnits]=qwStart+2;
		dwSecTyp[dwSecUnits]=TYPE_GPT;
		dwSecUnits++;

		if(dwSecUnits<UNITS_MAX && sGuid.qwBackupPosition)
			{
			qwSecPos[dwSecUnits]=sGuid.qwBackupPosition;
			qwSecEnd[dwSecUnits]=sGuid.qwBackupPosition+1;
			dwSecTyp[dwSecUnits]=TYPE_GPT;
			dwSecUnits++;
			}

		if(dwSecUnits<UNITS_MAX && sGuid.qwPartitionTab && sGuid.dwUsedEntries)
			{
			dwCount = (sGuid.dwUsedEntries+3)/4;
			qwSecPos[dwSecUnits]=sGuid.qwPartitionTab;
			qwSecEnd[dwSecUnits]=sGuid.qwPartitionTab+dwCount;
			dwSecTyp[dwSecUnits]=TYPE_GPTLIST;
			dwSecUnits++;


			if(dwSecUnits<UNITS_MAX && sGuid.qwBackupPosition)
				{
				qwSecPos[dwSecUnits]=sGuid.qwBackupPosition-dwCount;
				qwSecEnd[dwSecUnits]=sGuid.qwBackupPosition;
				dwSecTyp[dwSecUnits]=TYPE_GPTLIST;
				dwSecUnits++;
				}

			for(dwNumber=0;dwNumber<sGuid.dwUsedEntries;dwNumber++)
				{
				if(dwSecUnits>=UNITS_MAX)break;

				if(dwNumber%4==0)
					{
					if(!ReadSector(dwDrive,qwStart+sGuid.qwPartitionTab+dwNumber/4,1,aList))
						{
						break;
						}
					}

				i = dwNumber&3;

				if(aList[i].qwEndLba<=aList[i].qwStartLba)continue;

												// Ist die Partition schon eingetragen
				for(dwOffset=0;dwOffset<dwSecUnits;dwOffset++)
					{
					if(qwStart+aList[i].qwStartLba==qwSecPos[dwOffset])break;
					}

				if(dwOffset<dwSecUnits)continue;

				if(dwPartitions<PARTS_MAX)		// Start der Partition eintragen
					{
					qwPartitionBase[dwPartitions] = qwStart+aList[i].qwStartLba;
					dwPartitions++;
					}

				if(!ReadSector(dwDrive,qwStart+aList[i].qwStartLba,4,aData))
					{
					continue;
					}

				pNtfs = (BootRecordNtfs*)aData;

				if(pNtfs->wSignature==0xAA55)
					{
					if(memcmp(pNtfs->cOEMName,"NTFS    ",8)==0)
							ScanNTFS (qwStart+aList[i].qwStartLba);
					else if(memcmp(pNtfs->cOEMName,"EXFAT   ",8)==0)
							ScanExFAT(qwStart+aList[i].qwStartLba);
					else	ScanFAT  (qwStart+aList[i].qwStartLba);
					}

				if(*(LPWORD)(aData+0x0438)==0xEF53)
					{
					return ScanEXT(qwStart+aList[i].qwStartLba);
					}
				}
			}
		}



	for(i=1;i<(int)dwPartitions;i++)			// Sortiere die Partitionen
		{
		if(qwPartitionBase[i]>=qwPartitionBase[i-1])continue;


		qwPos				= qwPartitionBase[i];
		qwPartitionBase[i]	= qwPartitionBase[i-1];
		qwPartitionBase[i-1]= qwPos;

		i = 0;
		}



return (iNum>0);
}


//*****************************************************************************
//*
//*		DiskScanFile
//*
//*****************************************************************************
//	Sucht eine Partition in einer Partitionsdatei
//	iDrive		: Ist das Laufwerk mit der Partitionsdatei (0=A: 1=B: ... 26=Z:)
//	pEntires	: Zeiger auf die Laufwerksdaten
//	Ergibt 0 wenn ok oder eine Fehlernummer kleiner 0
//					 N = Partitionen geladen
//					 0 = Partition nicht gefunden
//					-1 = Falsches Laufwerk
//					-2 = Partitionsdatei nicht gefunden
//					-3 = Paritionen haben das falsche Format
//					-4 = Kein physikalisches Laufwerk aktiv
//					-5 = User-Abbruch
int CDiskDoc::ScanFile(int iDrive)
{
#define		SCF_MAX_LOAD	4

typedef struct
	{
	QWORD	qwDriveSize;							// Gesamtgre der Festplatte
	QWORD	qwStart[SCF_MAX_LOAD];					// Startsektor der Partition
	QWORD	qwSize [SCF_MAX_LOAD];					// Gre der Partition in Sektoren
	DWORD	dwEntry[SCF_MAX_LOAD];					// Position des MBR/GPT Eintrages
	}PartData;

#define 	CMP_DWORD(p,n)	(((*(int*)(p))           )^(*(int*)(n)))
#define 	CMP_DW_EX(p,n)	(((*(int*)(p))&0xFFF0FFFF)^(*(int*)(n)))
char		cLine[348]="A:\\Partitions.txt";
PartData   *pEntires;
QWORD		uValue;
PartData	sData;
FILE	   *pFile;
unsigned 	uPart;
unsigned 	uFlag;
unsigned	uStep;
BYTE		uSign;
int		 	iType;
int			iPos;
int			iRet;



	if(dwDrive<0x8000 || dwDrive>0x80FF)			// Ist ein physikalisches Laufwerk aktiv
		{
		return -4;
		}

	pEntires = &sData;
	memset(pEntires,0,sizeof(PartData));

	if(iDrive<0 || iDrive>=26)						// Prfe die Laufwerksnummer
		{
		return -1;
		}

	cLine[0] += iDrive;

		pFile = fopen(cLine,"rb");
	if(!pFile)return -2;

	cLine[sizeof(cLine)-1] = 0;
	uPart	= 0x8000;
	uFlag	= 0;
	iRet	= 0;

	while(iRet>=0)									// Partitionsdatei zeilen weise laden
		{
		if(!fgets(cLine,sizeof(cLine)-1,pFile))break;

		for(iPos=0;cLine[iPos];iPos++)
			{
			if(cLine[iPos]!=' ' )
			if(cLine[iPos]!='\t')break;
			}

		if(cLine[iPos]=='[')						// Neue Partition definiert
			{
			if(CMP_DWORD(cLine+iPos  ,"[DRI")==0)
			if(CMP_DWORD(cLine+iPos+4,"VES]")==0)
				{
				uPart = 0xFFFF;
				continue;
				}

			if(CMP_DWORD(cLine+iPos  ,"[PAR"))continue;
			if(CMP_DWORD(cLine+iPos+4,"TITI"))continue;
			if(CMP_DW_EX(cLine+iPos+8,"ON0]"))continue;

			uPart = cLine[iPos+10]-'0';

			continue;
			}

		iType = 0;

		if(!CMP_DWORD(cLine+iPos,"SECT"))iType=1;
		if(!CMP_DWORD(cLine+iPos,"SIZE"))iType=2;
		if(!CMP_DWORD(cLine+iPos,"SHOW"))iType=3;

		for(iPos+=4;;iPos++)
			{
			if(cLine[iPos]!=' ' )
			if(cLine[iPos]!='\t')break;
			if(cLine[iPos]=='=' )break;
			}

		if(cLine[iPos]!='=')continue;

		for(iPos++;cLine[iPos];iPos++)
			{
			if(cLine[iPos]!='\t')break;
			if(cLine[iPos]=='=' )break;
			}

		if(cLine[iPos]=='0' && (cLine[iPos+1]=='x' || cLine[iPos+1]=='X'))
			{
			uValue = 0;

			for(iPos+=2;cLine[iPos];iPos++)
				{
				uSign = cLine[iPos];

				if(uSign>='0' && uSign<='9')
					{
					uSign = cLine[iPos]-'0';
					}
				else if(uSign>='A' && uSign<='F')
					{
					uSign = cLine[iPos]-'A'+10;
					}
				else if(uSign>='a' && uSign<='f')
					{
					uSign = cLine[iPos]-'a'+10;
					}
				else{
					break;
					}

				uValue *= 16;
				uValue += uSign;
				}
			}
		else{
			uValue = 0;

			for(;cLine[iPos];iPos++)
				{
				   uSign = cLine[iPos]-'0';
				if(uSign>=10)break;

				uValue *= 10;
				uValue += uSign;
				}
			}

		if(uPart>=SCF_MAX_LOAD)
			{
			if(uPart==0xFFFF)pEntires->qwDriveSize=uValue;
			continue;
			}

		switch(iType)
			{
		case 1:	pEntires->qwStart[uPart] =        uValue;	break;
		case 2:	pEntires->qwSize [uPart] =        uValue;	break;
		case 3:	pEntires->dwEntry[uPart] = (DWORD)uValue;	break;
			}
		}

	fclose(pFile);

	if(iRet==0)
		{
		if(qwSectorCount!=pEntires->qwDriveSize)
			{
			char	cBuffer[256];

			sprintf(cBuffer,"Die Gre in %c:\\Partitions.txt:\n    %I64i\nstimmt nicht mit der Gre des physikalischen Laufwerks %i:\n    %I64i\nberein, trotzdem weiter machen ?",iDrive,pEntires->qwDriveSize,qwSectorCount);
			if(MessageBox(cBuffer,"Warnung",MB_OKCANCEL|MB_ICONWARNING)!=IDOK)return -5;
			}

		for(uPart=0;uPart<SCF_MAX_LOAD;uPart++)		// Partitionen aus der Datei einfgen
			{
			if(!pEntires->qwStart[uPart])continue;
			if(!pEntires->qwSize [uPart])continue;

			for(uStep=0;uStep<dwPartitions;uStep++)
				{
				if(pEntires->qwStart[uPart]==qwPartitionBase[uStep])break;
				}

			if(uStep>=dwPartitions && dwPartitions<PARTS_MAX)
				{
				qwPartitionBase[dwPartitions] = pEntires->qwStart[uPart];
				dwPartitions++;
				ScanFAT(pEntires->qwStart[uPart]);
				iRet++;
				}
			}
		}



return iRet;
}


//*****************************************************************************
//*
//*		OnSaveSec
//*
//*****************************************************************************
void CDiskDoc::OnSaveSec()
{
CSectionDlg		sDlg;
CProgressDlg	sPDlg;
DWORD			dwSize;
QWORD			qwSector;
FILE		   *pFile;


	sDlg.m_bSave   = TRUE;
	sDlg.m_uSector = qwSectorNumber;
	sDlg.m_uCount  = 1;
	sDlg.m_sMax.Format("max. : %I64i",qwSectorCount/(QWORD)dwDriveMul);

	if(sDlg.DoModal()!=IDOK)return;

	if(!sDlg.m_uCount || sDlg.m_uSector>=qwSectorCount || sDlg.m_sPath=="")
		{
		MessageBox("Falsche Eingabe","Fehler",MB_OK|MB_ICONERROR);
		return;
		}


	qwSector = sDlg.m_uSector;
	dwSize   = dwDriveSectorSize*sDlg.m_uCount;

		pFile=fopen(sDlg.m_sPath,"wb");
	if(!pFile)
		{
		MessageBox("Die Datei konnte nicht geffnet werden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	sPDlg.SetTitle("Speichere Sektoren");
	sPDlg.SetRange(qwSector,qwSector+sDlg.m_uCount);
	sPDlg.SetProc (SaveSec,this,pFile,(DWORD)qwSector,(DWORD)(qwSector>>32),dwSize);
	sPDlg.DoModal();


}

//*****************************************************************************
//*
//*		SaveSec
//*
//*****************************************************************************
int  _cdecl CDiskDoc::SaveSec(CProgressDlg  *pDlg)
{
CDiskDoc	*pDoc=(CDiskDoc*)pDlg->GetVoid1();
QWORD		 qwSector;

	qwSector  = (DWORD)pDlg->GetInt4();
	qwSector<<= 32;
	qwSector += (DWORD)pDlg->GetInt3();

return pDoc->SaveSec(pDlg,(FILE*)pDlg->GetVoid2(),qwSector,pDlg->GetInt5());
}
int CDiskDoc::SaveSec(CProgressDlg  *pDlg,FILE *pFile,QWORD	qwSector,DWORD dwSize)
{
DWORD		dwPos,dwAdd,dwRet,dwTurn=0;
BYTE	   *pData;
BOOL		bOk;




	dwAdd    = dwSize;

	   dwAdd=(DWORD)(qwSectorCount/128);
	if(dwAdd>512                      )dwAdd=512;
	if(dwAdd>(DWORD)(qwSectorCount/16))dwAdd=(DWORD)(qwSectorCount/16);
	if(dwAdd<dwDriveMul*2             )dwAdd=dwDriveMul*2;

	   dwAdd<<=9;
	if(dwAdd>0x1000 && dwDrive<2)dwAdd=0x1000;
	if(dwAdd>dwSize)dwAdd=dwSize;

	pData=new BYTE[dwAdd];


	for(dwPos=0;dwPos<dwSize;)
		{
		if(pDlg->IsStoped())break;
		   pDlg->SetPos(qwSector);

		if(dwPos+dwAdd>dwSize)dwAdd=dwSize-dwPos;

		bOk=ReadSector(dwDrive,qwSector,dwAdd>>9,pData);
		dwTurn++;

		if(!bOk)
			{
			if(dwTurn<2)continue;

			   dwRet=pDlg->MessageBox("Fehler beim Lesen vom Laufwerk !","Fehler",MB_ABORTRETRYIGNORE|MB_ICONERROR);
			if(dwRet==IDABORT)break;
			if(dwRet==IDRETRY)continue;
			}

			bOk=fwrite(pData,dwAdd,1,pFile);
		if(!bOk)
			{
			pDlg->MessageBox("Fehler beim schreiben in die Zieldatei.","Fehler",MB_OK|MB_ICONERROR);
			break;
			}

		qwSector += dwAdd>>9;
		dwPos    += dwAdd;
		dwTurn    = 0;
		}


	fclose(pFile);
	delete pData;

return 0;
}


//*****************************************************************************
//*
//*		OnLoadSec
//*
//*****************************************************************************
void CDiskDoc::OnLoadSec()
{
CSectionDlg		sDlg;
CProgressDlg	sPDlg;
DWORD			dwSize,dwMax,dwRet;
QWORD			qwSector;
QWORD			qwBytes;
FILE		   *pFile;



	sDlg.m_bSave   = FALSE;
	sDlg.m_uSector = qwSectorNumber;
	sDlg.m_uCount  = 1;
	sDlg.m_sMax.Format("max. : %I64i",qwSectorCount/(QWORD)dwDriveMul);

	if(sDlg.DoModal()!=IDOK)return;

	if(!sDlg.m_uCount || sDlg.m_uSector>=qwSectorCount || sDlg.m_sPath=="")
		{
		MessageBox("Falsche Eingabe","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	if(LengthFile(sDlg.m_sPath,&qwBytes)==-1)
		{
		MessageBox("Fehler beim Zugriff auf die Datei !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	if(qwBytes<dwDriveSectorSize*sDlg.m_uCount)
		{
		if(qwBytes<dwDriveSectorSize)
			{
			MessageBox("Die Datei ist zu klein !","Fehler",MB_OK|MB_ICONERROR);
			return;
			}

		if(MessageBox("Es sind zu wenige Sektoren in der Datei ?\nWeiter machen ?","Frage",MB_ICONWARNING|MB_OKCANCEL)!=IDOK)
			{
			return;
			}
		
		sDlg.m_uCount = (UINT)(qwBytes/(QWORD)dwDriveSectorSize);
		}


	if(sDlg.m_uCount*dwDriveMul>=0x40000000/512)
		{
		dwRet=MessageBox("Die Dateigre berschreittet 2 GB.\nWeiter machen ?","Frage",MB_ICONWARNING|MB_OKCANCEL|MB_DEFBUTTON2);
		if(dwRet==IDCANCEL)return;
		}

	if(bIsDisk)
		{
		CTextDlg sDlg;

		sDlg.SetText("Sicherheits Abfrage");
		sDlg.SetTextTitle("Bitte OK eingeben bei Festplatten :");
		if(sDlg.DoModal()!=IDOK || stricmp(sDlg.GetText(),"OK"))
			{
			return;
			}
		}

		pFile=fopen(sDlg.m_sPath,"rb");
	if(!pFile)
		{
		MessageBox("Die Datei konnte nicht geffnet werden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}


	fseek(pFile,0,SEEK_END);
	dwMax=ftell(pFile);
	fseek(pFile,0,SEEK_SET);

	if(dwMax<dwDriveSectorSize*sDlg.m_uCount)
	if(MessageBox("Es sind zu wenige Sektoren in der Datei ?\nWeiter machen ?","Frage",MB_ICONWARNING|MB_OKCANCEL)!=IDOK)
		{
		return;
		}

	if(MessageBox("Sollen die Sektoren wirklich berschrieben werden ?","Frage",MB_ICONQUESTION|MB_OKCANCEL)!=IDOK)
		{
		return;
		}

	qwSector = sDlg.m_uSector;
	dwSize   = dwDriveSectorSize*sDlg.m_uCount;


	sPDlg.SetTitle("Lade Sektoren");
	sPDlg.SetRange(qwSector,qwSector+(QWORD)sDlg.m_uCount);
	sPDlg.SetProc (LoadSec,this,pFile,(DWORD)qwSector,(DWORD)(qwSector>>32),dwSize);
	sPDlg.DoModal();

	UpdateSector();

}

//*****************************************************************************
//*
//*		LoadSec
//*
//*****************************************************************************
int  _cdecl CDiskDoc::LoadSec(CProgressDlg  *pDlg)
{
CDiskDoc	*pDoc=(CDiskDoc*)pDlg->GetVoid1();
QWORD		 qwSector;

	qwSector  = (DWORD)pDlg->GetInt4();
	qwSector<<= 32;
	qwSector += (DWORD)pDlg->GetInt3();

return pDoc->LoadSec(pDlg,(FILE*)pDlg->GetVoid2(),qwSector,pDlg->GetInt5());
}
int CDiskDoc::LoadSec(CProgressDlg  *pDlg,FILE *pFile,QWORD	qwSector,DWORD dwSize)
{
DWORD		dwPos,dwAdd,dwRet,dwTurn=0;
BYTE	   *pData;
BOOL		bOk;



	   dwAdd=(DWORD)qwSectorCount/128;
	if(dwAdd>512                      )dwAdd=512;
	if(dwAdd>(DWORD)(qwSectorCount/16))dwAdd=(DWORD)(qwSectorCount/16);
	if(dwAdd<dwDriveMul*2             )dwAdd=dwDriveMul*2;

	   dwAdd<<=9;
	if(dwAdd>0x001000 && dwDrive<2)dwAdd=0x001000;
	if(dwAdd>dwSize)dwAdd=dwSize;

	pData=new BYTE[dwAdd];


	for(dwPos=0;dwPos<dwSize;)
		{
		if(pDlg->IsStoped())break;
		   pDlg->SetPos(qwSector);

		if(dwPos+dwAdd>dwSize)dwAdd=dwSize-dwPos;

		if(!dwTurn)
			{
				bOk=fread(pData,dwAdd,1,pFile);
			if(!bOk)
				{
				pDlg->MessageBox("Fehler beim Lesen aus der Datei !","Fehler",MB_OK|MB_ICONERROR);
				break;
				}
			}

		dwTurn++;

			bOk=WriteSector(dwDrive,qwSector,dwAdd>>9,pData);
		if(!bOk)
			{
			if(dwTurn<2)continue;

			   dwRet=pDlg->MessageBox("Fehler beim Schreiben aufs Laufwerk !","Fehler",MB_ABORTRETRYIGNORE|MB_ICONERROR);
			if(dwRet==IDABORT)break;
			if(dwRet==IDRETRY)continue;
			}

		qwSector += dwAdd>>9;
		dwPos    += dwAdd;
		dwTurn    = 0;
		}


	fclose(pFile);
	delete pData;


return 0;
}


//*****************************************************************************
//*
//*		OnGoto
//*
//*****************************************************************************
//	Zu einem bestimmten Berech springen (FAT,Bootsektor, ... )
void CDiskDoc::OnGotoOk(CCmdUI *pCmdUI){pCmdUI->Enable(dwSecUnits>0);}
void CDiskDoc::OnGoto()
{
unsigned	uNr,uMax,uCount;
CListDlg	sDlg;
char		cText[256],*pType;


	if(dwSecUnits==0)
		{
		MessageBox("Es sind keine Bereiche vorhanden.","Warnung",MB_OK);
		return;
		}

	for(uNr=0,uMax=4;uNr<dwSecUnits;uNr++)
		{
		uCount=sprintf(cText,"%I64i",qwSecPos[uNr]);
		if(uMax<uCount)uMax=uCount;
		}

	for(uNr=0;uNr<dwSecUnits;uNr++)
		{
		pType = (char*)aSecName[uNr];

		if(!pType)
		switch(dwSecTyp[uNr])
			{
		case TYPE_BOOT:		pType="Boot-Sektor FAT";		break;
		case TYPE_BOOT32:	pType="Boot-Sektor FAT32";		break;
		case TYPE_BOOTNTFS:	pType="Boot-Sektor NTFS";		break;
		case TYPE_BOOTEXFAT:pType="Boot-Sektor EXFAT";		break;
		case TYPE_FAT12:	pType="FAT12";					break;
		case TYPE_FAT16:	pType="FAT16";					break;
		case TYPE_FAT32:	pType="FAT32";					break;
		case TYPE_FATEX:	pType="FATEX";					break;
		case TYPE_INFO:		pType="Info-Sektor";			break;
		case TYPE_DIR:		pType="Verzeichnis";			break;
		case TYPE_MBR:		pType="MasterBootRecord";		break;
		case TYPE_VDESC:	pType="VolumeDecriptor";		break;
		case TYPE_PTABLE:	pType="CD Pfad Tabelle";		break;
		case TYPE_CDDIR:	pType="CD Verzeichnis";			break;
		case TYPE_MFT:		pType="Master File Table";		break;
		case TYPE_MFTMIR:	pType="Mirror MFT";				break;
		case TYPE_ECMA:		pType="Ecma-Tag";				break;
		case TYPE_GPT:		pType="GUID Partitionstablle";	break;
		case TYPE_GPTLIST:	pType="GUID Partitioneintrge";	break;
		case TYPE_EXFATDIR:	pType="EXFAT Verzeichniss";		break;
		case TYPE_SUPERBLK:	pType="EXT Superblock";			break;
		default:			pType="???";					break;
			}

		sprintf(cText,"%0*I64i %s (%I64i)",uMax,qwSecPos[uNr],pType,qwSecEnd[uNr]-qwSecPos[uNr]);
		sDlg.AddString(uNr,cText);
		sDlg.Sort(CLD_VALUE);
		}

	   sDlg.AddSizeX(-120);
	   sDlg.AddSizeY(+ 40);
	   sDlg.SetTitle("Bereich auswhlen");
	if(sDlg.DoModal()!=IDOK)return;

	uNr = sDlg.GetData();
 	qwSectorNumber=qwSecPos[uNr];
	UpdateSector();

}


//*****************************************************************************
//*
//*		OnFind
//*
//*****************************************************************************
void CDiskDoc::OnFind()
{
CSectionDlg		sDlg;
CHexFindDlg		sHex;
CString			sText;


	sText.Format("Sektoren von 0 bis %I64i",qwSectorCount);
	sDlg.SetTitle(sText);
	sDlg.m_bSave   = TRUE;
	sDlg.m_uSector = qwSectorNumber;
	sDlg.m_uCount  = 1;
	sDlg.m_uFormat = 1;

	if(sDlg.DoModal()!=IDOK)return;

	if(!sDlg.m_uCount || sDlg.m_uSector>=qwSectorCount)
		{
		MessageBox("Falsche Eingabe","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	if(sDlg.m_uSector+sDlg.m_uCount>qwSectorCount)
		{
		sDlg.m_uCount = (DWORD)(qwSectorCount-sDlg.m_uSector);
		}



	iFindFlags|=HEX_FIND_NODIR;
	if(sHex.DoModal(&iFindFlags,&pFindSuchen,&pFindGruppe,&pFindErgebnis)!=IDOK)return;


   	qwFindPos		  = 0;				// Jetzige Position im Sektor
   	qwFindStart		  = sDlg.m_uSector;	// Startsektor fr die Suche
   	qwFindCount		  = sDlg.m_uCount;	// Sektorenanzahl fr die Suche
   	qwFindSecPos	  = sDlg.m_uSector;	// Jetziger Sektor in dem gesucht wird
   	qwFindStart		 *= dwDriveMul;
   	qwFindCount		 *= dwDriveMul;
   	qwFindSecPos	 *= dwDriveMul;

	OnFindNext();
}

//*****************************************************************************
//*
//*		OnFindNext
//*
//*****************************************************************************
void CDiskDoc::OnFindNextOk(CCmdUI *pCmdUI){pCmdUI->Enable(qwFindCount>0);}
void CDiskDoc::OnFindNext()
{
QWORD			qwMax;
QWORD			qwAnz;
CHexFind		sFind;


	if(qwFindCount==0)return;

	qwFindResultSec = 0xFFFFFFFFFFFFFFFFl;

	qwMax  = qwFindStart+qwFindCount;
	qwAnz  = qwMax-qwFindSecPos;

	if(qwAnz<1024 && (qwAnz<16 || dwDrive>2))
		{
		SetCursor(IDC_WAIT);
		FindNext(0,&sFind);
		SetCursor(IDC_ARROW);
		}
	else{
		CProgressDlg	sDlg;

		sDlg.SetTitle("Suche in Sektoren");
		sDlg.SetRange(qwFindStart,qwMax);
		sDlg.SetProc (FindNext,this,&sFind);
		sDlg.SetBreak(FindBreak);
		sDlg.DoModal();
		}

	if(qwFindResultSec!=0xFFFFFFFFFFFFFFFFl)	  // Das Ergebnis eine Sektorsuche
		{
		qwSectorNumber = qwFindResultSec;
		UpdateSector(qwFindResultPos,dwFindResultAnz);
		}

}

//*****************************************************************************
//*
//*		FindBreak
//*
//*****************************************************************************
void CDiskDoc::FindBreak(CProgressDlg *pDlg)
{
CHexFind	*pFind = (CHexFind*)pDlg->GetVoid2();

	pFind->Break();

}

//*****************************************************************************
//*
//*		FindNext
//*
//*****************************************************************************
int CDiskDoc::FindNext(CProgressDlg *pDlg)
{
CDiskDoc	*pDoc  = (CDiskDoc*)pDlg->GetVoid1();
CHexFind	*pFind = (CHexFind*)pDlg->GetVoid2();

return pDoc->FindNext(pDlg,pFind);
}
int CDiskDoc::FindNext(CProgressDlg  *pDlg,CHexFind *pFind)
{
DWORD			dwLast,dwTime,dwAnz;
QWORD			qwPos,qwEnd,qwAdd,qwMax;
char           *pPtr,cText[128];
BOOL			bOk;
int				iOff;




	qwMax  = qwFindStart+qwFindCount;
	qwAdd  = strtoi(pFindErgebnis);
	qwAdd += 512*4+511;
	qwAdd /= 512;
	dwLast = 0;

	if(qwAdd>128)qwAdd=128;


	if(!pFindData)pFindData=new BYTE[FIND_SIZE];


	if(qwFindSecPos<qwFindDataSec)					// Prfe Puffer
		{
		qwFindDataSec  = qwFindSecPos;
		qwFindDataSize = 0;
		}

	if(qwFindSecPos>qwFindDataSec+qwFindDataSize)
		{
		qwFindDataSec  = qwFindSecPos;
		qwFindDataSize = 0;
		}

	while(qwFindSecPos<qwMax)						// Duechlaufen bis zum Ende
		{
		if(pDlg)
			{
			   dwTime=GetTickCount();
			if(dwTime-dwLast>500)
				{
				sprintf(cText,"Sektor %I64i (bis %I64i)",qwFindDataSec,qwMax);
				pDlg->SetText(cText);
				dwLast=dwTime;
				}

			   pDlg->SetPos(qwFindSecPos);
			if(pDlg->IsStoped())break;
			}

		if(qwFindSecPos+qwAdd>qwMax)
			{
			qwAdd=qwMax-qwFindPos;
			}

		qwEnd = qwFindDataSec+qwFindDataSize;

		if(qwEnd<qwFindSecPos+qwAdd)				// Neue Sektoren laden
			{
			qwPos =         qwFindSecPos-qwFindDataSec;
			dwAnz = (DWORD)(qwFindDataSize-qwPos);
			memmove(pFindData,pFindData+(DWORD)qwPos*512,(DWORD)dwAnz*512);
			qwFindDataSec  = qwFindSecPos;
			qwFindDataSize = dwAnz;

			dwAnz = (DWORD)(FIND_SEC-qwFindDataSize);
			qwPos = qwFindDataSec+qwFindDataSize;

			if(qwPos+dwAnz>qwMax)
				{
				dwAnz = (DWORD)(qwMax-qwPos);
				}

				bOk=ReadSector(dwDrive,qwPos,dwAnz,pFindData+qwFindDataSize*512);
			if(!bOk)
				{
				if(pDlg)pDlg->MessageBox("Lesefehler","Fehler",MB_OK|MB_ICONERROR);
				else		  MessageBox("Lesefehler","Fehler",MB_OK|MB_ICONERROR);
				break;
				}

			qwFindDataSize += dwAnz;
			}

		qwPos = (qwFindSecPos-qwFindDataSec)*512+qwFindPos;
		dwAnz = (DWORD)      (qwFindDataSize*512-qwPos);
		iOff  = pFind->FindTxt(pFindData,pFindErgebnis,(DWORD)qwPos,dwAnz,(iFindFlags&HEX_FIND_IN_ORDER)? CHF_SAMEPOS:0);

		if(iOff<0)
			{
			qwPos += dwAnz;
			qwPos /= 512;
			qwPos -= qwFindSecPos-qwFindDataSec;
			if(qwFindSecPos+qwPos<qwMax)
			if(qwPos>=qwAdd)qwPos-=qwAdd-1;
			qwFindSecPos += qwPos;
			qwFindPos=0;
			continue;
			}

		qwPos        = iOff;						// Ein Wert Wurde gefunden
		qwFindSecPos = qwFindDataSec+qwPos/512;
		qwFindPos 	 = qwPos&511;

		pPtr   = pFindErgebnis;
		pPtr  += strlen (pPtr    )+1;
		pPtr  += strchar(pPtr,':')+1;
		dwAnz  = strtoi (pPtr);
		qwPos &= 511;
		qwPos +=(qwFindSecPos%dwDriveMul)*512;

		qwFindResultPos = qwPos;					// Das Ergebnis eine Sektorsuche
		dwFindResultAnz = dwAnz;					//			*
		qwFindResultSec = qwFindSecPos/dwDriveMul;	//			*

		   qwFindPos++;
		if(qwFindPos>=521)
			{
			qwFindPos-=512;
			qwFindSecPos++;
			}

		return 1;
		}

	MessageBeep(MB_ICONEXCLAMATION);

return 0;
}

//*****************************************************************************
//*
//*		OnWriteProtection
//*
//*****************************************************************************
void CDiskDoc::OnWriteProtectionOk(CCmdUI *pCmdUI){pCmdUI->SetCheck(!bIsWriteable);}
void CDiskDoc::OnWriteProtection()
{
int		i;
BOOL	bOk;


	if(dwSectorState!=0)				// Sektor geladen ?
		{
		MessageBox("Es ist kein Sektor geladen !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	if(!bIsWriteable)
		{
		i=MessageBox("Den Schreibschutz wirklich entfernen ?","Schreibschutz",MB_OKCANCEL|MB_ICONQUESTION);
		if(i==IDCANCEL)return;

		bIsWriteable=TRUE;
		memcpy(bSectorOld,bSectorData,dwSectorSize);
		UpdateAllViews(NULL,0xFFFFF100);
		return;
		}

	if(memcmp(bSectorOld,bSectorData,dwSectorSize))
		{
		i=MessageBox("Der Sektor wurde verndert ?\nSoll ergeschrieben werden ?","Schreibschutz",MB_YESNOCANCEL|MB_ICONWARNING|MB_DEFBUTTON2);
		if(i==IDCANCEL)return;
		if(i==IDYES && bIsDisk)
			{
			CTextDlg sDlg;

			sDlg.SetTitle("Sicherheits Abfrage");
			sDlg.SetTextTitle("Bitte OK eingeben bei Festplatten :");
			if(sDlg.DoModal()!=IDOK || stricmp(sDlg.GetText(),"OK"))
				{
				i=IDNO;
				}
			}
		if(i==IDYES)
			{
			SetCursor(IDC_WAIT);
			bOk=WriteSector(dwDrive,qwSectorNumber*dwDriveMul,dwDriveMul,bSectorData);
			SetCursor(IDC_ARROW);

			if(!bOk)
				{
				MessageBox("Der Sektor konnte nicht geschrieben werden!","Fehler",MB_OK|MB_ICONERROR);
				return;
				}
			}
		if(i==IDNO)
			{
			memcpy(bSectorData,bSectorOld,dwSectorSize);
			UpdateAllViews(NULL,0);
			}
		}

	UpdateAllViews(NULL,0xFFFFF200);
	bIsWriteable=FALSE;
}


//*****************************************************************************
//*
//*		DecodeClusterData
//*
//*****************************************************************************
//	Decodiert Clusetdaten
//	dwLen	: Maximale Clusteranzahl
//	pData	: Zeiger auf Daten
//	pCluser	: Zielspeicher fr Cluster Nummern
//	pCount	: Zielspeicher fr Cluster Anzahlen
//	iMax	: Maximale Zielspeichergre
//	Ergibt die Zahl der decodierten Wertepaare
int CDiskDoc::DecodeClusterData(long lLen,BYTE *pData,DWORD *pCluster,DWORD *pCount,int iMax)
{
BYTE	bType;
DWORD	dwValue;
int		iSize,iNum=0;


	while(lLen>0 && iMax>0)
		{
		bType = *pData;
		pData++;

		dwValue=*(DWORD*)pData;
		iSize=bType&0x0F;
		pData+=iSize;
		dwValue&=~bit_shift_l(0xFFFFFFFF,iSize*8);
		pCount[0]=dwValue;
		lLen-=dwValue;

		if(lLen<0)break;

		dwValue=*(DWORD*)pData;
		iSize=bType>>4;
		pData+=iSize;
		dwValue&=~bit_shift_l(0xFFFFFFFF,iSize*8);
		pCluster[0]=dwValue;

		pCluster++;
		pCount++;
		iNum++;
		iMax--;
		}


return iNum;
}


//*****************************************************************************
//*
//*		ReadSector
//*
//*****************************************************************************
//	Auslesen eines oder mehrere logischer Sektoren (immer 512 Byte gro !!!)
//	iDrive	: Laufwerksnummer (A=0 B=1 ...  0x8000=Physical_0 0x8001=Physical_1 ... )
//	dwStart	: Nummer des ersten Sektors
//	dwCount : Ist die Anzahl der Sektoren (1 bis 0xFFFF)
//	pBuffer	: Zeiger auf den Puffer in dem die Sektoren geschrieben werden.
//	Ergibt TRUE wenn die Sektoren gelesen wurden
BOOL  CDiskDoc::ReadSector(int iDrive,QWORD qwStart,DWORD dwCount,void *pBuffer)
{
LONG	lHigh;
BOOL	bResult;
DWORD	dwStart;
DWORD	dwBytes;


	if(iDrive==0xC000)
		{
		if(hEmulation==INVALID_HANDLE_VALUE)
			{
			if(sEmulation=="")return FALSE;

				hEmulation =  CreateFile(sEmulation,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
			if(	hEmulation == INVALID_HANDLE_VALUE)return FALSE;
			}

		lHigh=(LONG)(qwStart>>(32-9));
		qwStart*=512;
		dwCount*=512;
		dwStart=(DWORD)qwStart;

		if(SetFilePointer(hEmulation,dwStart,&lHigh,FILE_BEGIN)==0xFFFFFFFF)
		if(GetLastError())return FALSE;

			bResult=ReadFile(hEmulation,pBuffer,dwCount,&dwBytes,NULL);
		if(!bResult || dwCount!=dwBytes)return FALSE;

		return TRUE;
		}


return ::ReadSector(iDrive,qwStart,dwCount,pBuffer);
}

//*****************************************************************************
//*
//*		WriteSector
//*
//*****************************************************************************
//	Schreiben eines oder mehrere logischer Sektoren (immer 512 Byte gro !!!)
//	iDrive	: Laufwerksnummer (A=0 B=1 ...  0x8000=Physical_0 0x8001=Physical_1 ... )
//	dwStart	: Nummer des ersten Sektors
//	dwCount : Ist die Anzahl der Sektoren (1 bis 0xFFFF)
//	pBuffer	: Zeiger auf den Puffer in dem die Sektoren Daten stehen werden.
//	Ergibt TRUE wenn die Sektoren geschrieben wurden
BOOL  CDiskDoc::WriteSector(int iDrive,QWORD qwStart,DWORD dwCount,void *pBuffer)
{
LONG	lHigh;
BOOL	bResult;
DWORD	dwStart;
DWORD	dwBytes,dwHigh,dwSize;
__int64	iSize,iMove;



	if(iDrive==0xC000)
		{
		if(hEmulation!=INVALID_HANDLE_VALUE)
			{
			CloseHandle(hEmulation);
			hEmulation=INVALID_HANDLE_VALUE;
			}

		if(sEmulation=="")return FALSE;

			hEmulation =  CreateFile(sEmulation,GENERIC_READ|GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
		if(	hEmulation == INVALID_HANDLE_VALUE)return FALSE;


		   dwSize=GetFileSize(hEmulation,&dwHigh);
		if(dwSize==0xFFFFFFFF)
		if(GetLastError())
			{
			CloseHandle(hEmulation);
			hEmulation=INVALID_HANDLE_VALUE;
			return FALSE;
			}

		lHigh=(LONG)(qwStart>>(32-9));
		qwStart*=512;
		dwCount*=512;
		dwStart=(DWORD)qwStart;

		iSize  = dwSize;
		iSize |= ((__int64)dwHigh)<<32;
		iMove  = dwStart;
		iMove |= ((__int64)lHigh )<<32;
		iMove += dwCount;

		if(iMove>iSize)
			{
			CloseHandle(hEmulation);
			hEmulation=INVALID_HANDLE_VALUE;
			return FALSE;
			}

		if(SetFilePointer(hEmulation, dwStart, &lHigh, FILE_BEGIN)==0xFFFFFFFF)
		if(GetLastError())
			{
			CloseHandle(hEmulation);
			hEmulation=INVALID_HANDLE_VALUE;
			return FALSE;
			}

		bResult=WriteFile(hEmulation,pBuffer,dwCount,&dwBytes,NULL);
		CloseHandle(hEmulation);
		hEmulation=INVALID_HANDLE_VALUE;

		return (!bResult || dwCount!=dwBytes)? FALSE:TRUE;
		}


return ::WriteSector(iDrive,qwStart,dwCount,pBuffer);
}


//*****************************************************************************
//*
//*		GetSectorCount
//*
//*****************************************************************************
//	Ergibt die Gre eines Laufwerks in 512 Byte Sektoren
//	iDrive	: Laufwerksnummer (A=0 B=1 ...  0x8000=Physical_0 0x8001=Physical_1 ... )
//	pSize	: Wenn ungleich Null, dann wird dort die wirkliche
//			  Sektorgre gespeichert.
//	Ergibt 0 bei einem Fehler
QWORD CDiskDoc::GetSectorCount(int iDrive,DWORD *pSize)
{
DWORD	dwHigh;
DWORD	dwSize;


	if(iDrive==0xC000)
		{
		if(hEmulation==INVALID_HANDLE_VALUE)
			{
			if(sEmulation=="")return 0;

				hEmulation =  CreateFile(sEmulation,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
			if(	hEmulation == INVALID_HANDLE_VALUE)return 0;
			}

		   dwSize=GetFileSize(hEmulation,&dwHigh);
		if(dwSize==0xFFFFFFFF)
		if(GetLastError())
			{
			CloseHandle(hEmulation);
			hEmulation=INVALID_HANDLE_VALUE;
			return 0;
			}

		if(pSize)*pSize=512;

		return (QWORD)(dwSize>>9)+((QWORD)dwHigh<<23);
		}

return ::GetSectorCount(iDrive,pSize);
}


//*****************************************************************************
//*
//*		PreCloseFrame
//*
//*****************************************************************************
void CDiskDoc::PreCloseFrame( CFrameWnd* pFrame )
{


	if(bIsWriteable)
		{
		qwSectorNumber=-1;
		UpdateSector(0,0);
		}

}

//*****************************************************************************
//*
//*		OnStartOptions
//*
//*****************************************************************************
void CDiskDoc::OnStartOptions()
{
CStartOptionDlg	sDlg;


	sDlg.m_iStartMode	= iOpenMode;

	if(sDlg.DoModal()!=IDOK)return;

	iOpenMode = sDlg.m_iStartMode;

}

//*****************************************************************************
//*
//*		GetClusterStart
//*
//*****************************************************************************
QWORD CDiskDoc::GetClusterStart()
{
DWORD	dwPart;


	if(!dwClusterParts)return 0;

	for(dwPart=dwClusterParts-1;dwPart>0;dwPart--)
		{
		if(qwSectorNumber>=qwClusterFrom[dwPart])
			{
			break;
			}
		}


return qwClusterStart[dwPart];
}

//*****************************************************************************
//*
//*		GetClusterSize
//*
//*****************************************************************************
DWORD CDiskDoc::GetClusterSize()
{
DWORD	dwPart;


	if(!dwClusterParts)return 0;

	for(dwPart=dwClusterParts-1;dwPart>0;dwPart--)
		{
		if(qwSectorNumber>=qwClusterFrom[dwPart])
			{
			break;
			}
		}


return dwClusterSize[dwPart];
}

//*****************************************************************************
//*
//*		GetClusterSize
//*
//*****************************************************************************
QWORD CDiskDoc::GetClusterMin()
{
DWORD	dwPart;


	if(!dwClusterParts)return 0;

	for(dwPart=dwClusterParts-1;dwPart>0;dwPart--)
		{
		if(qwSectorNumber>=qwClusterFrom[dwPart])
			{
			break;
			}
		}


return qwClusterMin[dwPart];
}

//*****************************************************************************
//*
//*		GetPartitionBase
//*
//*****************************************************************************
QWORD CDiskDoc::GetPartitionBase()
{
DWORD	dwPart;


	for(dwPart=dwPartitions;dwPart>0;)
		{
		dwPart--;

		if(qwSectorNumber>=qwPartitionBase[dwPart])
			{
			return qwPartitionBase[dwPart];
			}
		}


return 0;
}

//*****************************************************************************
//*
//*		OnPartitionLoad
//*
//*****************************************************************************
//	Partitionen aus eine Prtitions Datei nachladen
void CDiskDoc::OnPartitionLoadOk(CCmdUI *pCmdUI){pCmdUI->Enable(dwDrive>=0x8000 && dwDrive<=0x80FF);}
void CDiskDoc::OnPartitionLoad()
{
char		cText[64];
CDriveDlg	sDlg;
int			iRet;


	sDlg.bAddImage	= FALSE;
	sDlg.bNoCdRom	= TRUE;
	sDlg.iTargets	= 2;

	if(sDlg.DoModal()!=IDOK)
		{
		return;
		}

	iRet = ScanFile(sDlg.dwDrive);

	if(iRet<0)
		{
		switch(iRet)
			{
		case -5:break;
		case -4:MessageBox("Kein physikalisches Laufwerk aktiv !" 	,"Fehler",MB_OK|MB_ICONERROR);
		case -3:MessageBox("Paritionen haben das falsche Format !"	,"Fehler",MB_OK|MB_ICONERROR);
		case -2:MessageBox("Partitionsdatei nicht gefunden !"		,"Fehler",MB_OK|MB_ICONERROR);
		case -1:MessageBox("Ein falsches Laufwerk wurde gewhlt !"	,"Fehler",MB_OK|MB_ICONERROR);
		default:MessageBox("Unbekannter Fehler !"					,"Fehler",MB_OK|MB_ICONERROR);
			}

		return;
		}

	SortEntries();
	sprintf(cText,"Es wurden %i Partitionen eingefgt.",iRet);

	MessageBox(cText,"Information",MB_OK|MB_ICONINFORMATION);

}
