//*****************************************************************************
//*
//*
//*		Klasse  CDiskView 
//*
//*
//*****************************************************************************
#if !defined(AFX_DISKVIEW_H__83791288_VXDA_1341_9273_144553540000__INCLUDED_)
#define      AFX_DISKVIEW_H__83791288_VXDA_1341_9273_144553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 

#include	"HexWnd.h"
#include	"InfoWnd.h"
#include	"DiskDoc.h"


//*****************************************************************************
//*
//*		CDiskView
//*
//*****************************************************************************
class CDiskView : public CView
{
protected: // Nur aus Serialisierung erzeugen

	CDiskView();
	DECLARE_DYNCREATE(CDiskView)

// Attribute
public:

	CDiskDoc   *GetDocument();
	CTextWnd   *GetTextWnd();
	CHexWnd    *GetHexWnd();
	BOOL		GetMark(QWORD *pAttr);
	void		OnCopy();
	void		OnPaste();

// Operationen
public:

	//{{AFX_VIRTUAL(CDiskView)
	public:
	virtual void OnDraw(CDC *pDC);  // berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CDiskView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

	CBrush		cBrush1;					// Farben fr der Vergrern-Balken	
	CBrush		cBrush2;			
	CBrush		cBrush3;			

	int			iViewPos;					// Teilung der beiden Fenster (Text/Hex)
	int			iStatusBarId;				// Registrierungs Id der Statusbar
	int			iActiveWnd;					// Was ist das aktive Fenster 0=Hex 1=Txt
	int			iLockType;					// Ist der eingestellte Anzeigetyp
	BOOL		bInit;						// Wurde das Fenster initialisiert

	CHexWnd		cHexWnd;
	CInfoWnd	cTxtWnd;

protected:
	//{{AFX_MSG(CDiskView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint cPoint);
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnSetFocus( CWnd* );
	afx_msg void OnInfo();
	afx_msg void OnDestroy();
	afx_msg void OnMoveTo();
	afx_msg void OnCppCopy();
	afx_msg void OnChecksum();
	afx_msg void OnHexConvert();
	afx_msg	void OnFindView();
	afx_msg	void OnFindNext();
	afx_msg	void OnMbrCreate();
	afx_msg	void OnChsToSector();
	afx_msg	void OnSetInfoType();
	afx_msg	void OnSuchenMarke();
	afx_msg	void OnMenuSelection (CCmdUI *pCmdUI);
	afx_msg	void OnMenuMarkeH(CCmdUI *pCmdUI);
	//}}AFX_MSG
	
	DECLARE_MESSAGE_MAP()
	
	afx_msg	void OnAnsiSetFocus(NMHDR *pNmHdr, LRESULT *pResult);

	void SetBoot  	  (void *pData,DWORD dwSize);
	void SetBootNtfs  (void *pData,DWORD dwSize);
	void SetBootExFat (void *pData,DWORD dwSize);
	void SetBoot32	  (void *pData,DWORD dwSize);
	void SetFat12 	  (void *pData,DWORD dwSize);
	void SetFat16 	  (void *pData,DWORD dwSize);
	void SetFat32 	  (void *pData,DWORD dwSize);
	void SetFatEx 	  (void *pData,DWORD dwSize);
	void SetInfo  	  (void *pData,DWORD dwSize);
	void SetDir		  (void *pData,DWORD dwSize);
	void SetMbr		  (void *pData,DWORD dwSize);
	void SetVDesc	  (void *pData,DWORD dwSize);
	void SetCdDir	  (void *pData,DWORD dwSize);
	void SetPTable	  (void *pData,DWORD dwSize);
	void SetMft		  (void *pData,DWORD dwSize);
	void SetEcma	  (void *pData,DWORD dwSize);
	void SetGpt		  (void *pData,DWORD dwSize);
	void SetGptList   (void *pData,DWORD dwSize);
	void SetExFatDir  (void *pData,DWORD dwSize);
	void SetSuperBlk  (void *pData,DWORD dwSize);

	static const char*  Stm(time_t iTime);
	static const char*  Sid(const void *pGuid);
	static const char*  Shx(unsigned uVal,unsigned uBase=1);
	static const char* 	Str(const char *pQuelle,int iMax=512);
	static const char* 	Sdt(const char *pQuelle);
	static const char* 	Sft(const void *pQuelle);
	static const char* 	Sde(DirectoryRecord *pDir,int iMax=34);
	static const char* 	Sat(DWORD       dwAttr);

	static const char* 	EcS(const unsigned char *pQuelle,int iMax=512);
	static const char* 	EcC(const unsigned char *pQuelle);
	static const char* 	EcT(const unsigned char *pQuelle);
	static const char* 	EcI(const unsigned char *pQuelle);
	static const char* 	EcB(const unsigned char *pQuelle);
	static const char* 	EcN(const unsigned char *pQuelle);
	static const char* 	EcA(unsigned uAttrib);
	static WORD			EcmaDescCrc(const void *pMem,int iLen);
	static BYTE         EcmaTagCrc(void *pTagPtr);

};

#ifndef _DEBUG
inline CDiskDoc* CDiskView::GetDocument(){return(CDiskDoc*)m_pDocument;}
#endif

inline 	CTextWnd   *CDiskView::GetTextWnd(){return &cTxtWnd;}
inline 	CHexWnd    *CDiskView::GetHexWnd (){return &cHexWnd;}

//*****************************************************************************
//{{AFX_INSERT_LOCATION}}
#endif
