//*****************************************************************************
//*
//*
//*		CDiskViewerApp Klasse
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#include  "StdAfx.h"
#include  <Afxadv.h>
#include  "DiskViewer.h"
#include  "DiskDoc.h"
#include  "DiskView.h"
#include  "MainFrm.h"


#ifdef      _DEBUG
#define new  DEBUG_NEW
#undef       THIS_FILE
static char  THIS_FILE[] = __FILE__;
#endif


CDiskViewerApp	theApp;

//*****************************************************************************
//*
//*		Nachrichten Verarbeitung
//*
//*****************************************************************************
#if _MFC_VER	>= 0x0700
	typedef  void (AFX_MSG_CALL CWnd::*AfxRangeProc)(UINT);
	#define 	AFX_MSG_RANGE (AfxRangeProc)
#else
	#define 	AFX_MSG_RANGE
#endif

BEGIN_MESSAGE_MAP(CDiskViewerApp, CWinApp)
	//{{AFX_MSG_MAP(CDiskViewerApp)
	ON_COMMAND(ID_APP_ABOUT			, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW			, OnFileNew)
	ON_COMMAND(ID_FILE_OPEN			, OnFileOpen)
	ON_COMMAND(ID_FILE_PRINT_SETUP	, OnFilePrintSetup)
	ON_COMMAND_RANGE(ID_FILE_MRU_FILE1,ID_FILE_MRU_FILE10, AFX_MSG_RANGE OnOpenRecentFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

LOAD_LAST1(CDiskViewerApp);
WAPP_FUNC (CDiskViewerApp)

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CDiskViewerApp::CDiskViewerApp()
{
}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CDiskViewerApp::~CDiskViewerApp()
{
}

//*****************************************************************************
//*
//*		InitInstance
//*
//*****************************************************************************
BOOL CDiskViewerApp::InitInstance()
{

	AfxUtilityInit();
	AfxOleInit();
	AfxEnableControlContainer();

#ifdef _AFXDLL
	Enable3dControls();
#else
	Enable3dControlsStatic();
#endif

	SetRegistryKey(_T("AZ"));
	LoadStdProfileSettings(8);


	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CDiskDoc  ),
		RUNTIME_CLASS(CMainFrame),
		RUNTIME_CLASS(CDiskView ));
	AddDocTemplate(pDocTemplate  );

	CCommandLineInfo  cmdInfo;
	ParseCommandLine (cmdInfo);
	MAKE_LONGFILENAME(cmdInfo.m_strFileName);


	if(!ProcessShellCommand(cmdInfo))return FALSE;


	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}

//*****************************************************************************
//*
//*		OnOpenRecentFile
//*
//*****************************************************************************
//	Prfe ob eine Datei aus der Dateiliste geladen werden kann
BOOL CDiskViewerApp::OnOpenRecentFile(UINT nID)
{
int		iIndex;


	if(!m_pRecentFileList    )return FALSE;
	if(nID< ID_FILE_MRU_FILE1)return FALSE;
	if(nID>=ID_FILE_MRU_FILE1 + (UINT)m_pRecentFileList->GetSize())
		{
		return FALSE;
		}

	iIndex = nID - ID_FILE_MRU_FILE1;
	if((*m_pRecentFileList)[iIndex].GetLength() == 0)return FALSE;

	return CWinApp::OnOpenRecentFile(nID);
}


//*****************************************************************************
//*
//*		OnAppAbout
//*
//*****************************************************************************
void CDiskViewerApp::OnAppAbout()
{
	CDialog aboutDlg(IDD_ABOUTBOX);
	aboutDlg.DoModal();
}
