//*****************************************************************************
//*
//*
//*		InfoWnd.cpp
//*
//*
//*****************************************************************************
#include 	"StdAfx.h"
#include	"Resource.h"
#include	"InfoWnd.h"


BEGIN_MESSAGE_MAP(CInfoWnd,CTextWnd)
	//{{AFX_MSG_MAP(CAnsiView)
	ON_COMMAND(ID_INFO_ACTION , OnInfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


typedef struct
	{
	WORD	wLine;										// Zeile mit der Information
	WORD	wPos1;										// Erstes  Zeichen
	WORD	wPos2;										// Letztes Zeichen
	WORD	wOffset;									// Offset im Sektor
	WORD	wSize;										// Anzahl der Bytes
	}InfoData;
	

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CInfoWnd::CInfoWnd(int iCharsMax,int iLinesMax,int iMode,char *pGroup) : CTextWnd(iCharsMax,iLinesMax,iMode,pGroup)
{

	m_sList.Len(sizeof(InfoData));
	
	m_uSize		= 0;										// Ausgewhlte Byteanzahl
	m_uMaxSize	= 4096;

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CInfoWnd::~CInfoWnd()
{


}


//*****************************************************************************
//*
//*     StartMenu
//*
//*****************************************************************************
//	Startet ein Kontextmen.
//	sPos		: Koordinaten bei denen das Kontextmen eingeblendet wird.
//	pMenu		: Zeiger auf das Men
//				  Ist pMenu=0 wird ein neues Men erzeugt.
void CInfoWnd::StartMenu(CPoint sPos,CMenu *pMenu)
{
const char *pWord=0; 
InfoData   *pInfo;
CMenu		sMenu;
int			iPosX;
int			iPosY;
int			iPos;

	if(!pMenu)											// Neues Men
		{
		pMenu = &sMenu;
		sMenu.CreatePopupMenu();
		}

	PointToPos(sPos,iPosX,iPosY);

	pMenu->AppendMenu(MF_STRING,ID_INFO_ACTION, _T("&Bereich markieren"));
	pMenu->AppendMenu(MF_SEPARATOR);

	m_uSize	= 0;
	iPos	= m_sList.Count();

	for(iPos--;iPos>=0;iPos--)							// Suche Info-Bereich
		{
		pInfo = (InfoData*)m_sList.Get(iPos);

		if(pInfo->wLine!=iPosY)continue;
		if(pInfo->wPos1> iPosX)continue;
		if(pInfo->wPos2<=iPosX)continue;

		m_uOffset	= pInfo->wOffset;
		m_uSize		= pInfo->wSize;

		break;
		}

	if(m_uSize==0)										// Kein Info-Bereich gefunden
		{
		pMenu->EnableMenuItem(ID_INFO_ACTION,MF_GRAYED);
		}

	
	CTextWnd::StartMenu(sPos,pMenu);

	if(pMenu==&sMenu)sMenu.DestroyMenu();

}

//*****************************************************************************
//*
//*		DelInfo
//*
//*****************************************************************************
//	Alle Infos lschen
void CInfoWnd::DelInfo()
{

	m_sList.Del();

	m_uSize = 0;										// Ausgewhlte Byteanzahl

}

//*****************************************************************************
//*
//*		AddInfo
//*
//*****************************************************************************
//	Einen Info-Eintrag einfgen
//	uOffset		: Offset im Sektor
//	uSize		: Anzahl der Bytes
//	iLine		: Zeile mit der Information
//	iPos1		: Erstes  Zeichen
//	iPos2		: Letztes Zeichen
void CInfoWnd::AddInfo(unsigned uOffset,unsigned uSize,int iLine,int iPos1,int iPos2)
{
InfoData	sData;


	if(uSize==0 || uOffset>=m_uMaxSize)
		{
		return;
		}

	sData.wLine		= iLine;
	sData.wPos1		= iPos1;
	sData.wPos2		= iPos2;
	sData.wOffset	= uOffset;	
	sData.wSize		= uSize;

	m_sList.Add(&sData);

}

//*****************************************************************************
//*
//*		OnInfo
//*
//*****************************************************************************
void CInfoWnd::OnInfo()
{

	GetParent()->PostMessage(WM_COMMAND,ID_INFO_ACTION);

}