//*****************************************************************************
//*
//*
//*		CMainFrame Klasse
//*
//*
//*****************************************************************************
#include "StdAfx.h"
#include "DiskViewer.h"
#include "DiskView.h"
#include "MainFrm.h"



#ifdef		_DEBUG
#define new  DEBUG_NEW
#undef		 THIS_FILE
static char  THIS_FILE[] = __FILE__;
#endif


//*****************************************************************************
//*
//*		Nachrichten Verarbeitung
//*
//*****************************************************************************
IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)
BEGIN_MESSAGE_MAP  (CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_ANSI_MESSAGE()
	ON_UPDATE_COMMAND_UI(ID_DATAVIEW_ON,OnDataviewOnMenu)
	ON_COMMAND(ID_DATAVIEW_ON	, OnDataviewOn)
	ON_COMMAND(ID_DATAVIEW_DOCK	, OnDataviewDock)
	ON_COMMAND(ID_UPDATEDATA	, OnUpdateData)
	ON_COMMAND(ID_STATUS_BAR_FLAT,OnFlatBar)
	ON_UPDATE_COMMAND_UI(ID_STATUS_BAR_FLAT,OnFlatBarUI)
	//}}AFX_MSG_MAP
	ON_STATUSBAR()
	ON_MENUICON()
	ON_WM_DATAWNDTAB(ID_DATAWND , OnDataWndTab)

END_MESSAGE_MAP()


//*****************************************************************************
//*
//*		Variabeln
//*
//*****************************************************************************

static UINT indicators[] =						// Statusleistenanzeige
	{
	ID_SEPARATOR,
	};

STATUSBAR_PROC(CMainFrame)
MENUICON_PROC(CMainFrame)
ANSI_PROC(CMainFrame)

//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CMainFrame::CMainFrame()
{
CRegKeys	sKey;

	m_bFlatMode = TRUE;

	sKey.Open();
	sKey.Up("Settings");
	sKey.Get(m_bFlatMode,"FlatMode");

}


//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CMainFrame::~CMainFrame()
{
CRegKeys	sKey;

	sKey.Open();
	sKey.Up("Settings");
	sKey.Set(m_bFlatMode,"FlatMode");
}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
DWORD	dwStyle;
CRect	rect;


	if(CFrameWnd::OnCreate(lpCreateStruct) == -1)
		{
		return -1;
		}

	dwStyle = (m_bFlatMode)? TBSTYLE_FLAT:0;

	if(!m_wndToolBar.CreateEx(this,dwStyle,WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC,CRect(2,2,2,2)))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
		}

	if(!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
		}

	if(!m_wndDataBar.Create(this,CBRS_BOTTOM|CBRS_GRIPPER|CBRS_CLOSEBUTTON))
		{
		TRACE0("Failed to create movebar\n");
		return -1;      // Fehler beim Erzeugen
		}

	rect.SetRectEmpty();

	if(!m_wndData.Create(8,CDW_LABELS|CDW_MODULLIST|CDW_BLOCKNAMES|CDW_ADDRES_ON|CDW_FIXEDFONT|CDW_LISTLINES|CDW_LISTBORDER|CDW_LOADCONFIG,rect,&m_wndDataBar,ID_DATAWND))
		{
		TRACE0("Failed to create datawnd\n");
		return -1;      // Fehler beim Erzeugen
		}

	m_wndDataBar.AttachWnd(&m_wndData);

	if (!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(indicators,sizeof(indicators)/sizeof(UINT)))
		{
		TRACE0("Failed to create status bar\n");
		return -1;      // Fehler beim Erzeugen
		}

	m_wndDataBar.SetBarStyle(m_wndDataBar.GetBarStyle() | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC | CBRS_ALIGN_BOTTOM);
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	m_wndDataBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);

	EnableDocking(CBRS_ALIGN_ANY);

	DockControlBar(&m_wndDataBar ,AFX_IDW_DOCKBAR_BOTTOM);
	DockControlBar(&m_wndToolBar);
	MenuIconsInit(IDR_MAINFRAME);


	CMenu *menu;
	menu=GetMenu();
	menu->EnableMenuItem(ID_EDIT_COPY ,MF_GRAYED);


return 0;
}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	return CFrameWnd::PreCreateWindow(cs);
}
//*****************************************************************************
//*
//*		ActivateFrame
//*
//*****************************************************************************
// Hauptfenseter sichbarmachen
void CMainFrame::ActivateFrame( int nCmdShow)
{
ShowWindow(SW_SHOW);
}

//*****************************************************************************
//*
//*		Debug Funktionen
//*
//*****************************************************************************
#ifdef _DEBUG
void CMainFrame::AssertValid() const
	{ CFrameWnd::AssertValid();}
void CMainFrame::Dump(CDumpContext& dc) const
	{ CFrameWnd::Dump(dc);}

#endif

//*****************************************************************************
//*
//*		OnDataviewOn
//*
//*****************************************************************************
void CMainFrame::OnDataviewOn()
{
	ShowControlBar(&m_wndDataBar ,!m_wndDataBar .IsVisible(),0);
}

//*****************************************************************************
//*
//*		OnDataviewOnMenu
//*
//*****************************************************************************
void CMainFrame::OnDataviewOnMenu(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_wndDataBar.IsVisible());
}
//*****************************************************************************
//*
//*		OnUpdateDataMenu
//*
//*****************************************************************************
void CMainFrame::OnUpdateDataMenu(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_wndDataBar.IsVisible());
}

//*****************************************************************************
//*
//*		OnDataviewDock
//*
//*****************************************************************************
void CMainFrame::OnDataviewDock()
{
	if(m_wndDataBar.IsFloating())
			DockControlBar (&m_wndDataBar,AFX_IDW_DOCKBAR_RIGHT);
	else	FloatControlBar(&m_wndDataBar,CPoint(100,100));

}

//*****************************************************************************
//*
//*		OnUpdateData
//*
//*****************************************************************************
void CMainFrame::OnUpdateData()
{
CDiskView	*view;
CHexWnd		*hex;
char		*mem;
int			 mem_max;
int			 mem_addr;
int			 mem_laenge;
int			 mem_offset;


	if(!m_wndDataBar.IsVisible())return;

		view=(CDiskView*)GetActiveView();
	if(!view)return;

	hex	 =view->GetHexWnd();
	mem  =(char*)hex->GetMem(&mem_max,&mem_addr);
	mem_offset  =hex->GetCursor();

	if(hex->IsSelected())
		{
		hex->GetSelection(0,&mem_laenge);
		}
	else{
		mem_laenge=mem_max-mem_offset;
		}


	m_wndData.SetMem(mem,mem_max,mem_offset,mem_laenge,mem_addr);


}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CMainFrame::OnSize( UINT nType, int cx, int cy )
{
CRect	rect;

	CFrameWnd::OnSize(nType,cx,cy);

	if(IsWindow(m_wndDataBar.m_hWnd))
		{
		m_wndDataBar.GetWindowRect(&rect);rect.right++;
		DockControlBar(&m_wndDataBar,(UINT)0,rect);
		}
}

//*****************************************************************************
//*
//*		OnDataWndTab
//*
//*****************************************************************************
void CMainFrame::OnDataWndTab(int Offset,int Id,int Len)
{
CDiskView	*view;
CHexWnd		*hex;


		view=(CDiskView*)GetActiveView();
	if(!view)return;

	hex = view->GetHexWnd();

	view->SetFocus();

	if(Len>0 && Len<256)
		{
		hex->SetCursor   (Offset);
		hex->SetSelection(Offset+Len);
		}
	else{
		hex->SetCursor(Offset);
		}

}

//*****************************************************************************
//*
//*		OnFlatBarUI
//*
//*****************************************************************************
void CMainFrame::OnFlatBarUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bFlatMode);
}


//*****************************************************************************
//*
//*		OnFlatBar
//*
//*****************************************************************************
void CMainFrame::OnFlatBar()
{
DWORD	dwStyle;


	dwStyle=(m_bFlatMode)? TBSTYLE_FLAT:0;
	m_wndToolBar.ModifyStyle(dwStyle,dwStyle^TBSTYLE_FLAT);
	m_bFlatMode=(dwStyle)? 0:1;

	if(m_wndToolBar.GetStyle()&WS_VISIBLE)
		{
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
		ShowControlBar(&m_wndToolBar,TRUE ,FALSE);
		}


}
