//*****************************************************************************
//*
//*
//*		SectionDlg.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"DiskViewer.h"
#include	"SectionDlg.h"
#include	"AfxUtility.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CSectionDlg, CDialog)
	//{{AFX_MSG_MAP(CSectionDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON1, OnPath)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//*****************************************************************************
//*
//*		Dialogfeld CSectionDlg
//*
//*****************************************************************************
CSectionDlg::CSectionDlg(CWnd *pParent)
	: CDialog(CSectionDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CSectionDlg)
	m_sPath = _T("");
	m_sBegin = _T("");
	m_sCount = _T("");
	m_sTitle = _T("");
	//}}AFX_DATA_INIT

	m_bSave   = 0;
	m_uSector = 0;
	m_uCount  = 0;
	m_uFormat = 0;

}



//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CSectionDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSectionDlg)
	DDX_Text(pDX, IDC_EDIT1, m_sPath);
	DDX_Text(pDX, IDC_EDIT2, m_sBegin);
	DDX_Text(pDX, IDC_EDIT3, m_sCount);
	DDX_Text(pDX, IDC_TITLE, m_sTitle);
	//}}AFX_DATA_MAP
}




//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
// Behandlungsroutinen fr Nachrichten CSectionDlg

BOOL CSectionDlg::OnInitDialog()
{

	if(m_uFormat==0)SetButtonBitmap(this,IDC_BUTTON1,IDB_OPEN);

	SetWindowText((m_bSave)? "Sektoren speichern":"Sektoren laden");
	m_sBegin.Format("%I64u",m_uSector);
	m_sCount.Format("%u"   ,m_uCount);
	SetDlgItemText(IDC_MAXSEC,m_sMax);

	CDialog::OnInitDialog();

	return TRUE;
}


//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CSectionDlg::OnOK()
{

	UpdateData();

	if(m_bSave && ExistFile(m_sPath))
		{
		CString sText;

		sText.Format("Die Datei %s existiert bereits !\nSoll sie berschrieben werden ?",(LPCSTR)m_sPath);
		if(MessageBox(sText,"DiskViewer",MB_ICONWARNING|MB_OKCANCEL)!=IDOK)return;
		}

	if(!m_bSave && ExistFile(m_sPath)!=1)
		{
		CString sText;

		sText.Format("Die Datei %s existiert nicht !\n",(LPCSTR)m_sPath);
		MessageBox(sText,"DiskViewer",MB_ICONERROR|MB_OK);
		return;
		}

	strcalc(m_sBegin,(__int64*)&m_uSector);
	strcalc(m_sCount,(  int  *)&m_uCount );

	CDialog::OnOK();
}



//*****************************************************************************
//*
//*		OnPath
//*
//*****************************************************************************
void CSectionDlg::OnPath()
{
int iFlags;

	UpdateData();

	iFlags =OFN_EXPLORER|OFN_ENABLESIZING|OFN_HIDEREADONLY;
	if(!m_bSave)iFlags|=OFN_PATHMUSTEXIST;

	CFileDialog sDlg(!m_bSave,".bin",m_sPath,iFlags,"Alle Image-Formate |*.bin;*.iso|Binrdatei   (*.bin)|*.bin|CD-Image   (*.iso)|*.iso|Alle Dateien|*.*|");

	if(sDlg.DoModal()!=IDOK)return;
	m_sPath=sDlg.GetPathName();

	UpdateData(FALSE);
}


//*****************************************************************************
//*
//*		DoModal
//*
//*****************************************************************************
INT_PTR CSectionDlg::DoModal()
{
	if(m_uFormat==1)
		{
		m_lpszTemplateName = MAKEINTRESOURCE(IDD_SECTIONDLG1);
		m_nIDHelp = IDD_SECTIONDLG1;
		}

return CDialog::DoModal();
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CSectionDlg::OnDestroy()
{
	CDialog::OnDestroy();

	if(m_uFormat==0)DelButtonBitmap(this,IDC_BUTTON1);

}

