//*****************************************************************************
//*
//*
//*		CDiskView Klasse
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#include 	"StdAfx.h"
#include	"Resource.h"
#include 	"HexDlg.h"
#include 	"TextDlg.h"
#include	"DiskDoc.h"
#include	"DiskView.h"
#include	"SetInfoDlg.h"
#include	"ChsDlg.h"
#include	"MbrDlg.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	ID_HEXWND		0x1002
#define 	ID_TXTWND		0x1003

IMPLEMENT_DYNCREATE(CDiskView, CView)

BEGIN_MESSAGE_MAP(CDiskView, CView)
	//{{AFX_MSG_MAP(CDiskView)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_WM_DROPFILES()
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_INFO_ACTION			,OnInfo)
	ON_COMMAND(ID_EDIT_COPY				,OnCopy)
	ON_COMMAND(ID_EDIT_PASTE            ,OnPaste)
	ON_COMMAND(ID_MOVETO				,OnMoveTo)
	ON_COMMAND(ID_CPP_COPY				,OnCppCopy)
	ON_COMMAND(ID_EDIT_FIND   			,OnFindView)
	ON_COMMAND(ID_EDIT_FIND_NEXT		,OnFindNext)
	ON_COMMAND(ID_CHECKSUM				,OnChecksum)
	ON_COMMAND(ID_CREATEMBR				,OnMbrCreate)
	ON_COMMAND(ID_HEX_CONVERT			,OnHexConvert)
	ON_COMMAND(ID_EDIT_FIND_WORD		,OnSuchenMarke)
	ON_COMMAND(ID_SETINFOTYPE			,OnSetInfoType)
	ON_COMMAND(ID_CHSCONVERT			,OnChsToSector)
	ON_UPDATE_COMMAND_UI(ID_CPP_COPY    ,OnMenuMarkeH)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY   ,OnMenuSelection)
	//}}AFX_MSG_MAP
	ON_NOTIFY(ANSI_SETFOCUS,ID_HEXWND	,OnAnsiSetFocus)
	ON_NOTIFY(ANSI_SETFOCUS,ID_TXTWND	,OnAnsiSetFocus)
END_MESSAGE_MAP()

typedef struct
	{
	unsigned	uType;
	char	   *pName;
	}PartitionName;

typedef struct
	{
	char	   *pName;
	DWORD		uGuid0;
	WORD		uGuid1;
	WORD		uGuid2;
	WORD		uGuid3;
	BYTE		uGuid4;
	BYTE		uGuid5;
	BYTE		uGuid6;
	BYTE		uGuid7;
	BYTE		uGuid8;
	BYTE		uGuid9;
	}PartitionList;


PartitionName	sPNames[]=
	{
	0x01,"FAT12",
	0x02,"Xenix",
	0x03,"Xenix",
	0x04,"FAT16 (max. 32 MB)",
	0x05,"extended DOS-Partition  (max. 2 GB)",
	0x06,"FAT16 (max. 2 GB)",
	0x07,"HPFS/NTFS",
	0x08,"AIX",
	0x09,"AIX bootable",
	0x0A,"OS/2 Bootmanager",
	0x0B,"FAT32 (CHS Adressierung)",
	0x0C,"FAT32 (LBA Adressierung)",
	0x0E,"FAT16 (LBA Adressierung)",
	0x0F,"extended Partition  (LBA,mehr als 1024 Zylinder)",
	0x10,"OPUS",
	0x11,"hidden FAT12",
	0x12,"Compaq diagnost",
	0x14,"hidden FAT16 bis 32MB",
	0x16,"hidden FAT16",
	0x17,"hidden HPFS / NTFS",
	0x18,"AST Windows swap",
	0x1B,"hidden WIN95 FAT32",
	0x1C,"hidden WIN95 FAT32 (LBA)",
	0x1E,"hidden WIN95 FAT16 (LBA)",
	0x24,"NEC DOS",
	0x39,"Plan 9",
	0x3C,"Partition Magic",
	0x40,"Venix 80286",
	0x41,"PPC PReP boot",
	0x42,"SFS",
	0x4D,"QNX4.x",
	0x4E,"QNX4.x 2nd partition",
	0x4F,"QNX4.x 3rd partition",
	0x50,"OnTrack DM",
	0x51,"OnTrack DM6 Aux",
	0x52,"CP/M",
	0x53,"OnTrack DM6 Aux",
	0x54,"OnTrack DM6",
	0x55,"EZ-Drive",
	0x56,"Golden Bow",
	0x5c,"Priam Edisk",
	0x61,"Speed Stor",
	0x63,"GNU HURD or SYS",
	0x64,"Novell NetWare",
	0x65,"Novell",
	0x70,"Disk Secure Mult",
	0x75,"UNIX PC/IX",
	0x80,"aktiv (old Minix)",
	0x81,"Booten von Laufwerk D:",
	0x82,"Linux Swap",
	0x83,"Linux native",
	0x84,"OS/2 hidden C:",
	0x85,"LINUX extended",
	0x86,"NTFS volume set",
	0x87,"NTFS volume set",
	0x8e,"LINUX LVM",
	0x93,"Amoebla",
	0x94,"Amoebla BBT",
	0x9F,"BSD/OS",
	0xA0,"IBM Thinkpad hidden",
	0xA5,"BSD/386",
	0xA6,"Open BSD",
	0xA7,"NeXT STEP",
	0xB7,"BSDI fs",
	0xB8,"BSDI swap",
	0xC1,"DRDOS/sec (FAT32)",
	0xC4,"DRDOS/sec (FAT32(LB))",
	0xC6,"DRDOS/sec (FAT16(LB))",
	0xC7,"Syrinx",
	0xDA,"Non-Fs data",
	0xDB,"Concurrent DOS , CP/M , CTOS",
	0xDE,"Dell Utility",
	0xE1,"DOS access",
	0xE3,"DOS R/O",
	0xE4,"Speed Stor",
	0xEB,"BeOS fs",
	0xEE,"EFI GPT",
	0xEF,"EFI (FAT12/16/32)",
	0xF1,"Speed Stor",
	0xF2,"DOS secondary",
	0xF4,"Speed Stor",
	0xFD,"LINUX raid auto",
	0xFE,"LANstep",
	0xFF,"BBT",
	0,0
	};


PartitionList	aPartTypes[]=
	{
	"Unbenutzt" 									,0x00000000,0x0000,0x0000,0x0000,0x00,0x00,0x00,0x00,0x00,0x00,
	"Intel Fast Flash (iFFS) Partition"				,0xD3BFE2DE,0x3DAF,0x11DF,0xBA40,0xE3,0xA5,0x56,0xD8,0x95,0x93,
	"MBR" 											,0x024DEE41,0x33E7,0x11D3,0x9D69,0x00,0x08,0xC7,0x81,0xF3,0x9F,
	"EFI-Systempartition (ESP)"			 			,0xC12A7328,0xF81F,0x11D2,0xBA4B,0x00,0xA0,0xC9,0x3E,0xC9,0x3B,
	"BIOS-Bootpartition" 							,0x21686148,0x6449,0x6E6F,0x744E,0x65,0x65,0x64,0x45,0x46,0x49,
	"Microsoft reservierte Partition (MSR)"			,0xE3C9E316,0x0B5C,0x4DB8,0x817D,0xF9,0x2D,0xF0,0x02,0x15,0xAE,
	"Microsoft Wiederherstellungspartition" 		,0xDE94BBA4,0x06D1,0x4D40,0xA16A,0xBF,0xD5,0x01,0x79,0xD6,0xAC,
	"Basic Data Partition" 							,0xEBD0A0A2,0xB9E5,0x4433,0x87C0,0x68,0xB6,0xB7,0x26,0x99,0xC7,
	"Logical Disk Manager Partition fr Meta-Daten"	,0x5808C8AA,0x7E8F,0x42E0,0x85D2,0xE1,0xE9,0x04,0x34,0xCF,0xB3,
	"Logical Disk Manager Partition fr Daten" 		,0xAF9B60A0,0x1431,0x4F62,0xBC68,0x33,0x11,0x71,0x4A,0x69,0xAD,
	"HP-UX 	Partition fr HP-UX-LVM" 				,0x75894C1E,0x3AEB,0x11D3,0xB7C1,0x7B,0x03,0xA0,0x00,0x00,0x00,
	"Service Partition" 							,0xE2A1E728,0x32E3,0x11D6,0xA682,0x7B,0x03,0xA0,0x00,0x00,0x00,
	"Linux Datapartition (old)"						,0xEBD0A0A2,0xB9E5,0x4433,0x87C0,0x68,0xB6,0xB7,0x26,0x99,0xC7,
	"Linux Datapartition" 							,0x0FC63DAF,0x8483,0x4772,0x8E79,0x3D,0x69,0xD8,0x47,0x7D,0xE4,
	"/home partition" 								,0x933AC7E1,0x2EB4,0x4F13,0xB844,0x0E,0x14,0xE2,0xAE,0xF9,0x15,
	"RAID partition"							 	,0xA19D880F,0x05FC,0x4D3B,0xA006,0x74,0x3F,0x0F,0x84,0x91,0x1E,
	"Swap partition" 								,0x0657FD6D,0xA4AB,0x43C4,0x84E5,0x09,0x33,0xC8,0x4B,0x4F,0x4F,
	"Partition fr Linux-LVM" 						,0xE6D6D379,0xF507,0x44C2,0xA23C,0x23,0x8F,0x2A,0x3D,0xF9,0x28,
	"plain dm-crypt Partition" 						,0x7FFEC5C9,0x2D00,0x49B7,0x8941,0x3E,0xA1,0x0A,0x55,0x86,0xB7,
	"LUKS Partition" 								,0xCA7D7CCB,0x63ED,0x4C53,0x861C,0x17,0x42,0x53,0x60,0x59,0xCC,
	"Reserved" 										,0x8DA63339,0x0007,0x60C0,0xC436,0x08,0x3A,0xC8,0x23,0x09,0x08,
	"FreeBSD Data partition" 						,0x516E7CB4,0x6ECF,0x11D6,0x8FF8,0x00,0x02,0x2D,0x09,0x71,0x2B,
	"Swap partition" 								,0x516E7CB5,0x6ECF,0x11D6,0x8FF8,0x00,0x02,0x2D,0x09,0x71,0x2B,
	"Unix File System (UFS)" 						,0x516E7CB6,0x6ECF,0x11D6,0x8FF8,0x00,0x02,0x2D,0x09,0x71,0x2B,
	"Partition fr FreeBSD-LVM (Vinum)"				,0x516E7CB8,0x6ECF,0x11D6,0x8FF8,0x00,0x02,0x2D,0x09,0x71,0x2B,
	"ZFS partition" 								,0x516E7CBA,0x6ECF,0x11D6,0x8FF8,0x00,0x02,0x2D,0x09,0x71,0x2B,
	"Mac OS X (HFS+)" 								,0x48465300,0x0000,0x11AA,0xAA11,0x00,0x30,0x65,0x43,0xEC,0xAC,
	"Partition fr UFS" 							,0x55465300,0x0000,0x11AA,0xAA11,0x00,0x30,0x65,0x43,0xEC,0xAC,
	"Partition fr CoreStorage (verschlsselt)" 	,0x53746F72,0x6167,0x11AA,0xAA11,0x00,0x30,0x65,0x43,0xEC,0xAC,
	"Partition eines Fusion Drive"					,0x53746F72,0x6167,0x11AA,0xAA11,0x00,0x30,0x65,0x43,0xEC,0xAC,
	"Partition fr Boot-Untersttzung" 				,0x426F6F74,0x0000,0x11AA,0xAA11,0x00,0x30,0x65,0x43,0xEC,0xAC,
	"Partition fr Software-RAID" 					,0x52414944,0x0000,0x11AA,0xAA11,0x00,0x30,0x65,0x43,0xEC,0xAC,
	"Partition fr Apple TV Recovery" 				,0x5265636F,0x7665,0x11AA,0xAA11,0x00,0x30,0x65,0x43,0xEC,0xAC,
	"Solaris Boot partition" 						,0x6A82CB45,0x1DD2,0x11B2,0x99A6,0x08,0x00,0x20,0x73,0x66,0x31,
	"Root partition"							 	,0x6A85CF4D,0x1DD2,0x11B2,0x99A6,0x08,0x00,0x20,0x73,0x66,0x31,
	"Swap partition" 								,0x6A87C46F,0x1DD2,0x11B2,0x99A6,0x08,0x00,0x20,0x73,0x66,0x31,
	"Backup partition" 								,0x6A8B642B,0x1DD2,0x11B2,0x99A6,0x08,0x00,0x20,0x73,0x66,0x31,
	"/usr partition" 								,0x6A898CC3,0x1DD2,0x11B2,0x99A6,0x08,0x00,0x20,0x73,0x66,0x31,
	"/var partition" 								,0x6A8EF2E9,0x1DD2,0x11B2,0x99A6,0x08,0x00,0x20,0x73,0x66,0x31,
	"/home partition" 								,0x6A90BA39,0x1DD2,0x11B2,0x99A6,0x08,0x00,0x20,0x73,0x66,0x31,
	"EFI_ALTSCTR" 									,0x6A9283A5,0x1DD2,0x11B2,0x99A6,0x08,0x00,0x20,0x73,0x66,0x31,
	"Reservierte Partition"							,0x6A945A3B,0x1DD2,0x11B2,0x99A6,0x08,0x00,0x20,0x73,0x66,0x31,
	"Reservierte Partition"							,0x6A9630D1,0x1DD2,0x11B2,0x99A6,0x08,0x00,0x20,0x73,0x66,0x31,
	"Reservierte Partition"							,0x6A980767,0x1DD2,0x11B2,0x99A6,0x08,0x00,0x20,0x73,0x66,0x31,
	"Reservierte Partition"							,0x6A96237F,0x1DD2,0x11B2,0x99A6,0x08,0x00,0x20,0x73,0x66,0x31,
	"Reservierte Partition"							,0x6A8D2AC7,0x1DD2,0x11B2,0x99A6,0x08,0x00,0x20,0x73,0x66,0x31,
	0
	};

const char	*aGtpTypes[] =
	{
	"00000000-0000-0000-0000-00000000000000"		,"Unused entry",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C701"		,"FAT-12",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C704"		,"FAT-16 < 32MB",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C706"		,"FAT-16",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C707"		,"NTFS",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C70b"		,"FAT-32",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C70c"		,"FAT-32 LBA",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C70e"		,"FAT-16 LBA",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C711"		,"FAT-12 (versteckt)",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C714"		,"FAT-16 < 32MB (versteckt)",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C716"		,"FAT-16 (versteckt)",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C717"		,"NTFS (oder HPFS) (versteckt)",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C71b"		,"FAT-32 (versteckt)",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C71c"		,"FAT-32 LBA (versteckt)",
	"EBD0A0A2-B9E5-4433-87C0-68B6B72699C71e"		,"FAT-16 LBA (versteckt)",
	"E3C9E316-0B5C-4DB8-817D-F92DF00215AE0c"		,"Windows (EFI) (FAT-32 LBA)",
	"DE94BBA4-06D1-4D40-A16A-BFD50179D6AC27"		,"Windows RE",
	"7412F7D5-A156-4B13-81DC-86717492932530"		,"ONIE boot",
	"D4E6E2CD-4469-46F3-B5CB-1BFF57AFC14930"		,"ONIE config",
	"9E1A2D38-C612-4316-AA26-8B49521E5A8B41"		,"PowerPC PReP boot",
	"AF9B60A0-1431-4F62-BC68-3311714A69AD42"		,"Windows LDM data",
	"5808C8AA-7E8F-42E0-85D2-E1E90434CFB342"		,"Windows LDM metadata",
	"E75CAF8F-F680-4CEE-AFA3-B001E56EFC2D42"		,"Windows Storage Spaces",
	"37AFFC90-EF7D-4E96-91C3-2D7AE055B17475"		,"IBM GPFS",
	"FE3A2A5D-4F32-41A7-B725-ACCC3285A3097f"		,"Chromebook",
	"3CB8E202-3B7E-47DD-8A3C-7FF2A13CFCEC7f"		,"ChromeOS root",
	"2E0A753D-9E48-43B0-8337-B15192CB1B5E7f"		,"ChromeOS reserved",
	"0657FD6D-A4AB-43C4-84E5-0933C84B4F4F82"		,"Linux swap",
	"0FC63DAF-8483-4772-8E79-3D69D8477DE483"		,"Linux native filesystem",
	"8DA63339-0007-60C0-C436-083AC823090883"		,"Linux reserved",
	"933AC7E1-2EB4-4F13-B844-0E14E2AEF91583"		,"Linux home",
	"44479540-F297-41B2-9AF7-D131D5F0458A83"		,"Linux x86 root",
	"4F68BCE3-E8CD-4DB1-96E7-FBCAF984B70983"		,"Linux x86-64 root",
	"B921B045-1DF0-41C3-AF44-4C6F280D3FAE83"		,"Linux ARM64 root",
	"3B8F8425-20E0-4F3B-907F-1A25A76F98E883"		,"Linux /srv",
	"D3BFE2DE-3DAF-11DF-BA40-E3A556D8959384"		,"Intel Rapid Start",
	"E6D6D379-F507-44C2-A23C-238F2A3DF9288e"		,"Linux LVM",
	"516E7CB4-6ECF-11D6-8FF8-00022D09712Ba5"		,"FreeBSD Disklabel",
	"83BD6B9D-7F41-11DC-BE0B-001560B84F0Fa5"		,"FreeBSD boot",
	"516E7CB5-6ECF-11D6-8FF8-00022D09712Ba5"		,"FreeBSD swap",
	"516E7CB6-6ECF-11D6-8FF8-00022D09712Ba5"		,"FreeBSD UFS",
	"516E7CBA-6ECF-11D6-8FF8-00022D09712Ba5"		,"FreeBSD ZFS",
	"516E7CB8-6ECF-11D6-8FF8-00022D09712Ba5"		,"FreeBSD Vinum/RAID",
	"85D5E45A-237C-11E1-B4B3-E89A8F7FC3A7a5"		,"MidnightBSD data",
	"85D5E45E-237C-11E1-B4B3-E89A8F7FC3A7a5"		,"MidnightBSD boot",
	"85D5E45B-237C-11E1-B4B3-E89A8F7FC3A7a5"		,"MidnightBSD swap",
	"0394EF8B-237E-11E1-B4B3-E89A8F7FC3A7a5"		,"MidnightBSD UFS",
	"85D5E45D-237C-11E1-B4B3-E89A8F7FC3A7a5"		,"MidnightBSD ZFS",
	"85D5E45C-237C-11E1-B4B3-E89A8F7FC3A7a5"		,"MidnightBSD Vinum",
	"824CC7A0-36A8-11E3-890A-952519AD3F61a6"		,"OpenBSD data",
	"55465300-0000-11AA-AA11-00306543ECACa8"		,"Apple UFS",
	"516E7CB4-6ECF-11D6-8FF8-00022D09712Ba9"		,"FreeBSD Disklabel",
	"49F48D32-B10E-11DC-B99B-0019D1879648a9"		,"NetBSD swap",
	"49F48D5A-B10E-11DC-B99B-0019D1879648a9"		,"NetBSD FFS",
	"49F48D82-B10E-11DC-B99B-0019D1879648a9"		,"NetBSD LFS",
	"2DB519C4-B10F-11DC-B99B-0019D1879648a9"		,"NetBSD concatenated",
	"2DB519EC-B10F-11DC-B99B-0019D1879648a9"		,"NetBSD encrypted",
	"49F48DAA-B10E-11DC-B99B-0019D1879648a9"		,"NetBSD RAID",
	"426F6F74-0000-11AA-AA11-00306543ECACab"		,"Apple boot",
	"48465300-0000-11AA-AA11-00306543ECACaf"		,"Apple HFS/HFS+",
	"52414944-0000-11AA-AA11-00306543ECACaf"		,"Apple RAID",
	"52414944-5F4F-11AA-AA11-00306543ECACaf"		,"Apple RAID offline",
	"4C616265-6C00-11AA-AA11-00306543ECACaf"		,"Apple Label",
	"5265636F-7665-11AA-AA11-00306543ECACaf"		,"AppleTV Recovery",
	"53746F72-6167-11AA-AA11-00306543ECACaf"		,"Apple Core Storage",
	"6A82CB45-1DD2-11B2-99A6-080020736631be"		,"Solaris 	Solaris boot",
	"6A85CF4D-1DD2-11B2-99A6-080020736631bf"		,"Solaris root",
	"6A898CC3-1DD2-11B2-99A6-080020736631bf"		,"Solaris /usr",
	"6A87C46F-1DD2-11B2-99A6-080020736631bf"		,"Solaris swap",
	"6A8B642B-1DD2-11B2-99A6-080020736631bf"		,"Solaris backup",
	"6A8EF2E9-1DD2-11B2-99A6-080020736631bf"		,"Solaris /var",
	"6A90BA39-1DD2-11B2-99A6-080020736631bf"		,"Solaris /home",
	"6A9283A5-1DD2-11B2-99A6-080020736631bf"		,"Solaris alternate sector",
	"6A945A3B-1DD2-11B2-99A6-080020736631bf"		,"Solaris Reserved",
	"6A9630D1-1DD2-11B2-99A6-080020736631bf"		,"Solaris Reserved",
	"6A980767-1DD2-11B2-99A6-080020736631bf"		,"Solaris Reserved",
	"6A96237F-1DD2-11B2-99A6-080020736631bf"		,"Solaris Reserved",
	"6A8D2AC7-1DD2-11B2-99A6-080020736631bf"		,"Solaris Reserved",
	"75894C1E-3AEB-11D3-B7C1-7B03A0000000c0"		,"HP-UX data",
	"E2A1E728-32E3-11D6-A682-7B03A0000000c0"		,"HP-UX service",
	"BC13C2FF-59E6-4262-A352-B275FD6F7172ea"		,"Freedesktop $BOOT",
	"42465331-3BA3-10F1-802A-4861696B7521eb"		,"Haiku BFS",
	"BFBFAFE7-A34F-448A-9A5B-6213EB736C22ed"		,"Lenovo system partition",
	"F4019732-066E-4E12-8273-346C5641494Fed"		,"Sony system partition",
	"C12A7328-F81F-11D2-BA4B-00A0C93EC93Bef"		,"EFI System (ESP)",
	"024DEE41-33E7-11D3-9D69-0008C781F39Fef"		,"MBR partition scheme",
	"21686148-6449-6E6F-744E-656564454649ef"		,"BIOS boot partition",
	"4FBD7E29-9D25-41B8-AFD0-062C0CEFF05Df8"		,"Ceph OSD",
	"4FBD7E29-9D25-41B8-AFD0-5EC00CEFF05Df8"		,"Ceph dm-crypt OSD",
	"45B0969E-9B03-4F30-B4C6-B4B80CEFF106f8"		,"Ceph journal",
	"45B0969E-9B03-4F30-B4C6-5EC00CEFF106f8"		,"Ceph dm-crypt journal",
	"89C57F98-2FE5-4DC0-89C1-F3AD0CEFF2BEf8"		,"Ceph disk in creation",
	"89C57F98-2FE5-4DC0-89C1-5EC00CEFF2BEf8"		,"Ceph dm-crypt disk in creation",
	"AA31E02A-400F-11DB-9590-000C2911D1B8fb"		,"VMware ESX/VMFS",
	"9198EFFC-31C0-11DB-8F78-000C2911D1B8fb"		,"VMware reserved",
	"9D275380-40AD-11DB-BF97-000C2911D1B8fc"		,"VMware kcore crash protection",
	"A19D880F-05FC-4D3B-A006-743F0F84911Efd"		,"Linux RAID",
	0
	};


#define 	ADD_LINE(p,v)		cTxtWnd.AddInfo(((char*)(&(v)))-((char*)(p)),sizeof(v),cTxtWnd.GetLineCount()  -1)
#define 	ADD_BYTE(p,v,n)		cTxtWnd.AddInfo(((char*)(&(v)))-((char*)(p)),n        ,cTxtWnd.GetLineCount()  -1)
#define 	ADD_INFO(p,v,s,n,m)	cTxtWnd.AddInfo(((char*)(&(v)))-((char*)(p)),s        ,cTxtWnd.GetLineCount(),n,m)
#define 	HILO(a)				(((QWORD)a##Lo)+(((QWORD)a##Hi)<<32))


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CDiskView::CDiskView()
{

	iViewPos	  = 300;
	bInit		  = FALSE;
	iActiveWnd	  = 0;
	iLockType	  = 0;
	iStatusBarId  = 0;

	cBrush1.CreateSolidBrush(GetSysColor(COLOR_3DSHADOW));
	cBrush2.CreateSolidBrush(GetSysColor(COLOR_3DFACE));
	cBrush3.CreateSolidBrush(GetSysColor(COLOR_3DLIGHT));

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CDiskView::~CDiskView()
{

}


//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CDiskView::PreCreateWindow(CREATESTRUCT& sCreate)
{
	sCreate.dwExStyle |= WS_EX_ACCEPTFILES;

	return CView::PreCreateWindow(sCreate);
}

//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
BOOL CDiskView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& sRect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext)
{

	if(!CWnd::Create(lpszClassName, lpszWindowName, dwStyle, sRect, pParentWnd, nID, pContext))
		return FALSE;

	SetClassLongPtr(m_hWnd,GCLP_HCURSOR      ,(LPARAM)LoadCursor(0 , IDC_SIZENS));
	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,(LPARAM)GetStockObject(NULL_BRUSH));



	cHexWnd.Create(WS_VISIBLE,sRect,this,ID_HEXWND);
	cTxtWnd.Create(WS_VISIBLE,sRect,this,ID_TXTWND);
	cTxtWnd.SetCanModify(FALSE);


	cTxtWnd.ColorAdd(RGB(0,0,255)  ,0xFFFFFFFF,"Blau"  ,10);
	cTxtWnd.ColorAdd(RGB(128,0,0)  ,0xFFFFFFFF,"Rot"   ,11);
	cTxtWnd.ColorAdd(RGB(0,128,0)  ,0xFFFFFFFF,"Grn"  ,12);
	cTxtWnd.ColorAdd(RGB(0,128,128),0xFFFFFFFF,"Trkis",13);
	cTxtWnd.ColorAdd(RGB(255,0,0)  ,0xFFFFFFFF,"Fehler",14);
	cTxtWnd.ColorAdd(RGB(0,192,0)  ,0xFFFFFFFF,"OK"    ,15);



return TRUE;
}


//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
void CDiskView::OnDraw(CDC *pDC)
{

	CDiskDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	DrawSeparator(pDC,iViewPos,10000,TRUE);

}


//*****************************************************************************
//*
//*		Debug Funktionen
//*
//*****************************************************************************
#ifdef _DEBUG
void CDiskView::AssertValid() const
{
	CView::AssertValid();
}

void CDiskView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDiskDoc* CDiskView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDiskDoc)));
	return (CDiskDoc*)m_pDocument;
}
#endif


//*****************************************************************************
//*
//*		GetMark
//*
//*****************************************************************************
//	Speichert die markierte Adresse in pAttr
//	Ergibt TRUE wenn ein Bereich markiert ist.
BOOL CDiskView::GetMark(QWORD *pAttr)
{
char	cText[256];


	if(iActiveWnd && cTxtWnd.IsSelected() && !cHexWnd.IsSelected())
		{
		cTxtWnd.TextCopy(cText,sizeof(cText));
		strcalc(cText,(__int64*)pAttr);
		return TRUE;
		}

	if(cHexWnd.IsSelected())
		{
		*pAttr=0;
		cHexWnd.GetSelection(pAttr,sizeof(DWORD));
		return TRUE;
		}


return FALSE;
}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CDiskView::OnSize(UINT nType, int cx, int cy)
{
CRect	sRect;


	GetClientRect(&sRect);
	cx=sRect.right;
	cy=sRect.bottom;

	if(cx && cy)
		{
		CRect	sRect1,sRect2;

		if(iViewPos+100>cy)iViewPos=cy-100;
		if(iViewPos    < 0)iViewPos=cy;

		sRect1.SetRect(0,0         ,cx,iViewPos);
		sRect2.SetRect(0,iViewPos+7,cx,cy     );

		if(IsWindow(cHexWnd.m_hWnd))cHexWnd.MoveWindow(sRect1);
		if(IsWindow(cTxtWnd.m_hWnd))cTxtWnd.MoveWindow(sRect2);
		}

}

//*****************************************************************************
//*
//*		OnLButtonDown
//*
//*****************************************************************************
void CDiskView::OnLButtonDown(UINT nFlags, CPoint cPoint)
{
CPoint	cMovePt;
CRect	sRect,sRect1,sRect2;
int		i,x,y;


	GetRectView  (sRect );
	GetClientRect(sRect1);


	cMovePt      =cPoint;
	cMovePt.y   -=iViewPos;

		i=Resize(this,FALSE,sRect,iViewPos,cMovePt,7,5);
	if(!i)return;

	GetClientRect(&sRect);
	iViewPos+=i;

	x=sRect.right;
	y=sRect.bottom;

				  sRect1.bottom-=6;
	if(iViewPos >=sRect1.bottom)iViewPos =sRect1.bottom-1;
				  sRect1.bottom-=7;
	if(iViewPos <0)iViewPos =0;

	if(iViewPos> y)iViewPos=y-100;
	if(iViewPos< 0)iViewPos=y;

	sRect1.SetRect(0,0         ,x,iViewPos);
	sRect2.SetRect(0,iViewPos+7,x,y       );

	if(IsWindow(cHexWnd.m_hWnd))cHexWnd.MoveWindow(sRect1);
	if(IsWindow(cTxtWnd.m_hWnd))cTxtWnd.MoveWindow(sRect2);

	RedrawWindow();

}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CDiskView::OnDestroy()
{
	if(bInit)
		{
		STATUSBAR_DEL(iStatusBarId);
		bInit=FALSE;
		}

	CView::OnDestroy();

}

//*****************************************************************************
//*
//*		OnDropFiles
//*
//*****************************************************************************
void CDiskView::OnDropFiles(HDROP hDropInfo)
{
TCHAR		cFile[MAX_PATH];
CDocument  *pDoc;
int			iNum;


		pDoc = GetDocument();
	if(!pDoc)
		{
		DragFinish(hDropInfo);
		return;
		}

	iNum = DragQueryFile(hDropInfo,0,cFile,MAX_PATH);
	DragFinish(hDropInfo);


	if(iNum>0)
		{
		if(pDoc->SaveModified())
			{
			pDoc->OnOpenDocument(cFile);
			}
		}


}

//*****************************************************************************
//*
//*		OnUpdate
//*
//*****************************************************************************
void CDiskView::OnUpdate(CView *pSender,LPARAM lHint,CObject *pHint)
{
CDiskDoc	*pDoc;
int			 iType;
void		*pData;
DWORD		 dwClSize;
DWORD		 dwSize,dwLen,dwPos;
QWORD		 qwSecNum,qwClStart;
QWORD		 qwClMin ,qwSecBase;


		pDoc=GetDocument();
	if(!pDoc)return;

	if(lHint&0x80000000)						// Nur einen Bereich markieren ?
		{
		if(lHint==0xFFFFF100)					// Schreibschutz entfernen
			{
			cHexWnd.SetFlags(0,HEX_NOT_CHANGE);
			return;
			}

		if(lHint==0xFFFFF200)					// Schreibschutz herstellen
			{
			cHexWnd.SetFlags(HEX_NOT_CHANGE,HEX_NOT_CHANGE);
			return;
			}

		dwLen= lHint&0xFF;
		dwPos=(lHint>>8)&0x7FFFFF;
		cHexWnd.Select(0,dwPos,dwLen);
		cHexWnd.SetCursor(dwPos);
		cHexWnd.SetSelection (dwPos+dwLen);
		return;
		}


	pData	= pDoc->GetData();
	dwSize	= pDoc->GetSectorSize();
	cHexWnd.SetMem(pData,dwSize);
	cTxtWnd.MaxSize(dwSize);


	if(lHint&0xFF)								// Einen Bereich markieren
		{
		dwLen=lHint&0xFF;
		dwPos=lHint>>8;
		cHexWnd.Select(0,dwPos,dwLen);
		cHexWnd.SetCursor(dwPos);
		cHexWnd.SetSelection (dwPos+dwLen);
		}


	if(!bInit && AfxGetMainWnd())				// Statusbar initialisieren
		{
		UINT	aId [] = {0x40,0x41};
		UINT	aBrt[] = {25*7,25*7};
		STATUSBAR_ADD(aId,aBrt,2,iStatusBarId);
		if(iStatusBarId)bInit=TRUE;
		}

	if(bInit)									// Sektornummer ausgeben
		{
		CString sText;

		qwSecNum  = pDoc->GetSectorNumber ();
		qwSecBase = pDoc->GetPartitionBase();
		qwClStart = pDoc->GetClusterStart ();
		dwClSize  = pDoc->GetClusterSize  ();
		qwClMin   = pDoc->GetClusterMin   ();

		if(pDoc->GetDrive()==0xC000)
			{
			sText.Format("(Img) Sektor %I64i ",qwSecNum);
			}
		else if(pDoc->GetDrive()&0x8000)
			{
			sText.Format("(Phys %i) Sektor %I64i",pDoc->GetDrive()&0xFF,qwSecNum);
			}
		else{
			sText.Format("(%c:) Sektor %I64i",'A'+pDoc->GetDrive(),qwSecNum);
			}

		STATUSBAR_SET(iStatusBarId>>16,sText,true);

		if(dwClSize>0 && qwSecNum>=qwClStart)
			{
			sText.Format(" Cl:%I64i Sec %I64i",(qwSecNum-qwClStart)/(QWORD)dwClSize+qwClMin,qwSecNum-qwSecBase);
			}
		else{
			sText.Format(" Rel.Sec %I64i",qwSecNum-qwSecBase);
			}

		STATUSBAR_SET((iStatusBarId>>16)+1,sText,true);
		}

	if(lHint==0x00100000)return;

	cTxtWnd.TextClear(0,0,0,1000);
	cTxtWnd.DelInfo();

	iType=pDoc->GetSectorType();
	if(!iType)iType=iLockType;

	switch(iType)
		{
	case TYPE_BOOT:		SetBoot     (pData,dwSize);	break;
	case TYPE_BOOT32:	SetBoot32   (pData,dwSize);	break;
	case TYPE_BOOTNTFS:	SetBootNtfs (pData,dwSize);	break;
	case TYPE_BOOTEXFAT:SetBootExFat(pData,dwSize);	break;
	case TYPE_FAT12:	SetFat12    (pData,dwSize);	break;
	case TYPE_FAT16:	SetFat16    (pData,dwSize);	break;
	case TYPE_FAT32:	SetFat32    (pData,dwSize);	break;
	case TYPE_FATEX:	SetFatEx    (pData,dwSize);	break;
	case TYPE_INFO:		SetInfo     (pData,dwSize);	break;
	case TYPE_DIR:		SetDir      (pData,dwSize);	break;
	case TYPE_MBR:		SetMbr		(pData,dwSize);	break;
	case TYPE_VDESC:	SetVDesc	(pData,dwSize);	break;
	case TYPE_PTABLE:	SetPTable	(pData,dwSize);	break;
	case TYPE_CDDIR:	SetCdDir	(pData,dwSize);	break;
	case TYPE_MFT:		SetMft		(pData,dwSize);	break;
	case TYPE_MFTMIR:	SetMft		(pData,dwSize);	break;
	case TYPE_ECMA:		SetEcma		(pData,dwSize);	break;
	case TYPE_GPT:		SetGpt		(pData,dwSize);	break;
	case TYPE_GPTLIST:	SetGptList	(pData,dwSize);	break;
	case TYPE_EXFATDIR:	SetExFatDir	(pData,dwSize);	break;
	case TYPE_SUPERBLK:	SetSuperBlk	(pData,dwSize);	break;
		}

	cTxtWnd.SetCursor(0,0);
	cTxtWnd.SetSelection(0,0);
	cTxtWnd.DrawView(0);

}

//*****************************************************************************
//*
//*		SetBoot32
//*
//*****************************************************************************
void CDiskView::SetBoot32(void *pData,DWORD dwSize)
{
BootRecord32   *pBoot=(BootRecord32*)pData;
char			cText[256],cLabel[16],cSystem[16],cOemName[16];
unsigned char   ucFarben[256];
int				i;

	cTxtWnd.TextInsert("\n BOOT-SEKTOR FAT32\n\n",0,1000);

	strlcpy(cLabel	,pBoot->bLabel   ,sizeof(pBoot->bLabel   )+1);
	strlcpy(cSystem	,pBoot->cSystemID,sizeof(pBoot->cSystemID)+1);
	strlcpy(cOemName,pBoot->cOEMName ,sizeof(pBoot->cOEMName )+1);

    sprintf(cText,"  OEMName            : %s"     ,       cOemName                );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->cOEMName);
    sprintf(cText,"  BytesPerSector     : %i"     ,pBoot->wBytesPerSector         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wBytesPerSector);
    sprintf(cText,"  SectorsPerCluster  : %i"     ,pBoot->bSectorsPerCluster      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bSectorsPerCluster);
    sprintf(cText,"  ReservedSectors    : %i"     ,pBoot->wReservedSectors        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wReservedSectors);
    sprintf(cText,"  NumberOfFATs       : %i"     ,pBoot->bNumberOfFATs           );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bNumberOfFATs);
    sprintf(cText,"  DirEntries         : %i"     ,pBoot->wDirEntries             );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wDirEntries);
    sprintf(cText,"  SectorsOnDisk      : %i"     ,pBoot->wSectorsOnDisk          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSectorsOnDisk);
    sprintf(cText,"  MediaDescriptor    : %02Xh"  ,pBoot->bMediaDescriptor        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bMediaDescriptor);
    sprintf(cText,"  SectorsPerFAT      : %i"     ,pBoot->wSectorsPerFAT          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSectorsPerFAT);
    sprintf(cText,"  SectorsPerTrack    : %i"     ,pBoot->wSectorsPerTrack        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSectorsPerTrack);
    sprintf(cText,"  NumberOfHeads      : %i"     ,pBoot->wNumberOfHeads          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wNumberOfHeads);
    sprintf(cText,"  HiddenSectors      : %i"     ,pBoot->dwNumberOfHiddenSectors );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwNumberOfHiddenSectors);
    sprintf(cText,"  TotalSectors       : %i"     ,pBoot->dwTotalSectors          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwTotalSectors);
    sprintf(cText,"  SectorsPerFAT      : %i"     ,pBoot->dwSectorsPerFAT         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwSectorsPerFAT);
    sprintf(cText,"  Flags              : %04Xh"  ,pBoot->wFlags                  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wFlags);
    sprintf(cText,"  Version            : %04Xh"  ,pBoot->wVersion                );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wVersion);
    sprintf(cText,"  RootDirCluster     : %08Xh"  ,pBoot->dwRootDirCluster        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwRootDirCluster);
    sprintf(cText,"  InfoSector         : %i"     ,pBoot->wFSInfoSector           );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wFSInfoSector);
    sprintf(cText,"  BackupBootSector   : %i"     ,pBoot->wBackupBootSector       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wBackupBootSector);
    sprintf(cText,"  PhysicalDiskNumber : %02Xh"  ,pBoot->bPhysicalDiskNumber     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bPhysicalDiskNumber);
    sprintf(cText,"  CurrentHead        : %i"     ,pBoot->bCurrentHead            );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bCurrentHead);
    sprintf(cText,"  Signature          : %02Xh"  ,pBoot->bSignature              );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bSignature);
    sprintf(cText,"  SerialNumber       : %08Xh"  ,pBoot->dwSerialNumber          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwSerialNumber);
    sprintf(cText,"  Label              : %s"     ,       cLabel                  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bLabel);
    sprintf(cText,"  SystemID           : %s"     ,       cSystem                 );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->cSystemID);
    sprintf(cText,"  Signature          : %04Xh"  ,pBoot->wSignature              );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSignature);

	memset(ucFarben,10,64);
	cTxtWnd.SetColor(1,ucFarben,64);
	memset(ucFarben   , 0,20);
	memset(ucFarben+22,11,20);
	ucFarben[21]=12;

	for(i=3;i<4+30;i++)cTxtWnd.SetColor(i,ucFarben,64);

}

//*****************************************************************************
//*
//*		SetBootNtfs
//*
//*****************************************************************************
void CDiskView::SetBootNtfs(void *pData,DWORD dwSize)
{
BootRecordNtfs *pBoot=(BootRecordNtfs*)pData;
char			cText[256],cOemName[16];
unsigned char   ucFarben[256];
int				i;

	cTxtWnd.TextInsert("\n BOOT-SEKTOR NTFS\n\n",0,1000);

	strlcpy(cOemName,pBoot->cOEMName ,sizeof(pBoot->cOEMName)+1);

    sprintf(cText,"  OEMName            : %s"     ,       cOemName                );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->cOEMName);
    sprintf(cText,"  BytesPerSector     : %i"     ,pBoot->wBytesPerSector         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wBytesPerSector);
    sprintf(cText,"  SectorsPerCluster  : %i"     ,pBoot->bSectorsPerCluster      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bSectorsPerCluster);
    sprintf(cText,"  ReservedSectors    : %i"     ,pBoot->wReservedSectors        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wReservedSectors);
    sprintf(cText,"  SectorsOnDisk      : %i"     ,pBoot->wSectorsOnDisk          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSectorsOnDisk);
    sprintf(cText,"  MediaDescriptor    : %02Xh"  ,pBoot->bMediaDescriptor        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bMediaDescriptor);
    sprintf(cText,"  SectorsPerTrack    : %i"     ,pBoot->wSectorsPerTrack        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSectorsPerTrack);
    sprintf(cText,"  NumberOfHeads      : %i"     ,pBoot->wNumberOfHeads          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wNumberOfHeads);
    sprintf(cText,"  HiddenSectors      : %i"     ,pBoot->dwNumberOfHiddenSectors );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwNumberOfHiddenSectors);
    sprintf(cText,"  PhysicalDiskNumber : %02Xh"  ,pBoot->bPhysicalDiskNumber     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bPhysicalDiskNumber);
    sprintf(cText,"  CurrentHead        : %i"     ,pBoot->bCurrentHead            );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bCurrentHead);
    sprintf(cText,"  Signature          : %02Xh"  ,pBoot->bSignature              );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bSignature);
    sprintf(cText,"  TotalSectors       : %I64i"  ,pBoot->qwTotalSectors		  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->qwTotalSectors);
    sprintf(cText,"  MtfCluster         : %I64i"  ,pBoot->qwMtfCluster		      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->qwMtfCluster);
    sprintf(cText,"  MtfMirrorCluster   : %I64i"  ,pBoot->qwMtfMirrorCluster	  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->qwMtfMirrorCluster);
    sprintf(cText,"  ClusterPerRecord   : %i"     ,pBoot->dwClusterPerRecord	  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwClusterPerRecord);
    sprintf(cText,"  ClusterPerIndexBl. : %i"     ,pBoot->dwClusterPerIndexBlock  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwClusterPerIndexBlock);
	sprintf(cText,"  CheckSum           : %08X"   ,pBoot->dwCheckSum			  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwCheckSum);
    sprintf(cText,"  SerialNumber       : %016I64Xh",pBoot->qwSerialNumber        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->qwSerialNumber);
    sprintf(cText,"  Signature          : %04Xh"  ,pBoot->wSignature              );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSignature);



	memset(ucFarben,10,64);
	cTxtWnd.SetColor(1,ucFarben,64);
	memset(ucFarben   , 1,20);
	memset(ucFarben+22,11,20);
	ucFarben[21]=12;

	for(i=3;i<4+30;i++)cTxtWnd.SetColor(i,ucFarben,64);

}

//*****************************************************************************
//*
//*		SetBootExFat
//*
//*****************************************************************************
void CDiskView::SetBootExFat(void *pData,DWORD dwSize)
{
BootRecordExFat*pBoot=(BootRecordExFat*)pData;
char			cText[256],cSecSize[16],cSpcSize[16],cOemName[16],cVersion[16];
unsigned char   ucFarben[256];
unsigned		uSecSize;
int				i;

	cTxtWnd.TextInsert("\n BOOT-SEKTOR EXFAT\n\n",0,1000);

	sprintf(cVersion,"%i.%i",pBoot->bVersionMajor,pBoot->bVersionMinor);
	strlcpy(cOemName,pBoot->cOEMName ,sizeof(pBoot->cOEMName )+1);
	uSecSize = 1<<pBoot->bSectorBits;
	vtostr ((__int64)1<<pBoot->bSectorBits,cSecSize,VTS_ADDSUFFIX|VTS_ADDSPACE|VTS_BIN10|0x8300,VTS_BYTESUFFIX);
	vtostr ((__int64)uSecSize<<pBoot->bSpcBits   ,cSpcSize,VTS_ADDSUFFIX|VTS_ADDSPACE|VTS_BIN10|0x8300,VTS_BYTESUFFIX);

    sprintf(cText,"  OEMName            : %s"     ,       cOemName                );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->cOEMName);
    sprintf(cText,"  BytesPerSector     : %i"     ,pBoot->wBytesPerSector         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wBytesPerSector);
    sprintf(cText,"  SectorsPerCluster  : %i"     ,pBoot->bSectorsPerCluster      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bSectorsPerCluster);
    sprintf(cText,"  ReservedSectors    : %i"     ,pBoot->wReservedSectors        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wReservedSectors);
    sprintf(cText,"  NumberOfFATs       : %i"     ,pBoot->bNumberOfFATs           );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bNumberOfFATs);
    sprintf(cText,"  DirEntries         : %i"     ,pBoot->wDirEntries             );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wDirEntries);
    sprintf(cText,"  SectorsOnDisk      : %i"     ,pBoot->wSectorsOnDisk          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSectorsOnDisk);
    sprintf(cText,"  MediaDescriptor    : %02Xh"  ,pBoot->bMediaDescriptor        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bMediaDescriptor);
    sprintf(cText,"  SectorsPerFAT      : %i"     ,pBoot->wSectorsPerFAT          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSectorsPerFAT);
    sprintf(cText,"  SectorsPerTrack    : %i"     ,pBoot->wSectorsPerTrack        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSectorsPerTrack);
    sprintf(cText,"  NumberOfHeads      : %i"     ,pBoot->wNumberOfHeads          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wNumberOfHeads);
    sprintf(cText,"  HiddenSectors      : %i"     ,pBoot->dwNumberOfHiddenSectors );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwNumberOfHiddenSectors);
    sprintf(cText,"  TotalSectors       : %i"     ,pBoot->dwTotalSectors          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwTotalSectors);
    sprintf(cText,"  SectorsPerFAT      : %i"     ,pBoot->dwSectorsPerFAT         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwSectorsPerFAT);
    sprintf(cText,"  Flags              : %04Xh"  ,pBoot->wFlags                  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wFlags);
    sprintf(cText,"  Version            : %04Xh"  ,pBoot->wVersion                );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wVersion);
    sprintf(cText,"  RootDirClusterFAT  : %08Xh"  ,pBoot->dwRootDirDummy          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwRootDirCluster);
    sprintf(cText,"  InfoSector         : %i"     ,pBoot->wFSInfoSector           );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wFSInfoSector);
    sprintf(cText,"  BackupBootSector   : %i"     ,pBoot->wBackupBootSector       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wBackupBootSector);
	sprintf(cText,"  SectorStart        : %I64i"  ,pBoot->qwSectorStart			  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->qwSectorStart);
    sprintf(cText,"  SectorCount        : %I64i"  ,pBoot->qwSectorCount           );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->qwSectorCount);
    sprintf(cText,"  FatSectorStart     : %i"	  ,pBoot->dwFatSectorStart        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwFatSectorStart);
    sprintf(cText,"  FatSectorCount     : %i"     ,pBoot->dwFatSectorCount        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwFatSectorCount);
    sprintf(cText,"  ClusterSectorStart : %i"	  ,pBoot->dwClusterSectorStart    );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwClusterSectorStart);
    sprintf(cText,"  ClusterCount       : %i"     ,pBoot->dwClusterCount		  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwClusterCount);
	sprintf(cText,"  RootDirCluster     : %i"     ,pBoot->dwRootDirCluster        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwClusterCount);
	sprintf(cText,"  VolumeSerial       : %08Xh"  ,pBoot->dwVolumeSerial		  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwVolumeSerial);
	sprintf(cText,"  Version            : %s"     ,       cVersion		          );cTxtWnd.TextInsert(cText,0,1000);ADD_BYTE(pBoot,pBoot->bVersionMinor,2);
	sprintf(cText,"  VolumeStateFlags   : %04Xh"  ,pBoot->wVolumeState			  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wVolumeState);
    sprintf(cText,"  SectorBits         : %i (%s)",pBoot->bSectorBits, cSecSize   );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bSectorBits);
	sprintf(cText,"  SectorsPerCluster  : %i (%s)",pBoot->bSpcBits   , cSpcSize   );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bSpcBits);
	sprintf(cText,"  FatCount           : %i"     ,pBoot->bFatCount               );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bFatCount);
    sprintf(cText,"  PhysicalDiskNumber : %02Xh"  ,pBoot->bDriveNumber            );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bDriveNumber);
	sprintf(cText,"  AllocatedPercent   : %i"     ,pBoot->bAllocatedPercent       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bAllocatedPercent);
    sprintf(cText,"  Signature          : %04Xh"  ,pBoot->wSignature              );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSignature);


	memset(ucFarben,10,64);
	cTxtWnd.SetColor(1,ucFarben,64);
	memset(ucFarben   , 0,20);
	memset(ucFarben+22,11,20);
	ucFarben[21]=12;

	for(i=3;i<4+35;i++)cTxtWnd.SetColor(i,ucFarben,64);

}

//*****************************************************************************
//*
//*		SetBoot
//*
//*****************************************************************************
void CDiskView::SetBoot(void *pData,DWORD dwSize)
{
BootRecord16   *pBoot=(BootRecord16*)pData;
char			cText[256],cLabel[16],cSystem[16],cOemName[16];
unsigned char   ucFarben[256];
int				i;


	cTxtWnd.TextInsert("\n BOOT-SEKTOR FAT12/FAT16\n\n",0,1000);

	strlcpy(cLabel	,pBoot->bLabel   ,sizeof(pBoot->bLabel   )+1);
	strlcpy(cSystem	,pBoot->cSystemID,sizeof(pBoot->cSystemID)+1);
	strlcpy(cOemName,pBoot->cOEMName ,sizeof(pBoot->cOEMName )+1);

    sprintf(cText,"  OEMName            : %s"     ,       cOemName                );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->cOEMName);
    sprintf(cText,"  BytesPerSector     : %i"     ,pBoot->wBytesPerSector         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wBytesPerSector);
    sprintf(cText,"  SectorsPerCluster  : %i"     ,pBoot->bSectorsPerCluster      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bSectorsPerCluster);
    sprintf(cText,"  ReservedSectors    : %i"     ,pBoot->wReservedSectors        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wReservedSectors);
    sprintf(cText,"  NumberOfFATs       : %i"     ,pBoot->bNumberOfFATs           );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bNumberOfFATs);
    sprintf(cText,"  DirEntries         : %i"     ,pBoot->wDirEntries             );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wDirEntries);
    sprintf(cText,"  SectorsOnDisk      : %i"     ,pBoot->wSectorsOnDisk          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSectorsOnDisk);
    sprintf(cText,"  MediaDescriptor    : %02Xh"  ,pBoot->bMediaDescriptor        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bMediaDescriptor);
    sprintf(cText,"  SectorsPerFAT      : %i"     ,pBoot->wSectorsPerFAT          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSectorsPerFAT);
    sprintf(cText,"  SectorsPerTrack    : %i"     ,pBoot->wSectorsPerTrack        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSectorsPerTrack);
    sprintf(cText,"  NumberOfHeads      : %i"     ,pBoot->wNumberOfHeads          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wNumberOfHeads);
    sprintf(cText,"  HiddenSectors      : %i"     ,pBoot->dwNumberOfHiddenSectors );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwNumberOfHiddenSectors);
    sprintf(cText,"  TotalSectors       : %i"     ,pBoot->dwTotalSectors          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwTotalSectors);
    sprintf(cText,"  PhysicalDiskNumber : %02Xh"  ,pBoot->bPhysicalDiskNumber     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bPhysicalDiskNumber);
    sprintf(cText,"  CurrentHead        : %i"     ,pBoot->bCurrentHead            );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bCurrentHead);
    sprintf(cText,"  Signature          : %02Xh"  ,pBoot->bSignature              );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bSignature);
    sprintf(cText,"  SerialNumber       : %08Xh"  ,pBoot->dwSerialNumber          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->dwSerialNumber);
    sprintf(cText,"  Label              : %s"     ,       cLabel                  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->bLabel);
    sprintf(cText,"  SystemID           : %s"     ,       cSystem                 );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->cSystemID);
    sprintf(cText,"  Signature          : %04Xh"  ,pBoot->wSignature              );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pBoot,pBoot->wSignature);


	memset(ucFarben,10,64);
	cTxtWnd.SetColor(1,ucFarben,64);
	memset(ucFarben   , 0,20);
	memset(ucFarben+22,11,20);
	ucFarben[21]=12;

	for(i=3;i<4+30;i++)cTxtWnd.SetColor(i,ucFarben,64);

}

//*****************************************************************************
//*
//*		SetFat12
//*
//*****************************************************************************
void CDiskView::SetFat12(void *pData,DWORD dwSize)
{
int				i,j,iEnd;
char			cText[256];
DWORD			dwValue;
QWORD			qwStart;
BYTE			ucFarben[256];
BYTE		   *pByte=(BYTE*)pData;
CDiskDoc	   *pDoc;



		pDoc=GetDocument();
	if(!pDoc)return;

	cTxtWnd.TextInsert("\n FAT12\n\n",0,1000);
	iEnd=dwSize/2;

	qwStart  = pDoc->GetSectorNumber();
	qwStart -= pDoc->GetFATStart();
	qwStart %= pDoc->GetFATSize();
	qwStart *= pDoc->GetSectorSize();

	dwValue  = *(DWORD*)pByte;
	cText[0] = 0;

	switch(qwStart%3)
		{
	case 0:	i=12;	j=sprintf(cText,"  %03X"  ,dwValue&0xFFF);	break;											break;
	case 1:	i= 4;	j=sprintf(cText,"  %01X??",dwValue&0x00F);	break;
	case 2:	i= 8;	j=sprintf(cText,"  %02X?" ,dwValue&0x0FF);	break;
		}


	iEnd = pDoc->GetSectorSize()*8-8;

	for(;i<iEnd;i+=12)
		{
		dwValue  = *(DWORD*)(pByte+(i>>3));
		dwValue>>= i&7;
		j+=sprintf(cText+j,"  %03X",dwValue&0xFFF);
		if(j>=5*16){j=0;cTxtWnd.TextInsert(cText,0,1000);}
		}

	dwValue  = *(DWORD*)(pByte+(i>>3));
	dwValue>>= i&7;

	switch(iEnd+8-i)
		{
	case 4:	j=sprintf(cText+j,"  ??%01X",dwValue&0x00F);	break;
	case 8:	j=sprintf(cText+j,"  ?%02X" ,dwValue&0x0FF);	break;
		}

	if(j)cTxtWnd.TextInsert(cText,0,1000);

	memset(ucFarben,10,64);
	cTxtWnd.SetColor(1,ucFarben,64);

}

//*****************************************************************************
//*
//*		SetFat16
//*
//*****************************************************************************
void CDiskView::SetFat16(void *pData,DWORD dwSize)
{
int				i,j,iEnd;
WORD		   *pWord=(WORD*)pData;
char			cText[256];
unsigned char   ucFarben[256];


	cTxtWnd.TextInsert("\n FAT16\n\n",0,1000);
	iEnd=dwSize/2;
	cText[0]=0;

	for(i=0;i<iEnd;i++)
		{
		if((i&15)==0){j=0;cTxtWnd.TextInsert(cText,0,1000);}
		j+=sprintf(cText+j,"  %04X",pWord[i]);
		}

	memset(ucFarben,10,64);
	cTxtWnd.SetColor(1,ucFarben,64);

}

//*****************************************************************************
//*
//*		SetFat32
//*
//*****************************************************************************
void CDiskView::SetFat32(void *pData,DWORD dwSize)
{
int				i,j,iEnd;
char			cText[256];
DWORD		   *pDword=(DWORD*)pData;
DWORD			dwValue;
unsigned char   ucFarben[256];


	cTxtWnd.TextInsert("\n FAT32\n\n",0,1000);
	iEnd=dwSize/4;
	cText[0]=0;

	for(i=0;i<iEnd;i++)
		{
		dwValue=pDword[i];
		if((i&7)==0){j=0;cTxtWnd.TextInsert(cText,0,1000);}
		j+=sprintf(cText+j,"  %01X:%07X",dwValue>>28,dwValue&0xFFFFFFF);
		}

	memset(ucFarben,10,64);
	cTxtWnd.SetColor(1,ucFarben,64);

}

//*****************************************************************************
//*
//*		SetFatEx
//*
//*****************************************************************************
void CDiskView::SetFatEx(void *pData,DWORD dwSize)
{
int				i,j,iEnd;
char			cText[256];
DWORD		   *pDword=(DWORD*)pData;
DWORD			dwValue;
unsigned char   ucFarben[256];


	cTxtWnd.TextInsert("\n FATEX\n\n",0,1000);
	iEnd=dwSize/4;
	cText[0]=0;

	for(i=0;i<iEnd;i++)
		{
		dwValue=pDword[i];
		if((i&7)==0){j=0;cTxtWnd.TextInsert(cText,0,1000);}
		j+=sprintf(cText+j,"  %08X",dwValue);
		}

	memset(ucFarben,10,64);
	cTxtWnd.SetColor(1,ucFarben,64);

}

//*****************************************************************************
//*
//*		SetMbr
//*
//*****************************************************************************
void CDiskView::SetMbr(void *pData,DWORD dwSize)
{
int				i,j,k;
char			cText[256];
DWORD			dwValue;
DWORD		   *pDword;
BYTE		   *pByte;
unsigned char   ucFarben[256];



	cTxtWnd.TextInsert("\n MASTER-BOOT-RECORD\n\n",0,1000);

	pByte    = (LPBYTE)pData+0x1BE;
	pDword   = (LPDWORD)pByte;
	cText[0] = 0;

	cTxtWnd.TextInsert(cText,0,1000);

	for(i=0;i<4;i++)
		{
		dwValue=pByte[3]|((pByte[2]<<2)&0x0300);
		j=sprintf(cText,"  %s  S:%3i H:%3i C:%4i  Type=%02Xh ",(pByte[0]&0x80)? "BOOT":"----",pByte[2]&0x3F,pByte[1],dwValue,pByte[4]);

		ADD_INFO(pData,pByte[0],1,  2,  2+3);
		ADD_INFO(pData,pByte[2],1,  8,  8+5);
		ADD_INFO(pData,pByte[1],1, 14, 14+5);
		ADD_INFO(pData,pByte[2],2, 20, 20+6);
		ADD_INFO(pData,pByte[4],1, 28, 28+8);

		dwValue=pByte[7]|((pByte[6]<<2)&0x0300);
		j+=sprintf(cText+j," S:%3i H:%3i C:%4i ",pByte[6]&0x3F,pByte[5],dwValue);

		ADD_INFO(pData,pByte[6],1, 38, 38+5);
		ADD_INFO(pData,pByte[5],1, 44, 44+5);
		ADD_INFO(pData,pByte[6],2, 50, 50+6);

		j+=sprintf(cText+j,"  Off:%10u   Size:%10u ",pDword[2],pDword[3]);

		ADD_INFO(pData,pDword[2],4, 59, 59+14);
		ADD_INFO(pData,pDword[3],4, 76, 76+26);

		dwValue=pDword[3]/2;


		if(dwValue<1000*1024)
			{
			j+=sprintf(cText+j,"(%3i.%01i MB) ",dwValue>>10,((dwValue&0x3FF)*10)>>10);
			}
		else if(dwValue<1000*1024*1024)
			{
			dwValue>>=10;
			j+=sprintf(cText+j,"(%3i.%01i GB) ",dwValue>>10,((dwValue&0x3FF)*10)>>10);
			}
		else{
			dwValue>>=20;
			j+=sprintf(cText+j,"(%3i.%01i TB) ",dwValue>>10,((dwValue&0x3FF)*10)>>10);
			}

		for(k=0;sPNames[k].uType;k++)				// Suche Partitions Namen
			{
			if(pByte[4]!=sPNames[k].uType)continue;
			j+=sprintf(cText+j,"   %s",sPNames[k].pName);
			break;
			}

		ADD_INFO(pData,pByte[4],1,106,106+10);

		cTxtWnd.TextInsert(cText,0,1000);

		pByte  += 16;
		pDword += 4;
		}

	memset(ucFarben,10,64);
	cTxtWnd.SetColor(1,ucFarben,64);

	memset(ucFarben  , 0,128);
	memset(ucFarben+ 2,11, 4);
	memset(ucFarben+10,11, 4);
	memset(ucFarben+16,11, 4);
	memset(ucFarben+22,11, 5);
	memset(ucFarben+33,11, 4);
	memset(ucFarben+40,11, 4);
	memset(ucFarben+46,11, 4);
	memset(ucFarben+52,11, 5);
	memset(ucFarben+63,11,13);
	memset(ucFarben+81,11,11);
	memset(ucFarben+93,11, 8);

	ucFarben[  9]=12;
	ucFarben[ 15]=12;
	ucFarben[ 21]=12;
	ucFarben[ 32]=12;
	ucFarben[ 39]=12;
	ucFarben[ 45]=12;
	ucFarben[ 51]=12;
	ucFarben[ 62]=12;
	ucFarben[ 80]=12;
	ucFarben[ 92]=12;
	ucFarben[101]=12;

	for(i=3;i<4+4;i++)cTxtWnd.SetColor(i,ucFarben,128);

	pByte   =  (LPBYTE )pData+0x1B8;
	dwValue = *(LPDWORD)pByte;


	i = cTxtWnd.GetLineCount();

	sprintf(cText,"  Signature              : %04Xh",dwValue);
	
	cTxtWnd.TextInsert(" "  ,0,1000);
	cTxtWnd.TextInsert(cText,0,1000);
	cTxtWnd.AddInfo(0x1B8,4,i+1);

	memset(ucFarben,10,64);
	cTxtWnd.SetColor(1,ucFarben,64);
	memset(ucFarben   , 0,20);
	memset(ucFarben+22,11,20);
	ucFarben[21]=12;

	cTxtWnd.SetColor(i+1,ucFarben,64);


}

//*****************************************************************************
//*
//*		SetGpt
//*
//*****************************************************************************
void CDiskView::SetGpt(void *pData,DWORD dwSize)
{
unsigned char		ucFarben[512*32];
char				cText[256];
char				cGuid[64];
char				cInfo[64];
unsigned			uCheckSum;
unsigned			uCheckPar;
const char		   *pCrcPar;
const char		   *pCrcOk;
const char		   *pLine;
GuidPartitionTable *pGuid;
CDiskDoc		   *pDoc;
int					iVal;
int					iLen;
int					iSec;
int					iNum;
int					i;



	cTxtWnd.TextInsert("\n GUID PARTITION TABLE\n\n",0,1000);

	memcpy(ucFarben,pData,256);
	pGuid				= (GuidPartitionTable*)ucFarben;
	pGuid->dwHeaderCrc	= 0;
	iLen				= pGuid->dwHeaderSize;

	if(iLen>sizeof(ucFarben))iLen=sizeof(ucFarben);

	uCheckSum			= Crc32(0xFFFFFFFF,pGuid,iLen);
	pGuid				= (GuidPartitionTable*)pData;
	uCheckSum		   ^= pGuid->dwHeaderCrc;
	pCrcOk				= (~uCheckSum)? "\xA0 WRONG":"\xA0 OK";
	iLen				= pGuid->dwUsedEntries*pGuid->dwEntrySize;
	pDoc				= GetDocument();
	iNum				= (pDoc)? pDoc->GetSectorSize():512; if(!iNum)iNum=512;
	iSec				= (iLen+iNum-1)/iNum;

	if(iSec*iNum<=sizeof(ucFarben) && pDoc && pDoc->GetReadSectors(pGuid->qwPartitionTab,iSec,ucFarben))
		{
		uCheckPar		= Crc32(0xFFFFFFFF,ucFarben,iLen);
		pCrcPar			= (uCheckPar^~pGuid->dwPartitionCrc)? "\xA0 WRONG":"\xA0 OK";
		}
	else{
		pCrcPar			= "\xA0 UNKNOWN";
		}

	cText[0]=0;
	cTxtWnd.TextInsert(cText,0,1000);

	sprintf(cGuid,"%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X",pGuid->sDiskGuid.Data1,
																	 pGuid->sDiskGuid.Data2,
																	 pGuid->sDiskGuid.Data3,
																	 pGuid->sDiskGuid.Data4[0],
																	 pGuid->sDiskGuid.Data4[1],
																	 pGuid->sDiskGuid.Data4[2],
																	 pGuid->sDiskGuid.Data4[3],
																	 pGuid->sDiskGuid.Data4[4],
																	 pGuid->sDiskGuid.Data4[5],
																	 pGuid->sDiskGuid.Data4[6],
																	 pGuid->sDiskGuid.Data4[7]);
	sprintf(cInfo,"%i.%i.%i.%i",pGuid->aRevision[0],pGuid->aRevision[1],pGuid->aRevision[2],pGuid->aRevision[3]);


    sprintf(cText,"  Signatur           : %.8s"   	,pGuid->aSignatur				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->aSignatur);
    sprintf(cText,"  Revision           : %s"		,cInfo							);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->aRevision);
    sprintf(cText,"  HeaderSize         : %i"		,pGuid->dwHeaderSize        	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->dwHeaderSize);
    sprintf(cText,"  HeaderCrc          : %08Xh%s"	,pGuid->dwHeaderCrc,pCrcOk		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->dwHeaderCrc);
    sprintf(cText,"  Reserved           : %08Xh"  	,pGuid->dwReserved				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->dwReserved);
    sprintf(cText,"  LbaPosition        : %I64i"  	,pGuid->qwLbaPosition			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->qwLbaPosition);
    sprintf(cText,"  BackupPosition     : %I64i"  	,pGuid->qwBackupPosition    	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->qwBackupPosition);
    sprintf(cText,"  FirstLba           : %I64i"  	,pGuid->qwFirstLba				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->qwFirstLba);
    sprintf(cText,"  LastLba            : %I64i"  	,pGuid->qwLastLba				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->qwLastLba);
    sprintf(cText,"  DiskGuid           : %s"     	,cGuid							);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->sDiskGuid);
    sprintf(cText,"  PartitionTab       : %I64i"  	,pGuid->qwPartitionTab      	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->qwPartitionTab);
    sprintf(cText,"  UsedEntries        : %i"     	,pGuid->dwUsedEntries			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->dwUsedEntries);
    sprintf(cText,"  EntrySize          : %I64i"  	,pGuid->dwEntrySize				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->dwEntrySize);
    sprintf(cText,"  PartitionCrc       : %08Xh%s"	,pGuid->dwPartitionCrc,pCrcPar	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pGuid->dwPartitionCrc);

	memset(ucFarben,10,64);
	cTxtWnd.SetColor(1,ucFarben,64);
	memset(ucFarben   , 1,20);
	memset(ucFarben+22,11,50);
	ucFarben[21]=12;

	for(i=3;i<4+20;i++)
		{
		pLine = cTxtWnd.GetLineText(i);

		if(pLine)
			{
			iVal = strchar(pLine,'\xA0');
			if(pLine[iVal]=='\xA0')
				{
				iVal++;if(pLine[iVal])iVal++;
				memset(ucFarben+iVal,(pLine[iVal]=='O')? 15:14,8);
				cTxtWnd.SetColor(i,ucFarben,256);
				memset(ucFarben+iVal,11,8);

				continue;
				}
			}

		cTxtWnd.SetColor(i,ucFarben,64);
		}



}

//*****************************************************************************
//*
//*		SetGptList
//*
//*****************************************************************************
void CDiskView::SetGptList(void *pData,DWORD dwSize)
{
unsigned char		ucFarben[256];
char				cText[256];
char				cGuid[64];
GuidPartitionEntry *pEntry;
PartitionList	   *pType;
const char		   *pName;
int					i,j;



	cTxtWnd.TextInsert("\n GUID PARTITION ENTRIES\n",0,1000);

	pEntry	= (GuidPartitionEntry*)pData;

	cText[0]=0;
	cTxtWnd.TextInsert(cText,0,1000);


	for(j=0;j<4;j++,pEntry++)
		{
		sprintf(cText,"\n Entry %i\n\n",j+1);
		cTxtWnd.TextInsert(cText,0,1000);
		cTxtWnd.AddInfo((char*)pEntry-(char*)pData,128,cTxtWnd.GetLineCount()-2);

		pType = aPartTypes;
		pName = "";

		sprintf(cGuid,"%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X",pEntry->sPartitionsTyp.Data1,
																		 pEntry->sPartitionsTyp.Data2,
																		 pEntry->sPartitionsTyp.Data3,
																		 pEntry->sPartitionsTyp.Data4[0],
																		 pEntry->sPartitionsTyp.Data4[1],
																		 pEntry->sPartitionsTyp.Data4[2],
																		 pEntry->sPartitionsTyp.Data4[3],
																		 pEntry->sPartitionsTyp.Data4[4],
																		 pEntry->sPartitionsTyp.Data4[5],
																		 pEntry->sPartitionsTyp.Data4[6],
																		 pEntry->sPartitionsTyp.Data4[7]);

		for(i=0;aGtpTypes[i];i+=2)
			{
			if(stricmp(cGuid,aGtpTypes[i]))continue;
			pName = aGtpTypes[i+1];
			break;
			}

		if(!*pName)											// GTP Type noch nicht gefunden
			{
			while(pType->pName)
				{
				if(!memcmp(&pEntry->sPartitionsTyp.Data1,&pType->uGuid0,16))
					{
					pName = pType->pName;
					break;
					}

				pType++;
				}
			}


		sprintf(cText,"  PartitionsTyp      : %s %s"  ,cGuid,pName				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pEntry->sPartitionsTyp);

		sprintf(cGuid,"%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X",pEntry->sPartitionsGuid.Data1,
																		 pEntry->sPartitionsGuid.Data2,
																		 pEntry->sPartitionsGuid.Data3,
																		 pEntry->sPartitionsGuid.Data4[0],
																		 pEntry->sPartitionsGuid.Data4[1],
																		 pEntry->sPartitionsGuid.Data4[2],
																		 pEntry->sPartitionsGuid.Data4[3],
																		 pEntry->sPartitionsGuid.Data4[4],
																		 pEntry->sPartitionsGuid.Data4[5],
																		 pEntry->sPartitionsGuid.Data4[6],
																		 pEntry->sPartitionsGuid.Data4[7]);

		sprintf(cText,"  PartitionsGuid     : %s"     ,cGuid					);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pEntry->sPartitionsGuid);

		cGuid[0]=0;
		if((pEntry->qwAttributes>> 0)&1)strcat(cGuid,"System "    );
		if((pEntry->qwAttributes>> 1)&1)strcat(cGuid,"EFI-Hidden ");
		if((pEntry->qwAttributes>> 2)&1)strcat(cGuid,"Bootable "  );
		if((pEntry->qwAttributes>>60)&1)strcat(cGuid,"ReadOnly "  );
		if((pEntry->qwAttributes>>62)&1)strcat(cGuid,"Hidden "    );
		if((pEntry->qwAttributes>>63)&1)strcat(cGuid,"NotMount"   );

		sprintf(cText,"  StartLba           : %I64i"       ,pEntry->qwStartLba		  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pEntry->qwStartLba);
		sprintf(cText,"  EndLba             : %I64i"       ,pEntry->qwEndLba          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pEntry->qwEndLba);
		sprintf(cText,"  Attributes         : %016I64Xh %s",pEntry->qwAttributes,cGuid);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pEntry->qwAttributes);
		sprintf(cText,"  PartitionName      : %.36S"       ,pEntry->aPartitionName	  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pEntry->aPartitionName);
		}

	memset(ucFarben,10,sizeof(ucFarben));
	cTxtWnd.SetColor(1,ucFarben,64);
	memset(ucFarben   , 1,20);
	memset(ucFarben+22,11,50);
	ucFarben[21]=12;

	for(i=3;i<4+4*9;i++)
		{
		j = (i+6)%9;
		if(j==0)cTxtWnd.SetColor(i,(LPBYTE)"\x0D\x0D\x0D\x0D\x0D\x0D\x0D\x0D\x0D\x0D\x0D\x0D\x0D\x0D\x0D\x0D\x0D\x0D\x0D\x0D",12);
		if(j <2)continue;
		cTxtWnd.SetColor(i,ucFarben,(j==6)? 40:60);
		}



}

//*****************************************************************************
//*
//*		SetInfo
//*
//*****************************************************************************
void CDiskView::SetInfo(void *pData,DWORD dwSize)
{
FAT32InfoSector *pInfo=(FAT32InfoSector*)pData;
char			 cText[256];
unsigned char    ucFarben[256];
int				 i;



	cTxtWnd.TextInsert("\n INFO-SEKTOR\n\n",0,1000);


	sprintf(cText,"  Signature1         : %08Xh"  ,pInfo->dwSignature1		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pInfo,pInfo->dwSignature1);
	sprintf(cText,"  Signature2         : %08Xh"  ,pInfo->dwSignature2		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pInfo,pInfo->dwSignature2);
	sprintf(cText,"  FreeClusterCount   : %u"     ,pInfo->dwFreeClusterCount);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pInfo,pInfo->dwFreeClusterCount);
	sprintf(cText,"  NextFreeCluster    : %08Xh"  ,pInfo->dwNextFreeCluster	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pInfo,pInfo->dwNextFreeCluster);
	sprintf(cText,"  Signature          : %08Xh"  ,pInfo->dwSignature		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pInfo,pInfo->dwSignature);


	memset(ucFarben,10,64);
	cTxtWnd.SetColor(1,ucFarben,64);
	memset(ucFarben   , 0,20);
	memset(ucFarben+22,11,20);
	ucFarben[21]=12;

	for(i=3;i<4+5;i++)cTxtWnd.SetColor(i,ucFarben,64);
}


//*****************************************************************************
//*
//*		SetDir
//*
//*****************************************************************************
void CDiskView::SetDir(void *pData,DWORD dwSize)
{
LfnDirEntry	   *pLfnEntry=(LfnDirEntry*)pData;
DirEntry	   *pDirEntry=(DirEntry*)pData;
unsigned char   ucFarben[256];
char			cBuffer[256];
char			cText[256];
char			cMode[16];
DWORD			dwValue;
int				i,j,k;
int				iEnd;


	cTxtWnd.TextInsert("\n DIRECTORY\n\n",0,1000);
	iEnd = dwSize/32;


	for(i=0;i<iEnd;i++)
		{
		if(!pDirEntry[i].cFileName[0])break;

		if(pDirEntry[i].bAttributes==0x0F)					// VFAT Eintarg fr lange Namen
			{
			cMode[i] = 0;
			strcpy(cText,"  ");
			j=2;
			cText[j]=(char)pLfnEntry[i].wName1[0];j++;
			cText[j]=(char)pLfnEntry[i].wName1[1];j++;
			cText[j]=(char)pLfnEntry[i].wName1[2];j++;
			cText[j]=(char)pLfnEntry[i].wName1[3];j++;
			cText[j]=(char)pLfnEntry[i].wName1[4];j++;
			cText[j]=(char)pLfnEntry[i].wName2[0];j++;
			cText[j]=(char)pLfnEntry[i].wName2[1];j++;
			cText[j]=(char)pLfnEntry[i].wName2[2];j++;
			cText[j]=(char)pLfnEntry[i].wName2[3];j++;
			cText[j]=(char)pLfnEntry[i].wName2[4];j++;
			cText[j]=(char)pLfnEntry[i].wName2[5];j++;
			cText[j]=(char)pLfnEntry[i].wName3[0];j++;
			cText[j]=(char)pLfnEntry[i].wName3[1];j++;
			for(k=strlen(cText);k<j;k++)cText[k]=' ';
			j+=strlcpy(cText+j,"                      -------------------  -------------------  -------- ---------",sizeof(cText)-j);

			ADD_INFO(pData,pLfnEntry[i],sizeof(pLfnEntry[i]),2,j);
			}
		else{
			cMode[i] = 1;

			strlcpy(cBuffer  ,pDirEntry[i].cFileName ,8+1);j=strcut(cBuffer);if(pDirEntry[i].cExtension[0]>' ')cBuffer[j]='.';j++;
			strlcpy(cBuffer+j,pDirEntry[i].cExtension,3+1);  strcut(cBuffer);

			j=sprintf(cText,"  %-14s  %10i ",cBuffer,pDirEntry[i].dwFileSize);

			ADD_INFO(pData,pDirEntry[i].cFileName ,sizeof(pDirEntry[i].cFileName )+3,2,2+14);
			ADD_INFO(pData,pDirEntry[i].dwFileSize,sizeof(pDirEntry[i].dwFileSize),2+14+2,2+14+2+10);

			cText[j]=(pDirEntry[i].bAttributes&0x01)? 'R':'_';j++;
			cText[j]=(pDirEntry[i].bAttributes&0x02)? 'H':'_';j++;
			cText[j]=(pDirEntry[i].bAttributes&0x04)? 'S':'_';j++;
			cText[j]=(pDirEntry[i].bAttributes&0x08)? 'V':'_';j++;
			cText[j]=(pDirEntry[i].bAttributes&0x10)? 'D':'_';j++;
			cText[j]=(pDirEntry[i].bAttributes&0x20)? 'A':'_';j++;

			ADD_INFO(pData,pDirEntry[i].bAttributes,sizeof(pDirEntry[i].bAttributes),2+14+2+10+1,2+14+2+10+1+6);

			dwValue  = pDirEntry[i].wCreateDate;
			j+=sprintf(cText+j,"  %04i.%02i.%02i",((dwValue>>9)&0x7F)+1980,(dwValue>>5)&0x0F,(dwValue>>0)&0x1F);

			ADD_INFO(pData,pDirEntry[i].wCreateDate,sizeof(pDirEntry[i].wCreateDate),2+14+2+10+1+6+2,2+14+2+10+1+6+10);

			dwValue  = (pDirEntry[i].bCreateTimeTenthSecond/100)&1;
			dwValue	+=  pDirEntry[i].wCreateTime<<1;
			j+=sprintf(cText+j," %02i:%02i:%02i",(dwValue>>12)&0x1F,(dwValue>>6)&0x3F,(dwValue>>0)&0x3F);

			ADD_INFO(pData,pDirEntry[i].bCreateTimeTenthSecond,sizeof(pDirEntry[i].wCreateTime)+1,2+14+2+10+1+6+2+10+2,2+14+2+10+1+6+10+1+8);

			dwValue  = pDirEntry[i].wWriteDate;
			j+=sprintf(cText+j,"  %04i.%02i.%02i",((dwValue>>9)&0x7F)+1980,(dwValue>>5)&0x0F,(dwValue>>0)&0x1F);

			ADD_INFO(pData,pDirEntry[i].wWriteDate,sizeof(pDirEntry[i].wWriteDate),2+14+2+10+1+6+2+10+2+8+1,2+14+2+10+1+6+10+1+8+1+10);

			dwValue	 =  pDirEntry[i].wWriteTime<<1;
			j+=sprintf(cText+j," %02i:%02i:%02i",(dwValue>>12)&0x1F,(dwValue>>6)&0x3F,(dwValue>>0)&0x3F);

			ADD_INFO(pData,pDirEntry[i].wWriteTime,sizeof(pDirEntry[i].wWriteTime),2+14+2+10+1+6+2+10+2+8+1+10+1,2+14+2+10+1+6+10+1+8+1+10+1+8);

			j+=sprintf(cText+j,"  Cluster: %04X%04Xh",pDirEntry[i].wFirstClusterHi,pDirEntry[i].wFirstCluster);

			ADD_INFO(pData,pDirEntry[i].wFirstClusterHi,sizeof(pDirEntry[i].wFirstClusterHi),2+14+2+10+1+6+2+10+2+8+1+10+1+8+11  ,2+14+2+10+1+6+2+10+2+8+1+10+1+8+11+4);
			ADD_INFO(pData,pDirEntry[i].wFirstCluster  ,sizeof(pDirEntry[i].wFirstCluster  ),2+14+2+10+1+6+2+10+2+8+1+10+1+8+11+4,2+14+2+10+1+6+2+10+2+8+1+10+1+8+11+4+4);
			}


		cTxtWnd.TextInsert(cText,0,1000);
		}

	memset(ucFarben,10,64);
	cTxtWnd.SetColor(1,ucFarben,64);


	memset(ucFarben   , 1,128);
	memset(ucFarben+ 2,13,14);
	memset(ucFarben+16,11,13);
	memset(ucFarben+37,12, 4);
	memset(ucFarben+42,12, 2);
	memset(ucFarben+45,12, 2);
	memset(ucFarben+48,10, 2);
	memset(ucFarben+51,10, 2);
	memset(ucFarben+54,10, 2);
	memset(ucFarben+58,12, 4);
	memset(ucFarben+63,12, 2);
	memset(ucFarben+66,12, 2);
	memset(ucFarben+69,10, 2);
	memset(ucFarben+72,10, 2);
	memset(ucFarben+75,10, 2);
	memset(ucFarben+88,11, 9);

	memcpy(cText,ucFarben,38);
	memset(cText+37,13  ,100);

	for(i=3;i<4+20;i++)
		{
		cTxtWnd.SetColor(i,(cMode[i-3])? ucFarben:(LPBYTE)cText,128);
		}

}

//*****************************************************************************
//*
//*		Sid
//*
//*****************************************************************************
//	Eine GUID erstellen
const char* CDiskView::Sid(const void *pData)
{
LPGUID			pGuid=(LPGUID)pData;
static	char	cBuffer[64];


	sprintf(cBuffer,"%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X",	pGuid->Data1,
																		pGuid->Data2,
																	 	pGuid->Data3,
																	 	pGuid->Data4[0],
																	 	pGuid->Data4[1],
																	 	pGuid->Data4[2],
																	 	pGuid->Data4[3],
																	 	pGuid->Data4[4],
																	 	pGuid->Data4[5],
																	 	pGuid->Data4[6],
																	 	pGuid->Data4[7]);

return cBuffer;
}

//*****************************************************************************
//*
//*		Stm
//*
//*****************************************************************************
//	Eine UTC Zeit erstellen
const char *CDiskView::Stm(time_t iTime)
{
static	char	cBuffer[64];


	strtimeset(cBuffer,iTime,STR_ALL_ISO );


return cBuffer;
}

//*****************************************************************************
//*
//*		Shx
//*
//*****************************************************************************
//	Gre eines Shift-Wertes erzeugen mit kB Angabe (uBase<<uVal)
const char *CDiskView::Shx(unsigned uVal,unsigned uBase)
{
static	char	cBuffer[64];
char			cTemp[64];


	if(!uBase)
		{
		if(!uVal)return "0  (---)";
		uBase = 1;
		}

	vtostr ((__int64)uBase<<uVal,cTemp,VTS_ADDSUFFIX|VTS_ADDSPACE|VTS_BIN10|0x8300,VTS_BYTESUFFIX);
	sprintf(cBuffer,"%u  (%s)",uVal,cTemp);


return cBuffer;
}

//*****************************************************************************
//*
//*		Str
//*
//*****************************************************************************
//	Kopiert einen String mit Lngen Beschrnkung und Unicode-Prfung
const char* CDiskView::Str(const char *pQuelle,int iMax)
{
static	char cBuffer[1024];
char 	cZeichen,*pZiel;
int		iAdd;


	pZiel=cBuffer;
	iAdd=1;

	if(iMax<=2 || pQuelle[0] || !pQuelle[1] || pQuelle[2])
		{
		cBuffer[0]=0;
		strlcpy(cBuffer,pQuelle,iMax+1);
		return cBuffer;
		}

	pQuelle++;

	for(iMax>>=1;iMax>0;iMax--)
		{
		cZeichen=pQuelle[0];
		if(!cZeichen)break;
		pZiel[0]=cZeichen;
		pZiel++;
		pQuelle+=2;
		}

	pZiel[0]=0;


return cBuffer;
}


//*****************************************************************************
//*
//*		Sdt
//*
//*****************************************************************************
//	Kopiert einen Date/Time String
const char* CDiskView::Sdt(const char *pQuelle)
{
int		iMonth;
char 	cMonth[6];
static	char *pMonth[]={"000","Jan","Feb","Mar","Apr","Mai","Jun","Jul","Aug","Feb","Okt","Nov","Dec","???","???","???","???"};
static	char  cBuffer[1024];


	if(pQuelle[0]<'0' || pQuelle[0]>'9')return "";

	strlcpy(cMonth,pQuelle+4,3);
	iMonth = atoi(cMonth)&0x0F;
	sprintf(cBuffer,"%.2s.%s.%.4s  %.2s:%.2s:%.2s.%.2s0",pQuelle+6,pMonth[iMonth],pQuelle,pQuelle+8,pQuelle+10,pQuelle+12,pQuelle+14);

return cBuffer;
}

//*****************************************************************************
//*
//*		Sat
//*
//*****************************************************************************
//	Kopiert einen Date/Time String
const char* CDiskView::Sat(DWORD dwAttr)
{
static	char	cBuffer[1024];
int				i;

	cBuffer[0]=0;
	i=0;

	if(dwAttr&FILE_ATTRIBUTE_ARCHIVE	)i+=strlcpy(cBuffer+i,"ARCHIVE "	,sizeof(cBuffer)-i);
	if(dwAttr&FILE_ATTRIBUTE_COMPRESSED	)i+=strlcpy(cBuffer+i,"COMPRESSED "	,sizeof(cBuffer)-i);
	if(dwAttr&FILE_ATTRIBUTE_DIRECTORY	)i+=strlcpy(cBuffer+i,"DIRECTORY "	,sizeof(cBuffer)-i);
	if(dwAttr&FILE_ATTRIBUTE_HIDDEN		)i+=strlcpy(cBuffer+i,"HIDDEN "		,sizeof(cBuffer)-i);
	if(dwAttr&FILE_ATTRIBUTE_READONLY	)i+=strlcpy(cBuffer+i,"READONLY "	,sizeof(cBuffer)-i);
	if(dwAttr&FILE_ATTRIBUTE_SYSTEM		)i+=strlcpy(cBuffer+i,"SYSTEM "		,sizeof(cBuffer)-i);
	if(dwAttr&FILE_ATTRIBUTE_ENCRYPTED	)i+=strlcpy(cBuffer+i,"ENCRYPTED "	,sizeof(cBuffer)-i);

return cBuffer;
}

//*****************************************************************************
//*
//*		Sft
//*
//*****************************************************************************
//	Kopiert einen File Time String
const char* CDiskView::Sft(const void *pQuelle)
{
SYSTEMTIME	  sTime;
static	char *pMonth[]={"000","Jan","Feb","Mar","Apr","Mai","Jun","Jul","Aug","Feb","Okt","Nov","Dec","???","???","???","???"};
static	char  cBuffer[1024];


	if(!FileTimeToSystemTime((LPFILETIME)pQuelle,&sTime))return "";

	sprintf(cBuffer,"%.2i.%s.%.4i  %.2i:%.2i:%.2i.%.3i",sTime.wDay,pMonth[sTime.wMonth],sTime.wYear,sTime.wHour,sTime.wMinute,sTime.wSecond,sTime.wMilliseconds);

return cBuffer;
}

//*****************************************************************************
//*
//*		Sde
//*
//*****************************************************************************
//	CD-Verzeichnis eintrag ausgeben
const char* CDiskView::Sde(DirectoryRecord *pDir,int iMax)
{
static	char  cBuffer[1024];
static	char *pMonth[]={"000","Jan","Feb","Mar","Apr","Mai","Jun","Jul","Aug","Feb","Okt","Nov","Dec","???","???","???","???"};
const   char *pName;
int		iLen;

	iMax-=33;
	if(pDir->bNameLength<iMax)iMax=pDir->bNameLength;

	pName=Str(pDir->cName,iMax);
	iLen=strlen(pName);

	if(iLen>2 && pName[iLen-1]=='1' && pName[iLen-2]==';')((char*)pName)[iLen-2]=0;

	sprintf(cBuffer,"Ex=%3i Sec=%7i Len=%12i  %02i.%s.%04i  %02i:%02i:%02i  %c%c  %s",
						pDir->bExtendedSectors,
						pDir->dwLsbSector&0xFFFFFF,
						pDir->dwLsbFileLength,
						pDir->bDay,
						pMonth[pDir->bMonth&0x0F],
						pDir->bYear+1900,
						pDir->bHour,
						pDir->bMinute,
						pDir->bSecound,
						(pDir->bFlags&0x01)? 'H':'_',
						(pDir->bFlags&0x02)? 'D':'_',
						pName);

return cBuffer;
}

//*****************************************************************************
//*
//*		EcS
//*
//*****************************************************************************
//	Erstellt einen ECMA String
const char* CDiskView::EcS(const unsigned char *pQuelle,int iMax)
{
static char		cText[512+4];
int				iPos;


	if(iMax>512)iMax=512;

	if(pQuelle[0]==16)
		{
		iMax-= 1;
		iMax/= 2;

		for(iPos=0;iPos<iMax;iPos++)
			{
			cText[iPos] = (pQuelle[2+iPos*2+1])? 255:pQuelle[2+iPos*2];
			if(!cText[iPos])break;
			}

		cText[iPos]=0;
		return cText;
		}
	else if(pQuelle[0]==8)
		{
		if(pQuelle[1])
			{
			iMax--;
			pQuelle++;
			}
		else{
			iMax-=2;
			pQuelle+=2;
			}

		strlcpy(cText,(char*)pQuelle,sizeof(cText),iMax);
		return cText;
		}

return "???";
}

//*****************************************************************************
//*
//*		EcC
//*
//*****************************************************************************
//	Erstellt einen ECMA Characterset
const char* CDiskView::EcC(const unsigned char *pQuelle)
{
static char		cText[512+4];
int				iMax=63;


	strlcpy(cText,(char*)pQuelle+1,sizeof(cText),iMax);


return cText;
}

//*****************************************************************************
//*
//*		EcT
//*
//*****************************************************************************
//	Erstellt eine ECMA Zeit
const char* CDiskView::EcT(const unsigned char *pQuelle)
{
static char		cText[512+4];


	sprintf(cText,"%04u-%02u-%02u %02u:%02u:%02u.%02u%02u%02u",*(WORD*)(pQuelle+2),pQuelle[3],pQuelle[4],pQuelle[5],pQuelle[6],pQuelle[7],pQuelle[8],pQuelle[9],pQuelle[10]);


return cText;
}

//*****************************************************************************
//*
//*		EcI
//*
//*****************************************************************************
//	Erstellt eine ECMA ID
const char* CDiskView::EcI(const unsigned char *pQuelle)
{
static char		cText[512+4];


	sprintf(cText,"%.23s",pQuelle+1);


return cText;
}

//*****************************************************************************
//*
//*		EcB
//*
//*****************************************************************************
//	Erstellt einen ECMA ICB
const char* CDiskView::EcB(const unsigned char *pQuelle)
{
static char		cText[512+4];
__int64			iVal;


	iVal  = *(__int64*)(pQuelle+4);
	iVal &= 0x0000FFFFFFFFFFFF;
	sprintf(cText,"%u - %I64u",*(unsigned*)pQuelle,iVal);


return cText;
}

//*****************************************************************************
//*
//*		EcN
//*
//*****************************************************************************
//	Erstellt einen ECMA ICB Tag
const char* CDiskView::EcN(const unsigned char *pQuelle)
{
EcmaIcb		   *pIcb=(EcmaIcb*)pQuelle;
static char		cText[512+4];



	sprintf(cText,"#%u STyp%u FTyp%u F:%04Xh",pIcb->dwDirectEntries,pIcb->wStrategyType,pIcb->bFileType,pIcb->wFlags);



return cText;
}



//*****************************************************************************
//*
//*		EcA
//*
//*****************************************************************************
//	Gibt ECMA Attribute aus
const char *CDiskView::EcA(unsigned uAttrib)
{
static char		cText[512+4];
unsigned		uPos=0;


	uPos = sprintf(cText,"%02Xh  ",uAttrib);

	if(uAttrib&0x0001)uPos+=sprintf(cText+uPos,"NOTEXIST ");
	if(uAttrib&0x0002)uPos+=sprintf(cText+uPos,"DIR "     );
	if(uAttrib&0x0004)uPos+=sprintf(cText+uPos,"DELETED " );
	if(uAttrib&0x0008)uPos+=sprintf(cText+uPos,"PARENT "  );
	if(uAttrib&0x0010)uPos+=sprintf(cText+uPos,"METADATA ");


return cText;
}

//*****************************************************************************
//*
//*		EcmaTagCrc
//*
//*****************************************************************************
BYTE CDiskView::EcmaTagCrc(void *pTagPtr)
{
LPBYTE		pTag=(LPBYTE)pTagPtr;
BYTE		bCrc;
int			iPos;


	bCrc = pTag[0];

	for(iPos=1;iPos< 4;iPos++)bCrc+=pTag[iPos];
	for(iPos=5;iPos<16;iPos++)bCrc+=pTag[iPos];


return bCrc;
}

//*****************************************************************************
//*
//*		EcmaDescCrc
//*
//*****************************************************************************
WORD CDiskView::EcmaDescCrc(const void *pMem,int iLen)
{
static const WORD aCrcTable[256] =
    {
    0x0000 , 0x1021 , 0x2042 , 0x3063 , 0x4084 , 0x50A5 , 0x60C6 , 0x70E7 ,
    0x8108 , 0x9129 , 0xA14A , 0xB16B , 0xC18C , 0xD1AD , 0xE1CE , 0xF1EF ,
    0x1231 , 0x0210 , 0x3273 , 0x2252 , 0x52B5 , 0x4294 , 0x72F7 , 0x62D6 ,
    0x9339 , 0x8318 , 0xB37B , 0xA35A , 0xD3BD , 0xC39C , 0xF3FF , 0xE3DE ,
    0x2462 , 0x3443 , 0x0420 , 0x1401 , 0x64E6 , 0x74C7 , 0x44A4 , 0x5485 ,
    0xA56A , 0xB54B , 0x8528 , 0x9509 , 0xE5EE , 0xF5CF , 0xC5AC , 0xD58D ,
    0x3653 , 0x2672 , 0x1611 , 0x0630 , 0x76D7 , 0x66F6 , 0x5695 , 0x46B4 ,
    0xB75B , 0xA77A , 0x9719 , 0x8738 , 0xF7DF , 0xE7FE , 0xD79D , 0xC7BC ,
    0x48C4 , 0x58E5 , 0x6886 , 0x78A7 , 0x0840 , 0x1861 , 0x2802 , 0x3823 ,
    0xC9CC , 0xD9ED , 0xE98E , 0xF9AF , 0x8948 , 0x9969 , 0xA90A , 0xB92B ,
    0x5AF5 , 0x4AD4 , 0x7AB7 , 0x6A96 , 0x1A71 , 0x0A50 , 0x3A33 , 0x2A12 ,
    0xDBFD , 0xCBDC , 0xFBBF , 0xEB9E , 0x9B79 , 0x8B58 , 0xBB3B , 0xAB1A ,
    0x6CA6 , 0x7C87 , 0x4CE4 , 0x5CC5 , 0x2C22 , 0x3C03 , 0x0C60 , 0x1C41 ,
    0xEDAE , 0xFD8F , 0xCDEC , 0xDDCD , 0xAD2A , 0xBD0B , 0x8D68 , 0x9D49 ,
    0x7E97 , 0x6EB6 , 0x5ED5 , 0x4EF4 , 0x3E13 , 0x2E32 , 0x1E51 , 0x0E70 ,
    0xFF9F , 0xEFBE , 0xDFDD , 0xCFFC , 0xBF1B , 0xAF3A , 0x9F59 , 0x8F78 ,
    0x9188 , 0x81A9 , 0xB1CA , 0xA1EB , 0xD10C , 0xC12D , 0xF14E , 0xE16F ,
    0x1080 , 0x00A1 , 0x30C2 , 0x20E3 , 0x5004 , 0x4025 , 0x7046 , 0x6067 ,
    0x83B9 , 0x9398 , 0xA3FB , 0xB3DA , 0xC33D , 0xD31C , 0xE37F , 0xF35E ,
    0x02B1 , 0x1290 , 0x22F3 , 0x32D2 , 0x4235 , 0x5214 , 0x6277 , 0x7256 ,
    0xB5EA , 0xA5CB , 0x95A8 , 0x8589 , 0xF56E , 0xE54F , 0xD52C , 0xC50D ,
    0x34E2 , 0x24C3 , 0x14A0 , 0x0481 , 0x7466 , 0x6447 , 0x5424 , 0x4405 ,
    0xA7DB , 0xB7FA , 0x8799 , 0x97B8 , 0xE75F , 0xF77E , 0xC71D , 0xD73C ,
    0x26D3 , 0x36F2 , 0x0691 , 0x16B0 , 0x6657 , 0x7676 , 0x4615 , 0x5634 ,
    0xD94C , 0xC96D , 0xF90E , 0xE92F , 0x99C8 , 0x89E9 , 0xB98A , 0xA9AB ,
    0x5844 , 0x4865 , 0x7806 , 0x6827 , 0x18C0 , 0x08E1 , 0x3882 , 0x28A3 ,
    0xCB7D , 0xDB5C , 0xEB3F , 0xFB1E , 0x8BF9 , 0x9BD8 , 0xABBB , 0xBB9A ,
    0x4A75 , 0x5A54 , 0x6A37 , 0x7A16 , 0x0AF1 , 0x1AD0 , 0x2AB3 , 0x3A92 ,
    0xFD2E , 0xED0F , 0xDD6C , 0xCD4D , 0xBDAA , 0xAD8B , 0x9DE8 , 0x8DC9 ,
    0x7C26 , 0x6C07 , 0x5C64 , 0x4C45 , 0x3CA2 , 0x2C83 , 0x1CE0 , 0x0CC1 ,
    0xEF1F , 0xFF3E , 0xCF5D , 0xDF7C , 0xAF9B , 0xBFBA , 0x8FD9 , 0x9FF8 ,
    0x6E17 , 0x7E36 , 0x4E55 , 0x5E74 , 0x2E93 , 0x3EB2 , 0x0ED1 , 0x1EF0 ,
    };

unsigned char  *pPtr = (unsigned char*)pMem;
unsigned char   ucByte;
WORD            uCrc=0;

    while(iLen>0)
        {
        ucByte  = (unsigned char)((uCrc>>8)^*pPtr);
        uCrc    = aCrcTable[ucByte]^(uCrc<<8);
        pPtr++;
        iLen--;
        }

return uCrc;
}

//*****************************************************************************
//*
//*		OnHexConvert
//*
//*****************************************************************************
void CDiskView::OnHexConvert()
{
	cHexWnd.OnHexConvert();
}

//*****************************************************************************
//*
//*		OnMoveTo
//*
//*****************************************************************************
void CDiskView::OnMoveTo()
{
	cHexWnd.SetFocus();
	cHexWnd.OnMoveTo();
}

//*****************************************************************************
//*
//*		OnCppCopy
//*
//*****************************************************************************
void CDiskView::OnCppCopy()
{
	cHexWnd.OnCppCopy();
}

//*****************************************************************************
//*
//*		OnChecksum
//*
//*****************************************************************************
void CDiskView::OnChecksum()
{
	cHexWnd.OnChecksum();
}

//*****************************************************************************
//*
//*		OnMenuMarkeH
//*
//*****************************************************************************
void CDiskView::OnMenuMarkeH(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(cHexWnd.IsSelected());
}

//*****************************************************************************
//*
//*		OnFindView
//*
//*****************************************************************************
void CDiskView::OnFindView()
{
	if(iActiveWnd)cTxtWnd.FindView();
	else	      cHexWnd.FindView();
}

//*****************************************************************************
//*
//*		OnFindNext
//*
//*****************************************************************************
void CDiskView::OnFindNext()
{
	if(iActiveWnd)cTxtWnd.FindNext();
	else	      cHexWnd.FindNext();
}

//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
void CDiskView::OnCopy()
{
	if(iActiveWnd)cTxtWnd.OnCopy();
	else	      cHexWnd.OnCopy();
}

//*****************************************************************************
//*
//*		OnPaste
//*
//*****************************************************************************
void CDiskView::OnPaste()
{
	if(iActiveWnd)cTxtWnd.OnPaste();
	else	      cHexWnd.OnPaste();
}

//*****************************************************************************
//*
//*		OnSetFocus
//*
//*****************************************************************************
void CDiskView::OnSetFocus( CWnd* pLastWnd)
{
	if(iActiveWnd==1)cTxtWnd.SetFocus();
	else			 cHexWnd.SetFocus();

	if(!bInit && AfxGetMainWnd())				// Statusbar initialisieren
		{
		OnUpdate(NULL,0x00100000,NULL);
		}

}

//*****************************************************************************
//*
//*		OnSuchenMarke
//*
//*****************************************************************************
void CDiskView::OnSuchenMarke()
{
	if(iActiveWnd)cTxtWnd.FindWord();
	else		  cHexWnd.FindSelection();
}

//*****************************************************************************
//*
//*		OnMenuSelection
//*
//*****************************************************************************
void CDiskView::OnMenuSelection(CCmdUI *pCmdUI)
{
	if(iActiveWnd)pCmdUI->Enable(cTxtWnd.IsSelected());
	else	      pCmdUI->Enable(cHexWnd.IsSelected());
}


//*****************************************************************************
//*
//*		OnInfo
//*
//*****************************************************************************
void CDiskView::OnInfo()
{
unsigned	uOffste;
unsigned	uSize;


		uSize = cTxtWnd.GetInfo(uOffste);
	if(!uSize)return;

	cHexWnd.SetCursor   (uOffste);
	cHexWnd.SetSelection(uOffste+uSize);


}

//*****************************************************************************
//*
//*		OnAnsiSetFocus
//*
//*****************************************************************************
//	Scroll nderung
void CDiskView::OnAnsiSetFocus(NMHDR *pNmHdr, LRESULT *pResult)
{
ANSI_NMHDR	*pHdr=(ANSI_NMHDR*)pNmHdr;


	if(pHdr->sHdr.idFrom==ID_HEXWND)iActiveWnd=0;
	if(pHdr->sHdr.idFrom==ID_TXTWND)iActiveWnd=1;

	*pResult=1;
}




//*****************************************************************************
//*
//*		OnChsToSector
//*
//*****************************************************************************
void CDiskView::OnChsToSector()
{
CChsDlg		 sDlg;
CDiskDoc	*pDoc;



		pDoc=GetDocument();
	if(!pDoc)return;

	GetDriveData(pDoc->GetDrive(),&sDlg.sDisk);
	sDlg.qwSector=pDoc->GetSectorNumber();
	GetMark(&sDlg.qwSector);
	sDlg.DoModal();

}

//*****************************************************************************
//*
//*		OnMbrCreate
//*
//*****************************************************************************
void CDiskView::OnMbrCreate()
{
CMbrDlg		 sDlg;
CDiskDoc	*pDoc;
char		 cBuffer[2048];


		pDoc=GetDocument();
	if(!pDoc)return;

	GetDriveData(pDoc->GetDrive(),&sDlg.sDisk);
	sDlg.qwSector=pDoc->GetSectorCount();
	if(sDlg.DoModal()!=IDOK)return;

	memtodump(cBuffer,sDlg.bMbr,512,HEX_NULL|HEX_DPOINT|HEX_SPACE);
	SetClipboardText(cBuffer);
	MessageBox("Ein Hex-Dump des Master-Boot-Records wurde in der Zwischenablage abgelegt","MBR");

}


//*****************************************************************************
//*
//*		OnSetInfoType
//*
//*****************************************************************************
void CDiskView::OnSetInfoType()
{
CSetInfoDlg	 cDlg;
CDiskDoc	*pDoc;
int			 iType;
void		*pData;
DWORD		 dwSize;
BOOL		 bClear=0;


		pDoc=GetDocument();
	if(!pDoc)return;

	pData	= pDoc->GetData();
	dwSize	= pDoc->GetSectorSize();

	iType=pDoc->GetSectorType();

	switch(iType)
		{
	case TYPE_BOOT:		cDlg.m_iSelect=1;	break;
	case TYPE_BOOT32:	cDlg.m_iSelect=2;	break;
	case TYPE_BOOTNTFS:	cDlg.m_iSelect=3;	break;
	case TYPE_BOOTEXFAT:cDlg.m_iSelect=4;	break;
	case TYPE_FAT12:	cDlg.m_iSelect=5;	break;
	case TYPE_FAT16:	cDlg.m_iSelect=6;	break;
	case TYPE_FAT32:	cDlg.m_iSelect=7;	break;
	case TYPE_FATEX:	cDlg.m_iSelect=8;	break;
	case TYPE_DIR:		cDlg.m_iSelect=9;	break;
	case TYPE_INFO:		cDlg.m_iSelect=10;	break;
	case TYPE_MBR:		cDlg.m_iSelect=11;	break;
	case TYPE_VDESC:	cDlg.m_iSelect=12;	break;
	case TYPE_PTABLE:	cDlg.m_iSelect=13;	break;
	case TYPE_CDDIR:	cDlg.m_iSelect=14;	break;
	case TYPE_MFT:		cDlg.m_iSelect=15;	break;
	case TYPE_MFTMIR:	cDlg.m_iSelect=16;	break;
	case TYPE_ECMA:		cDlg.m_iSelect=17;	break;
	case TYPE_GPT:		cDlg.m_iSelect=18;	break;
	case TYPE_GPTLIST:	cDlg.m_iSelect=19;	break;
	case TYPE_EXFATDIR:	cDlg.m_iSelect=20;	break;
	case TYPE_SUPERBLK:	cDlg.m_iSelect=21;	break;
	default:			cDlg.m_iSelect=0;	break;
		}

	if(cDlg.DoModal()!=IDOK)return;

	cTxtWnd.TextClear(0,0,0,1000);
	cTxtWnd.DelInfo();

	if(cDlg.m_iSelect==0)
		{
		cDlg.m_iSelect=iType;
		bClear=TRUE;
		}


	switch(cDlg.m_iSelect)
		{
	case  1:	SetBoot  	 (pData,dwSize);iLockType=TYPE_BOOT;		break;
	case  2:	SetBoot32	 (pData,dwSize);iLockType=TYPE_BOOT32;		break;
	case  3:	SetBootNtfs	 (pData,dwSize);iLockType=TYPE_BOOTNTFS;	break;
	case  4:	SetBootExFat (pData,dwSize);iLockType=TYPE_BOOTEXFAT;	break;
	case  5:	SetFat12 	 (pData,dwSize);iLockType=TYPE_FAT12;		break;
	case  6:	SetFat16 	 (pData,dwSize);iLockType=TYPE_FAT16;		break;
	case  7:	SetFat32 	 (pData,dwSize);iLockType=TYPE_FAT32;		break;
	case  8:	SetFatEx 	 (pData,dwSize);iLockType=TYPE_FATEX;		break;
	case  9:	SetDir   	 (pData,dwSize);iLockType=TYPE_DIR;			break;
	case 10:	SetInfo		 (pData,dwSize);iLockType=TYPE_INFO;		break;
	case 11:	SetMbr		 (pData,dwSize);iLockType=TYPE_MBR;			break;
	case 12:	SetVDesc	 (pData,dwSize);iLockType=TYPE_VDESC;		break;
	case 13:	SetPTable	 (pData,dwSize);iLockType=TYPE_PTABLE;		break;
	case 14:	SetCdDir	 (pData,dwSize);iLockType=TYPE_CDDIR;		break;
	case 15:	SetMft		 (pData,dwSize);iLockType=TYPE_MFT;			break;
	case 16:	SetMft		 (pData,dwSize);iLockType=TYPE_MFTMIR;		break;
	case 17:	SetEcma		 (pData,dwSize);iLockType=TYPE_ECMA;		break;
	case 18:	SetGpt		 (pData,dwSize);iLockType=TYPE_GPT;			break;
	case 19:	SetGptList   (pData,dwSize);iLockType=TYPE_GPTLIST;		break;
	case 20:	SetExFatDir  (pData,dwSize);iLockType=TYPE_EXFATDIR;	break;
	case 21:	SetSuperBlk  (pData,dwSize);iLockType=TYPE_SUPERBLK;	break;
		}

	if(bClear)iLockType=0;

	cTxtWnd.SetCursor(0,0);
	cTxtWnd.SetSelection(0,0);
	cTxtWnd.DrawView(0);
}

//*****************************************************************************
//*
//*		SetVDesc
//*
//*****************************************************************************
void CDiskView::SetVDesc(void *pData,DWORD dwSize)
{
VolumeDescriptor   *pVd=(VolumeDescriptor*)pData;
char				cText[256];
unsigned char		ucFarben[256];
int					i;




	cTxtWnd.TextInsert("\n VOLUME DESKRIPTOR\n\n",0,1000);


	sprintf(cText,"  Descriptor Type    : %02Xh",    pVd->bVDType							);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->bVDType);
	sprintf(cText,"  Descriptor ID      : %s"	,Str(pVd->cVSStdId,5)						);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cVSStdId);
	sprintf(cText,"  Descriptor Version : %i"	,    pVd->bVSStdVersion           			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->bVSStdVersion);
	sprintf(cText,"  Volume Flags       : %02Xh",    pVd->bVolumeFlags            			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->bVolumeFlags);

	if(pVd->bVDType>=1 && pVd->bVDType<=2)
	{
	sprintf(cText,"  System Identifier  : %s"	,Str(pVd->cSystemIdentifier,32)				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cSystemIdentifier);
	sprintf(cText,"  Volume Identifier  : %s"	,Str(pVd->cVolumeIdentifier,32)				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cVolumeIdentifier);
	sprintf(cText,"  Volume Size        : %i"	,    pVd->dwLsbVolumeSpaceSize    			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->dwLsbVolumeSpaceSize);
	sprintf(cText,"  Escape Sequences   : %s"	,Str(pVd->cEscapeSequences,32)				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cEscapeSequences);
	sprintf(cText,"  VolumeSet Size     : %i"	,    pVd->wLsbVolumeSetSize       			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->wLsbVolumeSetSize);
	sprintf(cText,"  VolumeSet Seq.Nr.  : %i"	,    pVd->wLsbVolumeSetSequenceNumber		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->wLsbVolumeSetSequenceNumber);
	sprintf(cText,"  Logical Block Size : %i"	,    pVd->wLsbLogicalBlockSize				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->wLsbLogicalBlockSize);
	sprintf(cText,"  PathTable Size     : %i"	,    pVd->dwLsbPathTableSize      			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->dwLsbPathTableSize);
	sprintf(cText,"  PathTable 1        : %i"	,    pVd->dwLsbPathTable1         			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->dwLsbPathTable1);
	sprintf(cText,"  PathTable 2        : %i"	,    pVd->dwLsbPathTable2					);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->dwLsbPathTable2);
	sprintf(cText,"  Root Directory     : %s"	,Sde(&pVd->sRootDirectory)	 				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->sRootDirectory);
	sprintf(cText,"  VolumeSet ID       : %s"	,Str(pVd->cVolumeSetIdentifier,128)			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cVolumeSetIdentifier);
	sprintf(cText,"  Publisher ID       : %s"	,Str(pVd->cPublisherIdentifier,128)			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cPublisherIdentifier);
	sprintf(cText,"  DataPreparer ID    : %s"	,Str(pVd->cDataPreparerIdentifier,128)		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cDataPreparerIdentifier);
	sprintf(cText,"  Application ID     : %s"	,Str(pVd->cApplicationIdentifier,128)		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cApplicationIdentifier);
	sprintf(cText,"  Copyright File ID  : %s"	,Str(pVd->cCopyrightFileIdentifier,37)		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cCopyrightFileIdentifier);
	sprintf(cText,"  Abstract File ID   : %s"	,Str(pVd->cAbstractFileIdentifier,37)		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cAbstractFileIdentifier);
	sprintf(cText,"  Bibliographic ID   : %s"	,Str(pVd->cBibliographicFileIdentifier,37)	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cBibliographicFileIdentifier);
	sprintf(cText,"  Volume Creation    : %s"	,Sdt(pVd->cVolumeCreation)					);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cVolumeCreation);
	sprintf(cText,"  Volume Modifiy     : %s"	,Sdt(pVd->cVolumeModification)				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cVolumeModification);
	sprintf(cText,"  Volume Expiration  : %s"	,Sdt(pVd->cVolumeExpiration) 				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cVolumeExpiration);
	sprintf(cText,"  Volume Effective   : %s"	,Sdt(pVd->cVolumeEffective)					);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->cVolumeEffective);
	sprintf(cText,"  FileStructure Ver. : %02Xh",    pVd->bFileStructureStandardVersion		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pData,pVd->bFileStructureStandardVersion);
	}


	memset(ucFarben,10,256);
	cTxtWnd.SetColor(1,ucFarben,256);
	memset(ucFarben   , 0, 20);
	memset(ucFarben+22,11,180);
	ucFarben[21]=12;

	for(i=3;i<4+30;i++)cTxtWnd.SetColor(i,ucFarben,256);
}



//*****************************************************************************
//*
//*		SetPTable
//*
//*****************************************************************************
void CDiskView::SetPTable(void *pData,DWORD dwSize)
{
BYTE			   *pTable=(BYTE*)pData;
DWORD				dwPos,dwValue,dwEnd,dwLen,dwNr,dwLast;
WORD				wValue1,wValue2;
char				cText[512];
unsigned char		ucFarben[512];
int					i,iOk;


	cTxtWnd.TextInsert("\n CD PFAD TABELLE\n\n",0,1000);


	dwLast=0xFFFFFFFF;

	for(dwPos=0;dwPos<dwSize-8;dwPos++)				// Suche Startposition
		{
		if(iOk)iOk=0;
		else   dwLast=0xFFFFFFFF;


		if(dwPos&1             )continue;
		if(pTable[dwPos  ]== 0 )continue;
		if(pTable[dwPos+1]&0xFE)continue;

		dwValue =*(DWORD*)(pTable+dwPos+2);
		 wValue1=*( WORD*)(pTable+dwPos+6);

		if(dwValue<(DWORD)btol_dw(dwValue))			// Intel
			{
			wValue2=(WORD)btol_w(wValue1);

			if(wValue1>wValue2     )continue;
			if(pTable[dwPos+5]     )continue;
			if(pTable[dwPos+7]&0xC0)continue;
			}
		else{										// Motorola
			wValue2=(WORD)btol_w(wValue1);

			if(wValue1<wValue2     )continue;
			if(pTable[dwPos+2]     )continue;
			if(pTable[dwPos+6]&0xC0)continue;
			}

		dwEnd=pTable[dwPos]+8+dwPos;				// Text prfen

		if(dwEnd>dwSize)dwEnd=dwSize;

		if(pTable[dwPos+8])							// Unicode ?
			{
			for(dwNr=dwPos+8;dwNr<dwEnd;dwNr++)
				{
				if(pTable[dwNr]==0)break;
				}
			}
		else{
			for(dwNr=dwPos+9;dwNr<dwEnd;dwNr+=2)
				{
				if(pTable[dwNr]==0)break;
				}
			}

		if(dwNr>=dwEnd)								// Ist Offset ok ?
			{
			if(dwLast!=0xFFFFFFFF)
				{
				dwPos=dwLast;
				break;
				}

			if(dwPos&1)dwPos++;						// Den 2. Eintrag prfen
			dwLast=dwPos;
			dwPos--;
			iOk=1;
			}
		}


//*****************************************************************************

	for(;dwPos+8<dwSize;)
		{
		if(pTable[dwPos]==0)break;

		dwValue =*(DWORD*)(pTable+dwPos+2);
		 wValue1=*( WORD*)(pTable+dwPos+6);

		if(dwValue>(DWORD)btol_dw(dwValue))			// Motorola
			{
			dwValue =btol_dw(dwValue );
			 wValue1=btol_w ( wValue1);
			}

		dwEnd=pTable[dwPos]+pTable[dwPos+1]+8+dwPos;
		if(dwEnd>dwSize)dwEnd=dwSize;
		dwLen=dwEnd-dwPos-8;

		dwValue&=0xFFFFFF;
		sprintf(cText,"  Ex=%3i Sec=%7i Parent=%5i  %s",pTable[dwPos+1],dwValue,wValue1,Str((char*)pTable+dwPos+8,dwLen));
		cTxtWnd.TextInsert(cText,0,1000);

		dwLen=pTable[dwPos];
		dwPos+=dwLen+8;
		if(dwLen&1)dwPos++;
		}



	memset(ucFarben,10,256);
	cTxtWnd.SetColor(1,ucFarben,256);

	memset(ucFarben   ,11, 35);
	memset(ucFarben+ 2, 0,  2);
	memset(ucFarben+ 9, 0,  3);
	memset(ucFarben+21, 0,  6);
	memset(ucFarben+35,13,365);
	ucFarben[ 4]=12;
	ucFarben[12]=12;
	ucFarben[27]=12;

	for(i=3;i<4+200;i++)cTxtWnd.SetColor(i,ucFarben,400);

}


//*****************************************************************************
//*
//*		SetCdDir
//*
//*****************************************************************************
void CDiskView::SetCdDir(void *pData,DWORD dwSize)
{
BYTE			   *pTable=(BYTE*)pData;
DWORD				dwPos,dwEnd,dwLen,dwNr,dwLast;
char				cText[256];
unsigned char		ucFarben[256];
DirectoryRecord    *pDir;
int					i,iOk;




	cTxtWnd.TextInsert("\n CD VERZEICHNIS\n\n",0,1000);


	dwLast=0xFFFFFFFF;

	for(dwPos=0;dwPos<dwSize-8;dwPos++)				// Suche Startposition
		{
		if(iOk)iOk=0;
		else   dwLast=0xFFFFFFFF;

		pDir=(DirectoryRecord*)(pTable+dwPos);

		if(dwPos&1)continue;
		if(pDir->bLength<34)continue;
		if(pDir->bExtendedSectors&0xFE)continue;
		if(pDir->dwLsbSector      !=(DWORD)btol_dw(pDir->dwMsbSector      ))continue;
		if(pDir->dwLsbFileLength  !=(DWORD)btol_dw(pDir->dwMsbFileLength  ))continue;
		if(pDir->wLsbVolumeSequenz!=( WORD)btol_w (pDir->wMsbVolumeSequenz))continue;

		if(!(pDir->bFlags&2) || memcmp(&pDir->bYear,"\0\0\0\0\0\0",6))
			{
			if(pDir->bYear   < 1)continue;
			if(pDir->bYear   <50)continue;
			if(pDir->bMonth  < 1)continue;
			if(pDir->bMonth  >12)continue;
			if(pDir->bDay    < 1)continue;
			if(pDir->bDay    >31)continue;
			if(pDir->bHour   >23)continue;
			if(pDir->bMinute >59)continue;
			if(pDir->bSecound>59)continue;
			}

		dwEnd=pDir->bNameLength+32+dwPos;			// Text prfen

		if(dwEnd>dwSize)dwEnd=dwSize;

		if(pDir->cName[0])							// Unicode ?
			{
			for(dwNr=dwPos+33;dwNr<dwEnd;dwNr++)
				{
				if(pTable[dwNr]==0)break;
				}
			}
		else{
			for(dwNr=dwPos+34;dwNr<dwEnd;dwNr+=2)
				{
				if(pTable[dwNr]==0)break;
				}
			}

		if(dwNr>=dwEnd)								// Ist Offset ok ?
			{
			if(dwLast!=0xFFFFFFFF)
				{
				dwPos=dwLast;
				break;
				}

			if(dwPos&1)dwPos++;						// Den 2. Eintrag prfen
			dwLast=dwPos;
			dwPos--;
			iOk=1;
			}
		}

//*****************************************************************************

	for(;dwPos+33<dwSize;)
		{
		if(pTable[dwPos]==0)break;



		   dwLen = pTable[dwPos];
		if(dwPos+dwLen>dwSize)dwLen=dwSize-dwPos;
		if(dwLen<33)break;

		pDir=(DirectoryRecord*)(pTable+dwPos);

		if(pDir->bNameLength==1 && pDir->cName[0]==0)
			{
			sprintf(cText,"  %s..",Sde(pDir,0));
			}
		else if(pDir->bNameLength==1 && pDir->cName[0]==1)
			{
			sprintf(cText,"  %s.",Sde(pDir,0));
			}
		else{
			sprintf(cText,"  %s",Sde(pDir,dwLen));
			}

		cTxtWnd.TextInsert(cText,0,1000);


		dwPos += dwLen+(dwLen&1);
		}



	memset(ucFarben,10,256);
	cTxtWnd.SetColor(1,ucFarben,256);

	memset(ucFarben   ,11, 66);
	memset(ucFarben+ 2, 0,  2);
	memset(ucFarben+ 9, 0,  3);
	memset(ucFarben+21, 0,  3);
	memset(ucFarben+62, 0,  2);
	memset(ucFarben+66,13,335);
	ucFarben[ 4]=12;
	ucFarben[12]=12;
	ucFarben[24]=12;
 	ucFarben[41]= 0;
	ucFarben[45]= 0;
	ucFarben[54]= 0;
	ucFarben[57]= 0;



	for(i=3;i<4+200;i++)cTxtWnd.SetColor(i,ucFarben,400);

}


//*****************************************************************************
//*
//*		SetMft
//*
//*****************************************************************************
void CDiskView::SetMft(void *pPtr,DWORD dwSize)
{
int					i;
CDiskDoc		   *pDoc;
BYTE				bData[1024];
char				cName[256],cText[256];
unsigned char		ucFarben[256];
NtfsMftEntry	   *pMftEntry;
NtfsAttribut	   *pAttribut;
NtfsAttributFile   *pFile=0;
NtfsAttributData   *pData=0;
NtfsAttributInfo   *pInfo=0;
BYTE			   *pByte;
DWORD				dwLen,dwPos,dwOffset;
DWORD				dwNum,dwCluster[8],dwCount[8];
static char		   *pAttrNames[16]=
						{
						"???","Standard Info","AttributList",
						"Filename","Volume Version","Security Deskr.","Volume Name",
						"Volume Info","Data","Index Root","Index Alloc","Bitmap",
						"Sympolic Link","???","???","???",
						};

		pDoc=GetDocument();
	if(!pDoc)return;

	memset(ucFarben,10,256);
	cTxtWnd.TextInsert("\n MASTER FILE TABLE ENTRY\n\n",0,1000);
	cTxtWnd.SetColor(1,ucFarben,256);

	if(!pDoc->GetMftData(bData,&pPtr))return;

	pMftEntry=(NtfsMftEntry*)bData;
	//if(memcmp(pMftEntry->cId,"FILE",4))continue;
	dwOffset = pMftEntry->wAttributOffset;
	cName[0] = 0;
	dwNum	 = 0;

	memset(ucFarben   ,10,256);
	memset(ucFarben   , 0, 20);
	memset(ucFarben+22,11,180);
	memset(ucFarben+23, 0,  3);
	memset(ucFarben+31, 0,  3);
	memset(ucFarben+41, 0,  3);
	memset(ucFarben+51, 0,  8);
	memset(ucFarben+66, 0,  7);
	memset(ucFarben+80, 0,  5);
	memset(ucFarben+91,13, 45);

	ucFarben[21]=12;
	ucFarben[26]=12;
	ucFarben[34]=12;
	ucFarben[44]=12;
	ucFarben[59]=12;
	ucFarben[73]=12;
	ucFarben[85]=12;

	pAttribut=(NtfsAttribut*)(bData+dwOffset);

	if(dwOffset<=1024-sizeof(NtfsAttribut))
	for(;pAttribut->dwType!=0xFFFFFFFF;dwOffset+=pAttribut->dwLength)
		{
		if(dwOffset>1024-sizeof(NtfsAttribut))break;
		if(pAttribut->dwLength<sizeof(NtfsAttribut)-2)break;
		   pAttribut=(NtfsAttribut*)(bData+dwOffset);
		if(pAttribut->dwType==0xFFFFFFFF     )break;
		if(pAttribut->dwLength+dwOffset>=1024)break;

		i=(pAttribut->dwType>>4)&0x0F;
		if(pAttribut->dwType&~0xF0)i=0;

		i=sprintf(cText,"  %-18s : Typ=%02Xh Len=%04Xh Off=%04Xh DataSize=%04Xh DataOff=%04Xh Index=%04Xh",pAttrNames[i],pAttribut->dwType&0xFF,pAttribut->dwLength&0xFFFF,dwOffset,pAttribut->wDataSize,pAttribut->wDataOffest+dwOffset,pAttribut->wIndex);

		ADD_INFO(pPtr,pAttribut->dwType			,1, 27, 27+3);
		ADD_INFO(pPtr,pAttribut->dwLength		,2, 35, 35+5);
		ADD_INFO(pPtr,pMftEntry->wAttributOffset,2, 45, 45+5);
		ADD_INFO(pPtr,pAttribut->wDataSize		,2, 60, 60+5);
		ADD_INFO(pPtr,pAttribut->wDataOffest	,2, 74, 74+5);
		ADD_INFO(pPtr,pAttribut->wIndex			,2, 86, 86+5);

		if(pAttribut->bNameLength)
			{
			char cTemp[256];
			WideCharToMultiByte(CP_ACP,0,(LPCWSTR)(bData+dwOffset+pAttribut->wNameOffest),pAttribut->bNameLength,cTemp,sizeof(cTemp),NULL,NULL);
			cTemp[pAttribut->bNameLength]=0;
			i=sprintf(cText+i," \"%s\"",cTemp);
			}

		i=cTxtWnd.GetLineCount();
		  cTxtWnd.TextInsert(cText,0,i);
		  cTxtWnd.SetColor(i,ucFarben,256);

		if(pAttribut->dwType==0x10)
			{
			pInfo=(NtfsAttributInfo*)(bData+dwOffset+pAttribut->wDataOffest);
			}

		if(pAttribut->dwType==0x30)
			{
			pFile=(NtfsAttributFile*)(bData+dwOffset+pAttribut->wDataOffest);
			WideCharToMultiByte(CP_ACP,0,pFile->wName,pFile->bNameLength,cName,sizeof(cName),NULL,NULL);
			cName[pFile->bNameLength]=0;
			}

		if(pAttribut->dwType==0x80)
			{
			pData=(NtfsAttributData*)(pAttribut);
			pByte=(bData+dwOffset+pData->wOffset);
			dwLen=(DWORD)(pData->qwEndCluster-pData->qwStartCluster+1);
			dwNum=pDoc->DecodeClusterData(dwLen,pByte,dwCluster,dwCount,8);
			}
		}

//*****************************************************************************

	if(pInfo)
		{
		memset(ucFarben,10,256);
		i=cTxtWnd.GetLineCount();
		  cTxtWnd.TextInsert("\n Standard Info\n\n",0,i);
		  cTxtWnd.SetColor(i+1,ucFarben,256);

		memset(ucFarben   , 0, 20);
		memset(ucFarben+22,11,180);
		ucFarben[21]=12;
		ucFarben[25]=12;
		ucFarben[29]=12;
		ucFarben[38]=12;
		ucFarben[41]=12;
		ucFarben[44]=12;

		sprintf(cText,"  Access Time        : %s",Sft(&pInfo->qwCreationTime     ));i=cTxtWnd.GetLineCount();cTxtWnd.TextInsert(cText,0,i);cTxtWnd.SetColor(i,ucFarben,256);ADD_LINE(pPtr,pInfo->qwCreationTime     );
		sprintf(cText,"  Motify Time        : %s",Sft(&pInfo->qwLastMotifyTime   ));i=cTxtWnd.GetLineCount();cTxtWnd.TextInsert(cText,0,i);cTxtWnd.SetColor(i,ucFarben,256);ADD_LINE(pPtr,pInfo->qwLastMotifyTime   );
		sprintf(cText,"  Mft Motify Time    : %s",Sft(&pInfo->qwLastMftMotifyTime));i=cTxtWnd.GetLineCount();cTxtWnd.TextInsert(cText,0,i);cTxtWnd.SetColor(i,ucFarben,256);ADD_LINE(pPtr,pInfo->qwLastMftMotifyTime);
		sprintf(cText,"  Access Time        : %s",Sft(&pInfo->qwAccessTime       ));i=cTxtWnd.GetLineCount();cTxtWnd.TextInsert(cText,0,i);cTxtWnd.SetColor(i,ucFarben,256);ADD_LINE(pPtr,pInfo->qwAccessTime       );

		}

	if(pFile)
		{
		memset(ucFarben,10,256);
		i=cTxtWnd.GetLineCount();
		  cTxtWnd.TextInsert("\n Filename\n\n",0,i);
		  cTxtWnd.SetColor(i+1,ucFarben,256);


		memset(ucFarben   , 0, 20);
		memset(ucFarben+22,13,180);
		ucFarben[21]=12;
		sprintf(cText,"  Name               : \"%s\"",cName);i=cTxtWnd.GetLineCount();cTxtWnd.TextInsert(cText,0,i);cTxtWnd.SetColor(i,ucFarben,256);ADD_BYTE(pPtr,pFile->wName,pFile->bNameLength*2);

		memset(ucFarben+22,11,180);
		ucFarben[25]=12;
		ucFarben[29]=12;
		ucFarben[38]=12;
		ucFarben[41]=12;
		ucFarben[44]=12;

		sprintf(cText,"  Access Time        : %s",Sft(&pFile->qwCreationTime     ));i=cTxtWnd.GetLineCount();cTxtWnd.TextInsert(cText,0,i);cTxtWnd.SetColor(i,ucFarben,256);ADD_LINE(pPtr,pFile->qwCreationTime     );
		sprintf(cText,"  Motify Time        : %s",Sft(&pFile->qwLastMotifyTime   ));i=cTxtWnd.GetLineCount();cTxtWnd.TextInsert(cText,0,i);cTxtWnd.SetColor(i,ucFarben,256);ADD_LINE(pPtr,pFile->qwLastMotifyTime   );
		sprintf(cText,"  Mft Motify Time    : %s",Sft(&pFile->qwLastMftMotifyTime));i=cTxtWnd.GetLineCount();cTxtWnd.TextInsert(cText,0,i);cTxtWnd.SetColor(i,ucFarben,256);ADD_LINE(pPtr,pFile->qwLastMftMotifyTime);
		sprintf(cText,"  Access Time        : %s",Sft(&pFile->qwAccessTime       ));i=cTxtWnd.GetLineCount();cTxtWnd.TextInsert(cText,0,i);cTxtWnd.SetColor(i,ucFarben,256);ADD_LINE(pPtr,pFile->qwAccessTime       );

		memset(ucFarben+22,11,180);

		sprintf(cText,"  Alloc Size         : %I64i",pFile->qwAllocSize	);i=cTxtWnd.GetLineCount();cTxtWnd.TextInsert(cText,0,i);cTxtWnd.SetColor(i,ucFarben,256);ADD_LINE(pPtr,pFile->qwAllocSize);
		sprintf(cText,"  Data Size          : %I64i",pFile->qwDataSize	);i=cTxtWnd.GetLineCount();cTxtWnd.TextInsert(cText,0,i);cTxtWnd.SetColor(i,ucFarben,256);ADD_LINE(pPtr,pFile->qwDataSize );

		memset(ucFarben+32,13,160);
		sprintf(cText,"  Flags              : %08Xh  %s",pFile->dwFlags,Sat(pFile->dwFlags));i=cTxtWnd.GetLineCount();cTxtWnd.TextInsert(cText,0,i);cTxtWnd.SetColor(i,ucFarben,256);ADD_LINE(pPtr,pFile->dwFlags);
		}

	if(pData && dwNum)
		{
		memset(ucFarben,10,256);
		i=cTxtWnd.GetLineCount();
		  cTxtWnd.TextInsert("\n Data\n\n",0,i);
		  cTxtWnd.SetColor(i+1,ucFarben,256);

		memset(ucFarben   , 0, 20);
		memset(ucFarben+22,11,180);
		ucFarben[21]=12;

		i=sprintf(cText,"  Cluster Kette      :");

		for(dwPos=0;dwPos<dwNum;dwPos++)
			{
			i+=sprintf(cText+i," %i-",dwCluster[dwPos]);
			ucFarben[i-1]=12;
			i+=sprintf(cText+i,"%i ,",dwCluster[dwPos]+dwCount[dwPos]-1);
			ucFarben[i-1]=12;
			}

		cText[i-1]=0;

		i=cTxtWnd.GetLineCount();
		  cTxtWnd.TextInsert(cText,0,i);
		  cTxtWnd.SetColor(i,ucFarben,256);
		}


}


//*****************************************************************************
//*
//*		SetEcma
//*
//*****************************************************************************
void CDiskView::SetEcma(void *pPtr,DWORD dwSize)
{
EcmaTag					   *pTag=(EcmaTag*)pPtr;
EcmaFileEntry			   *pEnt=(EcmaFileEntry*)pPtr;
EcmaVolumeDesc			   *pVol=(EcmaVolumeDesc*)pPtr;
EcmaFileSetDesc			   *pSet=(EcmaFileSetDesc*)pPtr;
EcmaIndirectEntry		   *pInd=(EcmaIndirectEntry*)pPtr;
EcmaTerminalEntry		   *pTer=(EcmaTerminalEntry*)pPtr;
EcmaPartitionDesc		   *pPar=(EcmaPartitionDesc*)pPtr;
EcmaPrimVolumeDesc		   *pPri=(EcmaPrimVolumeDesc*)pPtr;
EcmaAllocExtentDesc		   *pAlc=(EcmaAllocExtentDesc*)pPtr;
EcmaLogicalVolumeInt	   *pInt=(EcmaLogicalVolumeInt*)pPtr;
EcmaAnchorVolumeDesc	   *pAnc=(EcmaAnchorVolumeDesc*)pPtr;
EcmaLogicalVolumeDesc	   *pLog=(EcmaLogicalVolumeDesc*)pPtr;
EcmaImplementationUse	   *pUse=(EcmaImplementationUse*)pPtr;
EcmaFileIdentifierDesc	   *pFiI=(EcmaFileIdentifierDesc*)pPtr;
EcmaExtendedAttrHeader     *pExt=(EcmaExtendedAttrHeader*)pPtr;
EcmaUnallocatedSpaceDesc   *pAll=(EcmaUnallocatedSpaceDesc*)pPtr;
const char				   *pVal;
const char				   *pCrc;
char					   *pLine;
DWORD					   *pList;
unsigned char				ucFarben[256];
char						cText[256];
char						cTemp[256];
unsigned					aAdd[32];
unsigned					uStart;
unsigned					uNext;
unsigned					uVal;
unsigned					uCrc;
unsigned					uEnd;
unsigned					uPos;
unsigned					uLen;
unsigned					uOff;
unsigned					uIdx;



	uIdx	= 0;
	uOff	= 0;
	uStart	= 0;
	aAdd[0] = 0;

Next:

	memset(ucFarben,10,256);

    pTag = (EcmaTag*)((char*)pPtr+uOff);


    switch(pTag->wTagIdentifier)
        {
    case 0x0001:    cTxtWnd.TextInsert("\n ECMA PRIMARY VOLUME DESCRIPTOR\n\n"              ,0,1000);   break;
    case 0x0002:    cTxtWnd.TextInsert("\n ECMA ANCHOR VOLUME DESCRIPTOR\n\n"               ,0,1000);   break;
    case 0x0003:    cTxtWnd.TextInsert("\n ECMA VOLUME DESCRIPTOR POINTER\n\n"              ,0,1000);   break;
    case 0x0004:    cTxtWnd.TextInsert("\n ECMA IMPLEMENTATION USE VOLUME DESCRIPTOR\n\n"   ,0,1000);   break;
    case 0x0005:    cTxtWnd.TextInsert("\n ECMA PARTITION DESCRIPTOR\n\n"                   ,0,1000);   break;
    case 0x0006:    cTxtWnd.TextInsert("\n ECMA LOGICAL VOLUME DESCRIPTOR\n\n"              ,0,1000);   break;
    case 0x0007:    cTxtWnd.TextInsert("\n ECMA UNALLOCATED SPACE DESCRIPTOR\n\n"           ,0,1000);   break;
    case 0x0008:    cTxtWnd.TextInsert("\n ECMA TERMINATING DESCRIPTOR\n\n"                 ,0,1000);   break;
    case 0x0009:    cTxtWnd.TextInsert("\n ECMA LOGICAL VOLUME INTEGRITY\n\n"               ,0,1000);   break;
    case 0x0100:    cTxtWnd.TextInsert("\n ECMA FILE SET DESCRIPTOR\n\n"                    ,0,1000);   break;
    case 0x0101:    cTxtWnd.TextInsert("\n ECMA FILE IDENTIFIER DESCRIPTOR\n\n"             ,0,1000);   break;
    case 0x0102:    cTxtWnd.TextInsert("\n ECMA ALLOCATION EXTENT DESCRIPTOR\n\n"           ,0,1000);   break;
    case 0x0103:    cTxtWnd.TextInsert("\n ECMA INDIRECT ENTRY\n\n"                         ,0,1000);   break;
    case 0x0104:    cTxtWnd.TextInsert("\n ECMA TERMINAL ENTRY\n\n"                         ,0,1000);   break;
    case 0x0105:    cTxtWnd.TextInsert("\n ECMA FILE ENTRY\n\n"                             ,0,1000);   break;
    case 0x0106:    cTxtWnd.TextInsert("\n ECMA EXTENDED ATTRIBUTE HEADER DESCRIPTOR\n\n"   ,0,1000);   break;
    case 0x0107:    cTxtWnd.TextInsert("\n ECMA UNALLOCATED SPACE ENTRY\n\n"                ,0,1000);   break;
    case 0x0108:    cTxtWnd.TextInsert("\n ECMA SPACE BITMAP DESCRIPTOR\n\n"                ,0,1000);   break;
    case 0x0109:    cTxtWnd.TextInsert("\n ECMA PARTITION INTEGRITY ENTRY\n\n"              ,0,1000);   break;
    case 0x010A:    cTxtWnd.TextInsert("\n ECMA EXTENDED FILE ENTRY\n\n"                    ,0,1000);   break;
    default:        cTxtWnd.TextInsert("\n ECMA TAG\n\n",0,1000);                                       break;
        }


	cTxtWnd.AddInfo((char*)pTag-(char*)pPtr,pTag->wDescLen+16,cTxtWnd.GetLineCount()-2);


    pEnt = (EcmaFileEntry           *)((char*)pPtr+uOff);
    pVol = (EcmaVolumeDesc          *)((char*)pPtr+uOff);
    pSet = (EcmaFileSetDesc         *)((char*)pPtr+uOff);
    pInd = (EcmaIndirectEntry       *)((char*)pPtr+uOff);
    pTer = (EcmaTerminalEntry       *)((char*)pPtr+uOff);
    pPar = (EcmaPartitionDesc       *)((char*)pPtr+uOff);
    pPri = (EcmaPrimVolumeDesc      *)((char*)pPtr+uOff);
    pAlc = (EcmaAllocExtentDesc     *)((char*)pPtr+uOff);
    pInt = (EcmaLogicalVolumeInt    *)((char*)pPtr+uOff);
    pAnc = (EcmaAnchorVolumeDesc    *)((char*)pPtr+uOff);
    pLog = (EcmaLogicalVolumeDesc   *)((char*)pPtr+uOff);
    pUse = (EcmaImplementationUse   *)((char*)pPtr+uOff);
    pFiI = (EcmaFileIdentifierDesc  *)((char*)pPtr+uOff);
	pExt = (EcmaExtendedAttrHeader  *)((char*)pPtr+uOff);
    pAll = (EcmaUnallocatedSpaceDesc*)((char*)pPtr+uOff);

	if(uOff>0)
			sprintf(cTemp,"(%u) at %u",pTag->wTagIdentifier,uOff);
	else	sprintf(cTemp,"(%u)"      ,pTag->wTagIdentifier);

	uCrc	= EcmaTagCrc (pTag);
	uVal	= EcmaDescCrc(pTag+1,(pTag->wDescLen+16<=(int)dwSize)? pTag->wDescLen:0);
	pCrc	= (uCrc==pTag->bChecksum && pTag->wTagIdentifier)? "\xA0OK":"\xA0WRONG";
	pVal	= (uVal==pTag->wDescCrc  && pTag->wTagIdentifier)? "\xA0OK":"\xA0WRONG";

    sprintf(cText,"  Tag Identifier         : %04Xh%s"  ,pTag->wTagIdentifier,cTemp     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pTag->wTagIdentifier);
    sprintf(cText,"  Descriptor Version     : %04Xh"    ,pTag->wDescVersion             );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pTag->wDescVersion);
    sprintf(cText,"  Header CRC             : %02Xh  %s",pTag->bChecksum,pCrc           );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pTag->bChecksum);
    sprintf(cText,"  Serial Number          : %04Xh"    ,pTag->wSerialNumber            );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pTag->wSerialNumber);
    sprintf(cText,"  Descriptor CRC         : %04Xh%s"  ,pTag->wDescCrc,pVal            );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pTag->wDescCrc);
    sprintf(cText,"  Descriptor Len         : %u"       ,pTag->wDescLen                 );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pTag->wDescLen);
    sprintf(cText,"  Location               : %u"       ,pTag->dwLocation               );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pTag->dwLocation);

    cTxtWnd.TextInsert("\n",0,1000);


    switch(pTag->wTagIdentifier)
        {
    case 0x0001:

    sprintf(cText,"  Volume Descriptor      : %04Xh",    pPri->dwSequenceNumber         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->dwSequenceNumber);
    sprintf(cText,"  Pri. Volume Desc.      : %04Xh",    pPri->dwDescriptorNumber       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->dwDescriptorNumber);
    sprintf(cText,"  Identifier String      : %s",   EcS(pPri->aIdentifierString,32)    );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->aIdentifierString);
    sprintf(cText,"  Volume Sequence        : %u",       pPri->wSequenceNumber          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->wSequenceNumber);
    sprintf(cText,"  Max. Volume Sequ.      : %u",       pPri->wMaxVolumeSequence       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->wMaxVolumeSequence);
    sprintf(cText,"  Interchange Level      : %u",       pPri->wInterchangeLevel        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->wInterchangeLevel);
    sprintf(cText,"  Max.Interchange Level  : %u",       pPri->wMaxInterchange          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->wMaxInterchange);
    sprintf(cText,"  Character Set List     : %u",       pPri->dwCharSetList            );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->dwCharSetList);
    sprintf(cText,"  Max.Char. Set List     : %u",       pPri->dwMaxCharSetList         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->dwMaxCharSetList);
    sprintf(cText,"  Volume Set Ident.      : %s",   EcS(pPri->aVolumeSetIdentifier,128));cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->aVolumeSetIdentifier);
    sprintf(cText,"  Descriptor Char.Set    : %s",   EcC(pPri->aDescriptorCharSet)      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->aDescriptorCharSet);
    sprintf(cText,"  Explanatory Charset    : %s",   EcC(pPri->aExplanatoryCharSet)     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->aExplanatoryCharSet);
    sprintf(cText,"  Volume Abstract Len    : %u",       pPri->dwVolumeAbstractLen      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->dwVolumeAbstractLen);
    sprintf(cText,"  Volume Abstract Loc    : %u",       pPri->dwVolumeAbstractLoc      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->dwVolumeAbstractLoc);
    sprintf(cText,"  Copyright Len          : %u",       pPri->dwVolumeCopyrightLen     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->dwVolumeCopyrightLen);
    sprintf(cText,"  Copyright Loc          : %u",       pPri->dwVolumeCopyrightLoc     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->dwVolumeCopyrightLoc);
    sprintf(cText,"  Application Id         : %s",   EcI(pPri->aApplicationIdentifier)  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->aApplicationIdentifier);
    sprintf(cText,"  Recording Time         : %s",   EcT(pPri->aRecordingDateTime)      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->aRecordingDateTime);
    sprintf(cText,"  Implementation Id      : %s",   EcI(pPri->aImplementIdentifier)    );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->aImplementIdentifier);
    sprintf(cText,"  Predecessor Volume     : %u",       pPri->dwSequenceLocation       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->dwSequenceLocation);
    sprintf(cText,"  Flags                  : %04Xh",    pPri->wFlags                   );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPri->wFlags);
    break;

    case 0x0002:

    sprintf(cText,"  Main Volume Len        : %u",       pAnc->dwMainVolumeDescLen      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pAnc->dwMainVolumeDescLen);
    sprintf(cText,"  Main Volume Loc        : %u",       pAnc->dwMainVolumeDescLoc      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pAnc->dwMainVolumeDescLoc);
    sprintf(cText,"  Reserve Volume Len     : %u",       pAnc->dwReserveVolumeDescLen   );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pAnc->dwReserveVolumeDescLen);
    sprintf(cText,"  Reserve Volume Loc     : %u",       pAnc->dwReserveVolumeDescLoc   );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pAnc->dwReserveVolumeDescLoc);
    break;

    case 0x0003:

    sprintf(cText,"  Sequence Number        : %u",       pVol->dwSequenceNumber         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pVol->dwSequenceNumber);
    sprintf(cText,"  Sequence Len           : %u",       pVol->dwNexSequenceExtentLen   );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pVol->dwNexSequenceExtentLen);
    sprintf(cText,"  Sequence Loc           : %u",       pVol->dwNexSequenceExtentLoc   );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pVol->dwNexSequenceExtentLoc);
    break;

    case 0x0004:

    sprintf(cText,"  Sequence Number        : %u",       pUse->dwSequenceNumber         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pUse->dwSequenceNumber);
    sprintf(cText,"  Implementation Id.     : %s",   EcI(pUse->aImplementationId)       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pUse->aImplementationId);
    break;

    case 0x005:

    sprintf(cText,"  Sequence Number        : %u",       pPar->dwSequenceNumber         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPar->dwSequenceNumber);
    sprintf(cText,"  Partition Flags        : %04Xh",    pPar->wPartitionFlags          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPar->wPartitionFlags);
    sprintf(cText,"  Partition Number       : %u",       pPar->wPartitionNumber         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPar->wPartitionNumber);
    sprintf(cText,"  Partition Contents     : %s",   EcI(pPar->aPartitionContents)      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPar->aPartitionContents);
    sprintf(cText,"  Access Type            : %08Xh",    pPar->dwAccessType             );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPar->dwAccessType);
    sprintf(cText,"  Partition Location     : %u",       pPar->dwPartitionLoc           );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPar->dwPartitionLoc);
    sprintf(cText,"  Partition Length       : %u",       pPar->dwPartitionLen           );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPar->dwPartitionLen);
    sprintf(cText,"  Implementation Ident.  : %s",   EcI(pPar->aImplementationId)       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pPar->aImplementationId);
    break;

    case 0x0006:

    sprintf(cText,"  Sequence Number        : %u",       pLog->dwSequenceNumber         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pLog->dwSequenceNumber);
    sprintf(cText,"  Character Set          : %s",   EcC(pLog->aCharacterSet)           );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pLog->aCharacterSet);
    sprintf(cText,"  Volume Identifier      : %s",   EcS(pLog->aVolumeIdentifier)       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pLog->aVolumeIdentifier);
    sprintf(cText,"  Logical Block Size     : %u",       pLog->dwLogicalBlockSize       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pLog->dwLogicalBlockSize);
    sprintf(cText,"  Domain Identifier      : %s",   EcI(pLog->aDomainIdentifier)       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pLog->aDomainIdentifier);
    sprintf(cText,"  Map Table Length       : %u",       pLog->dwMapTableLength         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pLog->dwMapTableLength);
    sprintf(cText,"  Number of Maps         : %u",       pLog->dwNumberPartitionMaps    );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pLog->dwNumberPartitionMaps);
    sprintf(cText,"  Implementation Ident.  : %s",   EcS(pLog->bImplementationId)       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pLog->bImplementationId);
    sprintf(cText,"  Integrity Sequence Len : %u",       pLog->dwIntegritySequenceLoc   );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pLog->dwIntegritySequenceLoc);
    sprintf(cText,"  Integrity Sequence Loc : %u",       pLog->dwIntegritySequenceLen   );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pLog->dwIntegritySequenceLen);
    break;

    case 0x0007:

    sprintf(cText,"  Sequence Number        : %u",       pAll->dwSequenceNumber         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pAll->dwSequenceNumber);
    sprintf(cText,"  Number of Allocations  : %u",       pAll->dwNumberOfAllocation     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pAll->dwNumberOfAllocation);

    for(uPos=0;uPos<16 && uPos<pAll->dwNumberOfAllocation;uPos++)
    {
    sprintf(cText,"    Loc[%02u]              : %u",uPos,pAll->aAllocationDesc[uPos*2+0]);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pAll->aAllocationDesc[uPos*2+0]);
    sprintf(cText,"    Len[%02u]              : %u",uPos,pAll->aAllocationDesc[uPos*2+1]);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pAll->aAllocationDesc[uPos*2+1]);
    }
    break;

    case 9:

    sprintf(cText,"  Recording Time         : %s",   EcT(pInt->aRecordingTime)          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInt->aRecordingTime);
    sprintf(cText,"  Integrity Type         : %04Xh",    pInt->dwIntegrityType          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInt->dwIntegrityType);
    sprintf(cText,"  Next Integrity Len     : %u",       pInt->dwNextIntegrityLen       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInt->dwNextIntegrityLen);
    sprintf(cText,"  Next Integrity Loc     : %u",       pInt->dwNextIntegrityLoc       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInt->dwNextIntegrityLoc);
    sprintf(cText,"  Number of Partitions   : %u",       pInt->dwNumberOfPartitions     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInt->dwNumberOfPartitions);
    sprintf(cText,"  Length of Implement.   : %u",       pInt->dwLengthOfImplementation );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInt->dwLengthOfImplementation);
    break;

    case 0x0100:

    sprintf(cText,"  Recording Time         : %s",   EcT(pSet->aRecordingTime)          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->aRecordingTime);
    sprintf(cText,"  Interchange Level      : %u",       pSet->wInterchangeLevel        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->wInterchangeLevel);
    sprintf(cText,"  Max.Interchange Level  : %u",       pSet->wMaxInterchangeLevel     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->wMaxInterchangeLevel);
    sprintf(cText,"  Character Set List     : %u",       pSet->dwCharacterSetList       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->dwCharacterSetList);
    sprintf(cText,"  Max.Char. Set List     : %u",       pSet->dwMaxCharacterSetList    );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->dwMaxCharacterSetList);
    sprintf(cText,"  File Set Number        : %u",       pSet->dwFileSetNumber          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->dwFileSetNumber);
    sprintf(cText,"  File Set Desc. Number  : %u",       pSet->dwFileSetDescNumber      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->dwFileSetDescNumber);
    sprintf(cText,"  Volume Identifier CS.  : %s",   EcC(pSet->aVolumeIdentCharSet)     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->aVolumeIdentCharSet);
    sprintf(cText,"  Volume Identifier      : %s",   EcS(pSet->aVolumeIdentifier)       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->aVolumeIdentifier);
    sprintf(cText,"  File Set Character Set : %s",   EcC(pSet->aFileSetCharSet)         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->aFileSetCharSet);
    sprintf(cText,"  File Set Identifier    : %s",   EcS(pSet->aFileSetIdentifier)      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->aFileSetIdentifier);
    sprintf(cText,"  Copyright Identifier   : %s",   EcS(pSet->aCopyrightIdentifier)    );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->aCopyrightIdentifier);
    sprintf(cText,"  Abstract Identifier    : %s",   EcS(pSet->aAbstractIdentifier)     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->aAbstractIdentifier);
    sprintf(cText,"  Root Directory ICB     : %s",   EcB(pSet->aRootDirectoryIcb)       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->aRootDirectoryIcb);
    sprintf(cText,"  Domain Identifier      : %s",   EcS(pSet->aDomainIdentifier)       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->aDomainIdentifier);
    sprintf(cText,"  Next Extent ICB        : %s",   EcB(pSet->aNextExtentIcb)          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->aNextExtentIcb);
    sprintf(cText,"  System Stream Dir ICB  : %s",   EcB(pSet->aSystemStreamIcb)        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSet->aSystemStreamIcb);
    break;

    case 0x0101:

    sprintf(cText,"  File Version Number    : %u",       pFiI->wFileVersionNumber       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pFiI->wFileVersionNumber);
    sprintf(cText,"  File Characteristics   : %s",   EcA(pFiI->bFileCharacteristics)    );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pFiI->bFileCharacteristics);
    sprintf(cText,"  Length of File Id      : %u",       pFiI->bLengthOfFileIdentifier  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pFiI->bLengthOfFileIdentifier);
    sprintf(cText,"  File ICB               : %s",   EcB(pFiI->aFileIcb)                );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pFiI->aFileIcb);
    sprintf(cText,"  Length of Implement.   : %u",       pFiI->wImplementationUseLen    );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pFiI->wImplementationUseLen);
	sprintf(cText,"  Filename               : %s",   EcS(pFiI->aData+pFiI->wImplementationUseLen,pFiI->bLengthOfFileIdentifier));cTxtWnd.TextInsert(cText,0,1000);
	cTxtWnd.AddInfo(((char*)(pFiI->aData+pFiI->wImplementationUseLen))-((char*)pPtr),pFiI->bLengthOfFileIdentifier,cTxtWnd.GetLineCount()-1);

	if(uOff!=0)break;

	uLen		= dwSize;
	uPos		= pTag->wDescLen+16;
	aAdd[uIdx]	= uPos;

	for(uNext=0;uPos+16<uLen && uIdx+uNext<32;uNext++)
		{
		pTag = (EcmaTag*)((char*)pPtr+uOff+uPos);

		if(pTag->wTagIdentifier   ==  0x0000)break;
		if(EcmaTagCrc(pTag)!=pTag->bChecksum)break;
		if(uPos+pTag->wDescLen+16 >     uLen)break;

		aAdd[uIdx+uNext+1]  = pTag->wDescLen+16;
		uPos			   += pTag->wDescLen+16;
		}

	aAdd[uIdx+uNext] = 0;


    break;

    case 0x0102:

    sprintf(cText,"  Previous Allocation    : %u",       pAlc->dwAllocExtentLoc         );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pAlc->dwAllocExtentLoc);
    sprintf(cText,"  Length of Allocation   : %u",       pAlc->dwLengthOfAllocation     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pAlc->dwLengthOfAllocation);
    break;

    case 0x0103:

    sprintf(cText,"  File ICB               : %s",   EcB(pInd->aIcbTag)                 );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInd->aIcbTag);
    sprintf(cText,"  File ICB               : %s",   EcB(pInd->aIndirectIcb)            );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInd->aIndirectIcb);
    break;

    case 0x0104:

    sprintf(cText,"  File ICB               : %s",   EcB(pTer->aIcbTag)                 );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pTer->aIcbTag);
    break;

    case 0x0105:

    sprintf(cText,"  ICB Tag                : %s",   EcN(pEnt->aIcbTag)                 );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->aIcbTag);
    sprintf(cText,"  UID                    : %08Xh",    pEnt->dwUid                    );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->dwUid);
    sprintf(cText,"  GID                    : %08Xh",    pEnt->dwGid                    );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->dwGid);
    sprintf(cText,"  Permissions            : %08Xh",    pEnt->dwPermissions            );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->dwPermissions);
    sprintf(cText,"  File Link Count        : %u",       pEnt->wFileLinkCount           );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->wFileLinkCount);
    sprintf(cText,"  Record Format          : %u",       pEnt->bRecordFormat            );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->bRecordFormat);
    sprintf(cText,"  Display Attributes     : %02Xh",    pEnt->bRecordAttributes        );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->bRecordAttributes);
    sprintf(cText,"  Record Length          : %u",       pEnt->dwRecordLength           );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->dwRecordLength);
    sprintf(cText,"  Information Length     : %u",       pEnt->qwInformationLength      );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->qwInformationLength);
    sprintf(cText,"  Blocks Recorded        : %u",       pEnt->qwLogicalBlocksRecorded  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->qwLogicalBlocksRecorded);
    sprintf(cText,"  Access Time            : %s",   EcT(pEnt->aAccessTime)             );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->aAccessTime);
    sprintf(cText,"  Modification Time      : %s",   EcT(pEnt->aModificationTime)       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->aModificationTime);
    sprintf(cText,"  Attribute Time         : %s",   EcT(pEnt->aAttributeTime)          );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->aAttributeTime);
    sprintf(cText,"  Checkpoint             : %u",       pEnt->dwCheckpoint             );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->dwCheckpoint);
    sprintf(cText,"  Extended Attribute ICB : %s",   EcB(pEnt->aExtendedAttributeIcb)   );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->aExtendedAttributeIcb);
    sprintf(cText,"  Implementation Ident.  : %s",   EcI(pEnt->aImplementationId)       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->aImplementationId);
    sprintf(cText,"  Unique Id              : %u",       pEnt->qwUniqueId               );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->qwUniqueId);
    sprintf(cText,"  Length of Ex.Attrib    : %u",       pEnt->dwLengthOfExAttributes   );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->dwLengthOfExAttributes);
    sprintf(cText,"  Length of Allocation   : %u",       pEnt->dwLengthOfAllocation     );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pEnt->dwLengthOfAllocation);

	if(pEnt->dwLengthOfAllocation>=8 && (pEnt->aIcbTag[18]&7)<=1 && pEnt->dwLengthOfExAttributes==0)
		{
		pList = (DWORD*)(pEnt->aData+pEnt->dwLengthOfExAttributes);
		uLen  = pEnt->dwLengthOfAllocation/8;

		if(uLen)cTxtWnd.TextInsert("\n",0,1000);

		for(uPos=0;uPos<uLen;uPos++)
			{
			sprintf(cText,"  Length  [%i]            : %u",uPos,pList[uPos*2+0]);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pList[uPos*2+0]);
			sprintf(cText,"  Location[%i]            : %u",uPos,pList[uPos*2+1]);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pList[uPos*2+1]);
			}
		}

	if(uIdx!=0)break;

	uLen		 = pTag->wDescLen+16;
	aAdd[uIdx  ] = uLen;
	aAdd[uIdx+1] = pEnt->dwLengthOfExAttributes;
	uPos		 = pEnt->dwLengthOfExAttributes+176;

	if(uOff==0)dwSize=uLen;


	if(pEnt->dwLengthOfAllocation<16 || pEnt->aIcbTag[11]!=4)
		{
		aAdd[uIdx+1]=0;
		break;
		}

	for(uNext=2;uPos+16<uLen && uIdx+uNext<32;uNext++)
		{
		pTag = (EcmaTag*)((char*)pPtr+uOff+uPos);

		if(pTag->wTagIdentifier   ==  0x0000)break;
		if(EcmaTagCrc(pTag)!=pTag->bChecksum)break;
		if(uPos+pTag->wDescLen+16    >= uLen)break;

		aAdd[uIdx+uNext]  = pTag->wDescLen+16;
		uPos			 += pTag->wDescLen+16;
		}

	aAdd[uIdx+uNext] = 0;


	break;

    case 0x0106:

    sprintf(cText,"  Impl.Attributes Loc    : %u",       pExt->dwImplAttrLocation       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pExt->dwImplAttrLocation);
    sprintf(cText,"  Appl.Attributes Loc    : %u",       pExt->dwApplAttrLocation       );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pExt->dwApplAttrLocation);
    break;
        }


	memset(ucFarben,10,256);
	cTxtWnd.SetColor(uStart+1,ucFarben,256);
	memset(ucFarben   , 0, 25);
	memset(ucFarben+25,11,180);
	ucFarben[25]=12;
	uEnd = cTxtWnd.GetLineCount();

	for(uPos=uStart+3;uPos<uEnd;uPos++)
		{
		pLine = cTxtWnd.GetLineText(uPos);

		if(pLine)
			{
			uVal = strchar(pLine,'\xA0');
			if(pLine[uVal]=='\xA0')
				{
				uVal++;
				memset(ucFarben+uVal,(pLine[uVal]=='O')? 15:14,8);
				cTxtWnd.SetColor(uPos,ucFarben,256);
				memset(ucFarben+uVal,11,8);

				continue;
				}
			}


		cTxtWnd.SetColor(uPos,ucFarben,256);
		}

	if(aAdd[uIdx] && dwSize>=16)
		{
		uStart  = uEnd;
		dwSize -= aAdd[uIdx];
		uOff   += aAdd[uIdx];
		uIdx   += 1;

		if(dwSize<0x80000000 && dwSize>0)
			{
			goto Next;
			}
		}

}



//*****************************************************************************
//*
//*		SetExFatDir
//*
//*****************************************************************************
void CDiskView::SetExFatDir(void *pPtr,DWORD dwSize)
{
ExFatBitmap				   *pBmap;
ExFatUpcase				   *pUpcs;
ExFatLabel				   *pLabl;
ExFatFile				   *pFile;
ExFatInfo				   *pInfo;
ExFatName				   *pName;
char					   *pLine;
LPCTSTR						pText;
unsigned char				ucFarben[256];
char						cText[256];
char						cTemp[256];
char						cInfo[256];
char						cTime[256];
char						cAttr[256];
unsigned					uStart;
unsigned					uMonth;
unsigned					uType;
unsigned					uYear;
unsigned					uHour;
unsigned					uSec;
unsigned					uMin;
unsigned					uDay;
unsigned					uVal;
unsigned					uEnd;
unsigned					uPos;
unsigned					uLen;
unsigned					uOff;
unsigned					uIdx;


	uIdx	= 0;
	uOff	= 0;
	uStart	= 0;

Next:

	memset(ucFarben,10,256);

	pBmap	= (ExFatBitmap*)((char*)pPtr+uOff);
	pUpcs	= (ExFatUpcase*)((char*)pPtr+uOff);
	pLabl	= (ExFatLabel *)((char*)pPtr+uOff);
	pFile	= (ExFatFile  *)((char*)pPtr+uOff);
	pInfo	= (ExFatInfo  *)((char*)pPtr+uOff);
	pName	= (ExFatName  *)((char*)pPtr+uOff);

	uType = pName->bType&0x3F;

    switch(uType)
        {
	case 0x00:	pText = "Fileinfo";
				if(memcmp(pName,"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0",32))break;
				pText = "Empty";
				uType = 33;
				break;
	case 0x02:	pText = "Upcase";	break;
	case 0x03:	pText = "Label";	break;
	case 0x05:	pText = "File";		break;
	case 0x01:	pText = "Bitmap";
				if(!(pName->bType&0x40))break;
				pText = "Filename";
				uType = 32;
				break;
	default:	sprintf(cTemp,"Unknown Tag %i",uType);
				pText = cTemp;
				break;
		}

						 uLen =sprintf(cText     ,"\n EXFAT %s  %s",pText,(pName->bType&0xE0)? "(":"");uVal=uLen-2;
	if(pName->bType&0x20)uLen+=sprintf(cText+uLen,"%sOPTIONAL"           ,(pName->bType&0x00)? " ":"");
	if(pName->bType&0x40)uLen+=sprintf(cText+uLen,"%sCONTINUED"          ,(pName->bType&0x20)? " ":"");
	if(pName->bType&0x80)uLen+=sprintf(cText+uLen,"%sVALID"              ,(pName->bType&0x60)? " ":"");
	                     uLen+=sprintf(cText+uLen,"%s\n\n"		         ,(pName->bType&0xE0)? ")":"");

	cTxtWnd.TextInsert(cText,0,1000);
	cTxtWnd.AddInfo(uOff,32,cTxtWnd.GetLineCount()-2);


    switch(uType)
        {
	case 0x00:										// Fileinfo

		if(pInfo->bFlags)
			{
			uLen		= 1;
			cTemp[0]	= '(';
			if(pInfo->bFlags&0x01)uLen+=sprintf(cTemp+uLen,"ALWAYS1");
			if(pInfo->bFlags&0x02)uLen+=sprintf(cTemp+uLen,"%sCONTIGUOUS",(pInfo->bFlags&0x01)? " ":"");
								  uLen+=sprintf(cTemp+uLen,")");
			}
		else{
			cTemp[0] = 0;
			}

		sprintf(cText,"  Type                   : %02Xh"	,pInfo->bType				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInfo->bType);
		sprintf(cText,"  Flags                  : %02Xh %s" ,pInfo->bFlags,cTemp		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInfo->bFlags);
		sprintf(cText,"  NameLength             : %i"       ,pInfo->bNameLength			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInfo->bNameLength);
		sprintf(cText,"  NameHash               : %04Xh"    ,pInfo->wNameHash			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInfo->wNameHash);
		sprintf(cText,"  ValidSize              : %I64u"    ,pInfo->qwValidSize			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInfo->qwValidSize);
		sprintf(cText,"  StartCluster           : %u"       ,pInfo->dwStartCluster		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInfo->dwStartCluster);
		sprintf(cText,"  FileSize               : %I64u"    ,pInfo->qwSize				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInfo->qwSize);

		break;

	case 0x01:										// Bitmap

		sprintf(cText,"  Type                   : %02Xh"	,pBmap->bType				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pBmap->bType);
		sprintf(cText,"  StartCluster           : %u"       ,pBmap->dwStartCluster		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pBmap->dwStartCluster);
		sprintf(cText,"  FileSize               : %I64u"    ,pBmap->qwSize				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pBmap->qwSize);

		break;

	case 0x02:										// Upcase

		sprintf(cText,"  Type                   : %02Xh"	,pUpcs->bType				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pUpcs->bType);
		sprintf(cText,"  CheckSum               : %08Xh"	,pUpcs->dwCheckSum			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pUpcs->dwCheckSum);
		sprintf(cText,"  StartCluster           : %u"       ,pUpcs->dwStartCluster		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pUpcs->dwStartCluster);
		sprintf(cText,"  Size                   : %I64u"    ,pUpcs->qwSize				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pUpcs->qwSize);

		break;

	case 0x03:										// Label

		sprintf(cText,"  Type                   : %02Xh"	,pLabl->bType				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pLabl->bType);
		sprintf(cText,"  Length                 : %i"		,pLabl->bLength				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pLabl->bLength);
		sprintf(cText,"  Name                   : %.16S"    ,pLabl->aName				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pLabl->aName);

		break;

	case 0x05:										// File

		uDay	= (pFile->wCreateDate     )&0x1F;
		uMonth	= (pFile->wCreateDate >> 5)&0x0F;
		uYear	= (pFile->wCreateDate >> 9);
		uSec	=((pFile->wCreateTime     )&0x1F)*2;
		uMin	= (pFile->wCreateTime >> 5)&0x3F;
		uHour	= (pFile->wCreateTime >>11);
		uSec   += (pFile->wCreateCenti/100);

		sprintf(cTime,"%04i-%02i-%02i %02i:%02i:%02i.%03i",uYear+1980,uMonth,uDay,uHour,uMin,uSec,(pFile->wCreateCenti%100)*10);

		uDay	= (pFile->wWriteDate      )&0x1F;
		uMonth	= (pFile->wWriteDate  >> 5)&0x0F;
		uYear	= (pFile->wWriteDate  >> 9);
		uSec	=((pFile->wWriteTime      )&0x1F)*2;
		uMin	= (pFile->wWriteTime  >> 5)&0x3F;
		uHour	= (pFile->wWriteTime  >>11);
		uSec   += (pFile->wWriteCenti /100);

		sprintf(cTemp,"%04i-%02i-%02i %02i:%02i:%02i.%03i",uYear+1980,uMonth,uDay,uHour,uMin,uSec,(pFile->wWriteCenti%100)*10);

		uDay	= (pFile->wAcessDate     )&0x1F;
		uMonth	= (pFile->wAcessDate >> 5)&0x0F;
		uYear	= (pFile->wAcessDate >> 9);
		uSec	=((pFile->wAcessTime     )&0x1F)*2;
		uMin	= (pFile->wAcessTime >> 5)&0x3F;
		uHour	= (pFile->wAcessTime >>11);

		sprintf(cInfo,"%04i-%02i-%02i %02i:%02i:%02i.000",uYear+1980,uMonth,uDay,uHour,uMin,uSec);

		if(pFile->wAttributes&0x3F)
			{
			uLen		= 1;
			cAttr[0]	= '(';
			if(pFile->wAttributes&0x0001)uLen+=sprintf(cAttr+uLen,"ReadOnly");
			if(pFile->wAttributes&0x0002)uLen+=sprintf(cAttr+uLen,"%sHidden" ,(pFile->wAttributes&0x0001)? " ":"");
			if(pFile->wAttributes&0x0004)uLen+=sprintf(cAttr+uLen,"%sSystem" ,(pFile->wAttributes&0x0003)? " ":"");
			if(pFile->wAttributes&0x0008)uLen+=sprintf(cAttr+uLen,"%sVolume" ,(pFile->wAttributes&0x0007)? " ":"");
			if(pFile->wAttributes&0x0010)uLen+=sprintf(cAttr+uLen,"%sDir"    ,(pFile->wAttributes&0x000F)? " ":"");
			if(pFile->wAttributes&0x0020)uLen+=sprintf(cAttr+uLen,"%sArchive",(pFile->wAttributes&0x001F)? " ":"");
								         uLen+=sprintf(cAttr+uLen,")");
			}
		else{
			cAttr[0] = 0;
			}


		sprintf(cText,"  Type                   : %02Xh"	,pFile->bType				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pFile->bType);
		sprintf(cText,"  Continuations          : %i"		,pFile->bContinuations		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pFile->bContinuations);
		sprintf(cText,"  CheckSum               : %04Xh"	,pFile->wCheckSum			);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pFile->wCheckSum);
		sprintf(cText,"  Attributes             : %04Xh  %s",pFile->wAttributes,cAttr	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pFile->wAttributes);
		sprintf(cText,"  CreateTime             : %s"       ,cTime       				);cTxtWnd.TextInsert(cText,0,1000);ADD_BYTE(pPtr,pFile->wCreateTime,4);
		sprintf(cText,"  WriteTime              : %s"       ,cTemp       				);cTxtWnd.TextInsert(cText,0,1000);ADD_BYTE(pPtr,pFile->wWriteTime ,4);
		sprintf(cText,"  AccessTime             : %s"       ,cInfo       				);cTxtWnd.TextInsert(cText,0,1000);ADD_BYTE(pPtr,pFile->wAcessTime ,4);

		break;

	case 0x20:										// Label

		sprintf(cText,"  Type                   : %02Xh"	,pName->bType				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pName->bType);
//		sprintf(cText,"  Length                 : %i"		,pName->bLength				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pName->bLength);
		sprintf(cText,"  Name                   : %.16S"    ,pName->aName				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pName->aName);

		cTxtWnd.TextInsert("\n",0,1000);
		break;

	default:

		sprintf(cText,"  Type                   : %02Xh"	,pInfo->bType				);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pInfo->bType);

		break;
        }


	memset(ucFarben     ,10,    uVal);
	memset(ucFarben+uVal,12,256-uVal);

	cTxtWnd.SetColor(uStart+1,ucFarben,256);
	memset(ucFarben   , 0, 25);
	memset(ucFarben+25,11,180);
	ucFarben[25]=12;
	uEnd = cTxtWnd.GetLineCount();

	for(uPos=uStart+3;uPos<uEnd;uPos++)
		{
		pLine = cTxtWnd.GetLineText(uPos);

		if(pLine)
			{
			uVal = strchar(pLine,'\xA0');
			if(pLine[uVal]=='\xA0')
				{
				uVal++;
				memset(ucFarben+uVal,(pLine[uVal]=='O')? 15:14,8);
				cTxtWnd.SetColor(uPos,ucFarben,256);
				memset(ucFarben+uVal,11,8);

				continue;
				}
			}


		cTxtWnd.SetColor(uPos,ucFarben,256);
		}

	if(uOff+32<dwSize)
		{
		uStart  = uEnd;
		uOff   += 32;
		uIdx   += 1;
		goto Next;
		}

}




//*****************************************************************************
//*
//*		SetSuperBlk
//*
//*****************************************************************************
void CDiskView::SetSuperBlk(void *pPtr,DWORD dwSize)
{
BYTE			ucFarben[256];
BYTE			aData[1024];
char			cText[256];
QWORD			qwSector;
ExtSuperBlock  *pSuper;
const char 	   *pLine;
CDiskDoc	   *pDoc;
UINT			uPos;
UINT			uEnd;
UINT			uVal;


	pDoc	= GetDocument();
	pSuper	= (ExtSuperBlock*)pPtr;

	if(pSuper->wMagic!=0xEF53)
		{
		memset(aData,0,512);
		memcpy(aData+512,pPtr,512);
		pPtr = aData+512;

		if(pDoc)
			{
			qwSector = pDoc->GetSectorNumber();
			pDoc->GetReadSectors(qwSector-1,1,aData);
			}
		}
	else{
		memset(aData+512,0,512);
		memcpy(aData,pPtr,512);
		pPtr = aData;

		if(pDoc)
			{
			qwSector = pDoc->GetSectorNumber();
			pDoc->GetReadSectors(qwSector+1,1,aData+512);
			}
		}

	pSuper	= (ExtSuperBlock*)aData;
	cTxtWnd.TextInsert("\n SUPERBLOCK\n\n",0,1000);


    sprintf(cText,"  InodesCount            : %u"		,pSuper->dwInodesCount           	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwInodesCount);
    sprintf(cText,"  BlocksCountLo          : %I64u"    ,HILO(pSuper->dwBlocksCount)		);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwBlocksCountLo);
    sprintf(cText,"  ReservedBlocksCountLo  : %I64u"    ,HILO(pSuper->dwReservedBlocksCount));cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwReservedBlocksCountLo);
    sprintf(cText,"  FreeBlocksCountLo      : %I64u"    ,HILO(pSuper->dwFreeBlocksCount)   	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFreeBlocksCountLo);
    sprintf(cText,"  FreeInodesCount        : %u"		,pSuper->dwFreeInodesCount       	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFreeInodesCount);
    sprintf(cText,"  FirstDataBlock         : %u"		,pSuper->dwFirstDataBlock        	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFirstDataBlock);
    sprintf(cText,"  LogBlockSize           : %s"		,Shx(pSuper->dwLogBlockSize,1<<10)  );cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwLogBlockSize);
    sprintf(cText,"  LogClusterSize         : %s"       ,Shx(pSuper->dwLogClusterSize,0)   	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwLogClusterSize);
    sprintf(cText,"  BlocksPerGroup         : %u"		,pSuper->dwBlocksPerGroup        	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwBlocksPerGroup);
    sprintf(cText,"  FragsPerGroup          : %u"		,pSuper->dwFragsPerGroup         	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFragsPerGroup);
    sprintf(cText,"  InodesPerGroup         : %u"		,pSuper->dwInodesPerGroup        	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwInodesPerGroup);
    sprintf(cText,"  MountTime              : %s"		,Stm(pSuper->dwMountTime)          	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwMountTime);
    sprintf(cText,"  WriteTime              : %s"		,Stm(pSuper->dwWriteTime)          	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwWriteTime);
    sprintf(cText,"  MountCount             : %u"		,pSuper->wMountCount             	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wMountCount);
    sprintf(cText,"  MaxMountCount          : %u"		,pSuper->wMaxMountCount          	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wMaxMountCount);
    sprintf(cText,"  Magic                  : %04Xh"    ,pSuper->wMagic                  	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wMagic);
    sprintf(cText,"  State                  : %04Xh"    ,pSuper->wState                  	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wState);
    sprintf(cText,"  Errors                 : %u"		,pSuper->wErrors                 	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wErrors);
    sprintf(cText,"  MinorRevLevel          : %u"		,pSuper->wMinorRevLevel          	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wMinorRevLevel);
    sprintf(cText,"  LastCheckTime          : %s"		,Stm(pSuper->dwLastCheckTime)      	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwLastCheckTime);
    sprintf(cText,"  CheckInterval          : %u s"		,pSuper->dwCheckInterval         	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwCheckInterval);
    sprintf(cText,"  CreatorOs              : %u"		,pSuper->dwCreatorOs             	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwCreatorOs);
    sprintf(cText,"  RevLevel               : %u"		,pSuper->dwRevLevel              	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwRevLevel);
    sprintf(cText,"  DefResUid              : %u"		,pSuper->wDefResUid              	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wDefResUid);
    sprintf(cText,"  DefResGid              : %u"		,pSuper->wDefResGid              	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wDefResGid);
    sprintf(cText,"  FirstInode             : %u"		,pSuper->dwFirstInode            	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFirstInode);
    sprintf(cText,"  InodeSize              : %u"		,pSuper->wInodeSize              	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wInodeSize);
    sprintf(cText,"  BlockGroupIndex        : %u"		,pSuper->wBlockGroupIndex        	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wBlockGroupIndex);
    sprintf(cText,"  FeaturesCompatible     : %08Xh"    ,pSuper->dwFeaturesCompatible    	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFeaturesCompatible);
    sprintf(cText,"  FeaturesIncompatible   : %08Xh"    ,pSuper->dwFeaturesIncompatible  	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFeaturesIncompatible);
    sprintf(cText,"  FeaturesReadOnly       : %08Xh"    ,pSuper->dwFeaturesReadOnly      	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFeaturesReadOnly);
    sprintf(cText,"  Uuid                   : %s"		,Sid(pSuper->aUuid)               	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->aUuid);
    sprintf(cText,"  VolumeName             : '%.16s'"  ,pSuper->cVolumeName             	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->cVolumeName);
    sprintf(cText,"  LastMounted            : '%.64s'"  ,pSuper->cLastMounted           	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->cLastMounted);
    sprintf(cText,"  AlgorithmUsageBitmap   : %08Xh"    ,pSuper->dwAlgorithmUsageBitmap  	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwAlgorithmUsageBitmap);
    sprintf(cText,"  PreAllocBlocks         : %u"       ,pSuper->bPreAllocBlocks         	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->bPreAllocBlocks);
    sprintf(cText,"  PreAllocDirBlocks      : %u"       ,pSuper->bPreAllocDirBlocks      	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->bPreAllocDirBlocks);
    sprintf(cText,"  ReservedGdtBlocks      : %u"       ,pSuper->bReservedGdtBlocks      	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->bReservedGdtBlocks);
    sprintf(cText,"  JournalUuid[12]        : %s"       ,Sid(pSuper->aJournalUuid)        	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->aJournalUuid);
    sprintf(cText,"  JournalInodeNumber     : %u"       ,pSuper->dwJournalInodeNumber    	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwJournalInodeNumber);
    sprintf(cText,"  JournalDevice          : %u"       ,pSuper->dwJournalDevice         	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwJournalDevice);
    sprintf(cText,"  LastOrphan             : %u"       ,pSuper->dwLastOrphan            	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwLastOrphan);
    sprintf(cText,"  DefaultHashVersion     : %u"       ,pSuper->bDefaultHashVersion     	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->bDefaultHashVersion);
    sprintf(cText,"  JournalBackupType      : %u"       ,pSuper->bJournalBackupType      	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->bJournalBackupType);
    sprintf(cText,"  DescSize               : %u"       ,pSuper->wDescSize               	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wDescSize);
    sprintf(cText,"  DefaultMountOpts       : %04Xh"    ,pSuper->dwDefaultMountOpts      	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwDefaultMountOpts);
    sprintf(cText,"  FirstMetaBg            : %u"       ,pSuper->dwFirstMetaBg           	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFirstMetaBg);
    sprintf(cText,"  MkfsTime               : %s"       ,Stm(pSuper->dwMkfsTime)           	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwMkfsTime);
    sprintf(cText,"  BlocksCountHi          : %04Xh"    ,pSuper->dwBlocksCountHi         	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwBlocksCountHi);
    sprintf(cText,"  ReservedBlocksCountHi  : %04Xh"    ,pSuper->dwReservedBlocksCountHi 	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwReservedBlocksCountHi);
    sprintf(cText,"  FreeBlocksCountHi      : %04Xh"    ,pSuper->dwFreeBlocksCountHi     	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFreeBlocksCountHi);
    sprintf(cText,"  MinExtraInodeSize      : %u"       ,pSuper->wMinExtraInodeSize      	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wMinExtraInodeSize);
    sprintf(cText,"  WantExtraIsize         : %u"       ,pSuper->wWantExtraIsize         	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wWantExtraIsize);
    sprintf(cText,"  Flags                  : %04Xh"    ,pSuper->dwFlags                 	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFlags);
    sprintf(cText,"  RaidStride             : %u"       ,pSuper->wRaidStride             	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wRaidStride);
    sprintf(cText,"  MmpInterval            : %u"       ,pSuper->wMmpInterval            	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->wMmpInterval);
    sprintf(cText,"  MmpBlock               : %08I64Xh" ,pSuper->qwMmpBlock              	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->qwMmpBlock);
    sprintf(cText,"  RaidStripeWidth        : %02Xh"    ,pSuper->dwRaidStripeWidth      	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwRaidStripeWidth);
    sprintf(cText,"  LogGroupsPerFlex       : %s"       ,Shx(pSuper->bLogGroupsPerFlex)    	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->bLogGroupsPerFlex);
    sprintf(cText,"  ChecksumType           : %u"       ,pSuper->bChecksumType           	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->bChecksumType);
    sprintf(cText,"  KbytesWritten          : %I64u"    ,pSuper->qwKbytesWritten         	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->qwKbytesWritten);
    sprintf(cText,"  SnapshotInode          : %u"       ,pSuper->dwSnapshotInode         	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwSnapshotInode);
    sprintf(cText,"  SnapshotId             : %u"       ,pSuper->dwSnapshotId            	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwSnapshotId);
    sprintf(cText,"  SnapshotBlocksCount    : %I64u"    ,pSuper->qwSnapshotBlocksCount   	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->qwSnapshotBlocksCount);
    sprintf(cText,"  SnapshotList           : %u"       ,pSuper->dwSnapshotList          	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwSnapshotList);
    sprintf(cText,"  ErrorCount             : %u"       ,pSuper->dwErrorCount            	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwErrorCount);
    sprintf(cText,"  FirstErrorTime         : %s"       ,Stm(pSuper->dwFirstErrorTime)     	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFirstErrorTime);
    sprintf(cText,"  FirstErrorInode        : %u"       ,pSuper->dwFirstErrorInode       	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFirstErrorInode);
    sprintf(cText,"  FirstErrorBlock        : %I64u"    ,pSuper->qwFirstErrorBlock       	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->qwFirstErrorBlock);
    sprintf(cText,"  FirstErrorFunc         : '%.32s'"  ,pSuper->cFirstErrorFunc	     	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->cFirstErrorFunc);
    sprintf(cText,"  FirstErrorLine         : %u"		,pSuper->dwFirstErrorLine        	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwFirstErrorLine);
    sprintf(cText,"  LastErrorTime          : %s"		,Stm(pSuper->dwLastErrorTime)      	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwLastErrorTime);
    sprintf(cText,"  LastErrorInode         : %u"		,pSuper->dwLastErrorInode        	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwLastErrorInode);
    sprintf(cText,"  LastErrorLine          : %u"		,pSuper->dwLastErrorLine         	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwLastErrorLine);
    sprintf(cText,"  LastErrorBlock         : %I64u"	,pSuper->qwLastErrorBlock         	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->qwLastErrorBlock);
    sprintf(cText,"  LastErrorFunc          : '%.32s'"  ,pSuper->cLastErrorFunc         	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->cLastErrorFunc);
    sprintf(cText,"  MountOpts              : '%.64s'"  ,pSuper->cMountOpts		          	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->cMountOpts);
    sprintf(cText,"  UserQuotaInode         : %u"       ,pSuper->dwUserQuotaInode        	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwUserQuotaInode);
    sprintf(cText,"  GroupQuotaInode        : %u"       ,pSuper->dwGroupQuotaInode       	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwGroupQuotaInode);
    sprintf(cText,"  OverheadClusters       : %u"       ,pSuper->dwOverheadClusters      	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwOverheadClusters);
    sprintf(cText,"  EncryptAlgorithms      : %04Xh"    ,*(int*)pSuper->bEncryptAlgorithms	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->bEncryptAlgorithms);
    sprintf(cText,"  LpfInode               : %u"       ,pSuper->dwLpfInode              	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwLpfInode);
    sprintf(cText,"  Checksum               : %08X"     ,pSuper->dwChecksum              	);cTxtWnd.TextInsert(cText,0,1000);ADD_LINE(pPtr,pSuper->dwChecksum);



	memset(ucFarben,10,11);

	cTxtWnd.SetColor(1,ucFarben,256);

	memset(ucFarben   , 0, 25);
	memset(ucFarben+25,11,180);
	ucFarben[25]=12;

	uEnd = cTxtWnd.GetLineCount();

	for(uPos=3;uPos<uEnd;uPos++)
		{
		pLine = cTxtWnd.GetLineText(uPos);

		if(pLine)
			{
			uVal = strchar(pLine,'\xA0');
			if(pLine[uVal]=='\xA0')
				{
				uVal++;
				memset(ucFarben+uVal,(pLine[uVal]=='O')? 15:14,8);
				cTxtWnd.SetColor(uPos,ucFarben,256);
				memset(ucFarben+uVal,11,8);

				continue;
				}
			}


		cTxtWnd.SetColor(uPos,ucFarben,256);
		}



}

